/*
MySQL Data Transfer
Source Host: localhost
Source Database: holodb
Target Host: localhost
Target Database: holodb
Date: 12-1-2008 21:40:16
*/

SET FOREIGN_KEY_CHECKS=0;
-- ----------------------------
-- Table structure for bans
-- ----------------------------
CREATE TABLE `bans` (
  `name` varchar(30) collate latin1_general_ci default NULL,
  `ipaddress` varchar(100) collate latin1_general_ci default NULL,
  `length` varchar(50) collate latin1_general_ci default NULL,
  `desc` text collate latin1_general_ci
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for catalogue
-- ----------------------------
CREATE TABLE `catalogue` (
  `tab` varchar(100) collate latin1_general_ci NOT NULL,
  `content` text collate latin1_general_ci,
  PRIMARY KEY  (`tab`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for furniture
-- ----------------------------
CREATE TABLE `furniture` (
  `id` int(10) NOT NULL,
  `name` varchar(50) collate latin1_general_ci default NULL,
  `pos` varchar(20) collate latin1_general_ci default NULL,
  `rot` tinyint(1) default NULL,
  `height` varchar(4) collate latin1_general_ci default NULL,
  `ftype` varchar(7) collate latin1_general_ci default NULL,
  `colour` varchar(75) collate latin1_general_ci default NULL,
  `var` text collate latin1_general_ci,
  `top` varchar(4) collate latin1_general_ci default NULL,
  `room` int(10) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for furniture_template
-- ----------------------------
CREATE TABLE `furniture_template` (
  `name_catalogue` varchar(100) NOT NULL,
  `name_client` varchar(100) default NULL,
  `colour` varchar(75) default NULL,
  `ftype` varchar(10) default NULL,
  `var` varchar(7) default NULL,
  `top` varchar(4) default NULL,
  PRIMARY KEY  (`name_catalogue`),
  KEY `buyid` (`name_catalogue`(4))
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

-- ----------------------------
-- Table structure for guestroom_modeldata
-- ----------------------------
CREATE TABLE `guestroom_modeldata` (
  `model` char(1) collate latin1_general_ci NOT NULL,
  `door` varchar(50) collate latin1_general_ci default NULL,
  `static` text collate latin1_general_ci,
  `mep` text collate latin1_general_ci,
  PRIMARY KEY  (`model`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for guestrooms
-- ----------------------------
CREATE TABLE `guestrooms` (
  `id` int(10) NOT NULL,
  `name` varchar(30) collate latin1_general_ci default NULL,
  `descr` varchar(150) collate latin1_general_ci default NULL,
  `owner` varchar(35) collate latin1_general_ci default NULL,
  `model` char(1) collate latin1_general_ci default NULL,
  `category` smallint(2) default '0',
  `decor` varchar(6) collate latin1_general_ci default NULL,
  `state` tinyint(1) default NULL,
  `password` varchar(15) collate latin1_general_ci default NULL,
  `roomrights` text collate latin1_general_ci,
  `superuser` tinyint(1) default NULL,
  `showname` tinyint(1) default NULL,
  `maxin` tinyint(2) default NULL,
  `incnt` tinyint(2) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for messenger
-- ----------------------------
CREATE TABLE `messenger` (
  `name` varchar(30) collate latin1_general_ci NOT NULL,
  `friends` text collate latin1_general_ci,
  `requests` text collate latin1_general_ci,
  `mcount` smallint(3) default NULL,
  `mdat` text collate latin1_general_ci,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for ranks
-- ----------------------------
CREATE TABLE `ranks` (
  `rank` tinyint(1) NOT NULL,
  `fuserights` text collate latin1_general_ci,
  `ignoreFilter` tinyint(1) default NULL,
  `receiveCFH` tinyint(1) default NULL,
  `enterAllRooms` tinyint(1) default NULL,
  `seeAllOwners` tinyint(1) default NULL,
  `adminCatalogue` tinyint(1) default NULL,
  `staffFloor` tinyint(1) default NULL,
  `rightsEverywhere` tinyint(4) default NULL,
  PRIMARY KEY  (`rank`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for roomvotes
-- ----------------------------
CREATE TABLE `roomvotes` (
  `id` int(11) NOT NULL default '0',
  `score` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for sso
-- ----------------------------
CREATE TABLE `sso` (
  `name` varchar(50) collate latin1_general_ci NOT NULL,
  `ticket` text collate latin1_general_ci,
  `ipaddress` varchar(150) collate latin1_general_ci default NULL,
  PRIMARY KEY  (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for system
-- ----------------------------
CREATE TABLE `system` (
  `users` int(10) default NULL,
  `guestrooms` int(10) default NULL,
  `furnitures` int(10) default NULL,
  `onlinecount` tinyint(3) default NULL,
  `filterwords` text collate latin1_general_ci,
  `filtercensor` varchar(10) collate latin1_general_ci default NULL,
  `filterwords_names` text collate latin1_general_ci,
  `furniture_index` text collate latin1_general_ci,
  `catalogue_index` text collate latin1_general_ci,
  `catalogue_index_admin` text collate latin1_general_ci,
  `welcome_message` text collate latin1_general_ci
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for users
-- ----------------------------
CREATE TABLE `users` (
  `id` int(10) default NULL,
  `name` varchar(50) collate latin1_general_ci default NULL,
  `password` varchar(100) collate latin1_general_ci default NULL,
  `rank` tinyint(1) default NULL,
  `email` varchar(100) collate latin1_general_ci default NULL,
  `birth` varchar(255) collate latin1_general_ci default NULL,
  `hbirth` varchar(255) collate latin1_general_ci default NULL,
  `figure` varchar(150) collate latin1_general_ci default NULL,
  `sex` varchar(5) collate latin1_general_ci default NULL,
  `mission` varchar(50) collate latin1_general_ci default NULL,
  `consolemission` varchar(50) collate latin1_general_ci default NULL,
  `credits` int(7) default NULL,
  `tickets` smallint(5) default NULL,
  `hand` text collate latin1_general_ci,
  `badges` text collate latin1_general_ci,
  `club` varchar(50) collate latin1_general_ci default NULL,
  `lastvisit` varchar(50) collate latin1_general_ci default NULL,
  `swimsuit` varchar(50) collate latin1_general_ci default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Table structure for vouchers
-- ----------------------------
CREATE TABLE `vouchers` (
  `voucher` varchar(20) collate latin1_general_ci default NULL,
  `credits` int(5) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1 COLLATE=latin1_general_ci;

-- ----------------------------
-- Records 
-- ----------------------------
INSERT INTO `catalogue` VALUES ('Frontpage', 'i:Frontpage\rn:Frontpage\rl:ctlg_frontpage2\rs:Need some Funky Furni for your Habbo room?\rh:Need some Furni for your Habbo room?  Well, you’re in the right place!  This Catalogue is packed FULL of funky Furni, just click the tabs on the right to browse.<br><br>We regularly add and remove Furni, so check back regularly for new items.<br><br>\rg:catal_fp_header\rw:Quis autem vel eum iure reprehenderit qui in ea voluptate velit esse quam nihil molestiae consequatur, vel illum qui dolorem eum fugiat quo voluptas nulla pariatur?\rt1:You need Habbo Coins to buy Furni for your room, click the Purse at the bottom of your screen for more information about Credits.\re:catal_fp_pic4,catal_fp_pic5,');
INSERT INTO `catalogue` VALUES ('Rollers', 'i:Rollers\rn:Rollers\rl:ctlg_layout2\rs:You can fit 35 Rollers in a Guest Room!\rh:Move your imagination, while you move your Habbo!  Perfect for mazes, games, for keeping your queue moving or making your pet go round in circles for hours.  Available in multi-packs – the more you buy the cheaper the Roller!\rg:catalog_roller_headline1\rw:Click on a Roller to see more information!\re:\rp:Red Habbo Roller	The power of movement	25	2: 5 Red Habbo Rollers in a convenient Pack	d				a0 deal105		1	queue_tile1*2	5	#ffffff,#FF3333,#ffffff,#ffffff\rp:Red Habbo Roller	The power of movement	15	2: 3 Red Habbo Rollers in a convenient Pack	d				a0 deal104		1	queue_tile1*2	3	#ffffff,#FF3333,#ffffff,#ffffff\rp:Red Habbo Roller	The power of movement	7		s	queue_tile1*2	0	1,1	a4 queue	#ffffff,#FF3333,#ffffff,#ffffff\rp:Blue Habbo Roller	The power of movement	25	2: 5 Blue Habbo Rollers in a convenient Pack	d				a0 deal107		1	queue_tile1*6	5	#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Blue Habbo Roller	The power of movement	15	2: 3 Blue Habbo Rollers in a convenient Pack	d				a0 deal106		1	queue_tile1*6	3	#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Blue Habbo Roller	The power of movement	7		s	queue_tile1*6	0	1,1	a8 queue	#ffffff,#A2E8FA,#ffffff,#ffffff\rp:Green Habbo Roller	The power of movement	25	2: 5 Green Habbo Rollers in a convenient Pack	d				a0 deal115		1	queue_tile1*9	5	#ffffff,#9AFF60,#ffffff,#ffffff\rp:Green Habbo Roller	The power of movement	15	2: 3 Green Habbo Rollers in a convenient Pack	d				a0 deal114		1	queue_tile1*9	3	#ffffff,#9AFF60,#ffffff,#ffffff\rp:Green Habbo Roller	The power of movement	7		s	queue_tile1*9	0	1,1	a11 queue	#ffffff,#9AFF60,#ffffff,#ffffff\rp:Navy Habbo Roller	The power of movement	25	2: 5 Navy Habbo Rollers in a convenient Pack	d				a0 deal119		1	queue_tile1*8	5	#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Navy Habbo Roller	The power of movement	15	2: 3 Navy Habbo Rollers in a convenient Pack	d				a0 deal118		1	queue_tile1*8	3	#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Navy Habbo Roller	The power of movement	7		s	queue_tile1*8	0	1,1	a10 queue	#ffffff,#1E8AA5,#ffffff,#ffffff\rp:Purple Habbo Roller	The power of movement	25	2: 5 Purple Habbo Rollers in a convenient Pack	d				a0 deal109		1	queue_tile1*7	5	#ffffff,#FC5AFF,#ffffff,#ffffff\rp:Purple Habbo Roller	The power of movement	15	2: 3 Purple Habbo Rollers in a convenient Pack	d				a0 deal108		1	queue_tile1*7	3	#ffffff,#FC5AFF,#ffffff,#ffffff\rp:Purple Habbo Roller	The power of movement	7		s	queue_tile1*7	0	1,1	a9 queue	#ffffff,#FC5AFF,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('Rare', 'i:Rare\rn:Rars\rl:ctlg_productpage1\rs:\rh:Habbowheels in the Catalogue!<br>Go get yours now!:\rg:catalog_rares_headline1\rt1:Rare txt\rw:\re:\rp:Habbowheel	Give it a spin!	12		i	habbowheel			a0 habbowheel	0,0,0	\r');
INSERT INTO `catalogue` VALUES ('Spaces', 'i:Spaces\rn:Spaces\rl:ctlg_spaces\rt1:Wall\rt2:Floor\rt3:Pattern\rg:catalog_spaces_headline1\rt4:Colour\rt5:Pattern\rt6:Colour\rt7:Preview\rh:Are your walls looking a little grey?  What you need is a splash of paint and this is the place to get it!  <br><br>A splash of colour on the walls and a nice carpet can make all the difference. Use our virtual room below to test out the combinations before you buy. \re:\rp:floor	Floor	2		i	floor			2 l	\rp:wallpaper	wallpaper	2		i	wallpaper 1			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 2			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 3			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 4			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 5			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 6			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 7			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 8			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 9			2 t	\rp:wallpaper	wallpaper	2		i	wallpaper 10			2 t	\rp:wallpaper	wallpaper	5		i	wallpaper 11			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 12			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 13			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 14			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 15			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 16			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 17			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 18			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 19			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 20			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 21			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 22			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 23			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 24			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 25			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 26			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 27			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 28			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 29			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 30			5 t	\rp:wallpaper	wallpaper	5		i	wallpaper 31			5 t	');
INSERT INTO `catalogue` VALUES ('Habbo Exchange', 'i:Habbo Exchange\rn:Habbo Exchange\rl:ctlg_layout2\rg:catalog_bank_headline1\rw:Click on the item you want for more information.\rs:Refundable goods!\rh:The Habbo Exchange is where you can convert your Habbo Credits into a tradable currency. You can use this tradable currency to exchange Habbo Credits for Furni! \re:catalog_bank_teaser,\rp:Golden coin	Worth 10 Credits	10		s	CF_10_coin_gold	0	1,1	A0 CF_10_coin_gold	0,0,0\rp:Silver Coin	Worth 5 Credits	5		s	CF_5_coin_silver	0	1,1	A0 CF_5_coin_silver	0,0,0\rp:Bronze Coin	Worth 1 Credit	1		s	CF_1_coin_bronze	0	1,1	A0 CF_1_coin_bronze	0,0,0\rp:Sack of Credits	Worth 20 Credits	20		s	CF_20_moneybag	0	1,1	A0 CF_20_moneybag	0,0,0\rp:Gold Bar	Worth 50 Credits	50		s	CF_50_goldbar	0	1,1	A0 CF_50_goldbar	0,0,0');
INSERT INTO `catalogue` VALUES ('Club Furni', 'i:Club Furni\rn:Club Furni\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_club_headline1\rh:Welcome to the club furni page. Here you can buy any club furni for just 25 credits!\rw:\re:catalog_presents_teaser2,\rp:Club sofa	Club sofa	25		s	club_sofa	0	2,1	3 club_sofa	0,0,0\rp:HC chair	Aqua chair	3		s	chair_plasto*14	0	1,1	A1 aqua_chair	#ffffff,#3CB4F0,#ffffff,#3CB4F0\rp:HC table	Aqua table	3		s	table_plasto_4leg*14	0	2,2	A1 aqua_table	#ffffff,#3CB4F0,#ffffff,#3CB4F0\rp:Mochamaster	Wake up and smell it!	25		s	mocchamaster	0	1,1	3 mocchamaster	0,0,0\rp:Dicemaster	Click and roll!	25		s	edicehc	0	1,1	3 edicehc	0,0,0\rp:Tubmaster	Time for a soak	25		s	hcamme	0	1,2	3 hcamme	0,0,0\rp:Imperial Teleport	Lets go over tzar!	25		s	doorD	0	1,1	3 ovi4	0,0,0\rp:Throne Sofa	For royal bottoms...	25		s	hcsohva	0	2,1	3 hcsohva	0,0,0\rp:Oil Lamp	Be enlightened	25		s	hc_lmp	0	1,1	3 hc_lmp	0,0,0\rp:Nordic Table	Perfect for banquets	25		s	hc_tbl	0	1,3	3 hc_tbl	0,0,0\rp:Majestic Chair	Royal comfort	25		s	hc_chr	0	1,1	3 hc_chr	0,0,0\rp:Study Desk	For Habbo scholars	25		s	hc_dsk	0	1,2	3 hc_dsk	0,0,0\r\rp:Drinks Trolley	For swanky dinners only	25		s	hc_trll	0	1,2	25 hctrolly	0,0,0\r\rp:Persian Carpet	Ultimate craftsmanship	25		s	hc_crpt	0	3,5	25 hc_crpt	0,0,0\rp:Victorian Street Light	Somber and atmospheric	25		s	hc_lmpst	0	1,1	25 hclamp	0,0,0\rp:Antique Drapery	Topnotch privacy protection	25		s	hc_crtn	0	2,1	25 hcertain	0,0,0\rp:Mega TV Set	Forget plasma, go HC!	25		s	hc_tv	0	2,1	3 hctv	0,0,0\rp:Electric Butler	Your personal caretaker	25		s	hc_btlr	0	1,1	25 hcbutler	0,0,0\rp:Medieval Bookcase	For the scholarly ones	25		s	hc_bkshlf	0	1,4	50 hcbook	0,0,0\rp:X-Ray Divider	Believe it or not!	25		s	hc_rntgn	0	2,1	25 hcscan	0,0,0\r\r\rp:Weird Science Machine	By and for mad inventors	25		s	hc_machine	0	1,3	25 hcmachine	0,0,0\r\rp:Heavy Duty Fireplace	Pixel-powered for maximum heating	25		s	hc_frplc	0	1,3	25 hcfire	0,0,0\rp:The Grammophon	Very old skool scratchnspin	25		s	hc_djset	0	3,1	25 hcmusic	0,0,0\rp:Retro Wall Lamp	Tres chic!	25		i	hc_wall_lamp			a0 hc_wall_lamp');
INSERT INTO `catalogue` VALUES ('Club Furni 2', 'i:Club Furni 2\rn:Club Furni 2\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_club_headline1\rh:Welcome to the club furni page. Here you can buy any club furni for just a small ammount of credits!\rw:\re:catalog_presents_teaser2,\rp:Habbo Club Trolly	The life of luxery	25		s	hc_trll	0	1,2	25 hctrolly	0,0,0\rp:Habbo Club Lamp	Light up the Room	25		s	hc_lmpst	0	1,1	25 hclamp	0,0,0\rp:Habbo Club Curtain	Velvet Certain	25		s	hc_crtn	0	2,1	25 hcertain	0,0,0\rp:Habbo Club Television	Widescreen with High Definition	50		s	hc_tv	0	2,1	3 hctv	0,0,0\rp:Habbo Club Butler	At your Service	25		s	hc_btlr	0	1,1	25 hcbutler	0,0,0\rp:Habbo Club Bookshelf	Luxery at a Price	50		s	hc_bkshlf	0	1,4	50 hcbook	0,0,0\rp:Habbo Club Xray Machine	Radaition Alert	25		s	hc_rntgn	0	2,1	25 hcscan	0,0,0\r\r\rp:Habbo Club Control Panel	Press some switches	25		s	hc_machine	0	1,3	25 hcmachine	0,0,0\r\rp:Habbo Club Fireplace	Warmth and Light	25		s	hc_frplc	0	1,3	25 hcfire	0,0,0\rp:HabboClub DJ Set	Beats up ze music	25		s	hc_djset	0	3,1	25 hcmusic	0,0,0');
INSERT INTO `catalogue` VALUES ('Teleporters', 'i:Teleporters\rn:Teleporters\rl:ctlg_productpage3\rs:Teleport!\rh:Beam your Habbo from one room to another with one of our cunningly disguised, space age teleports. Now you can link any two rooms together! Teleports are sold in pairs, so if you trade for them, check youre getting a linked pair.\rg:catalog_doors_headline1\rw:Select an item by clicking one of the icons on the left.\re:catalog_door_a,catalog_door_c,catalog_door_b,\rp:Telephone Box	Dr Who?	5		s	door	0	1,1	a2 ovi	\rp:Portaloo	In a hurry?	4		s	doorC	0	1,1	a2 ovi3	\rp:Wardrobe	Narnia this way!	3		s	doorB	0	1,1	a2 ovi2	');
INSERT INTO `catalogue` VALUES ('Pets', 'i:Pets\rn:Pets\rl:ctlg_pets\rs:\rt2:\ru:Pets2\rw:Find your own pet!\rg:catalog_pet_headline1\rh:Fluff, scales and whiskers, meows, snaps and woofs!  Anyone can have a pet on Habbo!  Select your new pet from our ever changing selection, just click to page two then click back, to see more pets!\rt1:Give name:\re:catalog_pets_teaser1,\rp:Basket	Night, night	20		s	nest	0	1,1	a0 pet2	0,0,0\rp:Basket	Night, night	20		s	nest	0	1,1	a0 pet0	0,0,0\rp:Basket	Night, night	20		s	nest	0	1,1	a0 pet1	0,0,0');
INSERT INTO `catalogue` VALUES ('Pet Accessories', 'i:Pet Accessories\rn:Pet Accessories\rl:ctlg_layout2\rs:Youll have to share it!\rh:Youll need to take care of your pet to keep it happy and healthy. This section of the Catalogue has EVERYTHING you’ll need to satisfy your pet’s needs.  PLEASE NOTE:  No fish were harmed in the creating of this section!\rg:catalog_pet_headline2\rw:Click on the item you want for more information.\re:ctlg_pet_teaser1,p:Doggy Bones	Natural nutrition for the barking one	2		d				deal97		1	petfood1	6	0,0\rp:Sardines	Fresh catch of the day	2		d				deal98		1	petfood2	6	0\r\r\rp:Cabbage	Health food for pets	2		d				deal99		1	petfood3	6	0,0,0\r\r\rp:T-Bones	For the croc!	2		d				deal96		1	petfood4	6	0,0\rp:T-Bones	For the croc!	1		s	petfood4	2	1,1	A0 petfood4	0,0\rp:Doggy Bones	Natural nutrition for the barking one	1		s	petfood1	2	1,1	A0 petfood1	0,0\rp:Sardines	Fresh catch of the day	1		s	petfood2	2	1,1	A0 petfood2	0\rp:Cabbage	Health food for pets	1		s	petfood3	2	1,1	A0 petfood3	0,0,0\rp:Blue Water Bowl	Aqua unlimited	2		s	waterbowl*4	2	1,1	A0 waterbowlblue	#0099ff,#ffffff,#ffffff\rp:Brown Water Bowl	Aqua unlimited	2		s	waterbowl*5	2	1,1	A0 waterbowlbrown	#bf7f00,#ffffff,#ffffff\rp:Green Water Bowl	Aqua unlimited	2		s	waterbowl*2	2	1,1	A0 waterbowlgreen	#3fff3f,#ffffff,#ffffff\rp:Red Water Bowl	Aqua unlimited	2		s	waterbowl*1	2	1,1	A0 waterbowlred	#ff3f3f,#ffffff,#ffffff\rp:Yellow Water Bowl	Aqua unlimited	2		s	waterbowl*3	2	1,1	A0 waterbowlyellow	#ffff00,#ffffff,#ffffff\rp:Chocolate Mouse	For gourmet kittens	1		s	goodie2	2	1,1	A0 petgoodie2	0\rp:Marzipan Man	Crunchy Dog Treat	1		s	goodie1	2	1,1	A0 petgoodie1a	#ff4cbf,#ffffff\rp:Marzipan Man	Crunchy Dog Treat	1		s	goodie1*1	2	1,1	A0 petgoodie1b	#3fffff,#ffffff\rp:Marzipan Man	Crunchy Dog Treat	1		s	goodie1*2	2	1,1	A0 petgoodie1c	#ffbf00,#ffffff\rp:Rubber Ball	its bouncy-tastic	2		s	toy1	2	1,1	A0 pettoy1	#ff0000,#ffff00,#ffffff,#ffffff\rp:Rubber Ball	its bouncy-tastic	2		s	toy1*1	2	1,1	A0 pettoy2	#ff7f00,#007f00,#ffffff,#ffffff\rp:Rubber Ball	its bouncy-tastic	2		s	toy1*2	2	1,1	A0 pettoy3	#003f7f,#ff00bf,#ffffff,#ffffff\rp:Rubber Ball	its bouncy-tastic	2		s	toy1*3	2	1,1	A0 pettoy4	#bf1900,#00bfbf,#ffffff,#ffffff\rp:Rubber Ball	its bouncy-tastic	2		s	toy1*4	2	1,1	A0 pettoy5	#000000,#ffffff,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('Area', 'i:Area\rn:Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rw:Click on the item you want for more information.\rg:catalog_area_headline1\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\re:catalog_area_teaser1,\rp:Double Bed	Plain and simple x2	3		s	bed_silo_two	0	2,3	A1 S2S	0,0,0\rp:Single Bed	Plain and simple	3		s	bed_silo_one	0	1,3	A1 S1S	0,0,0\rp:Bookcase	For nic naks and art deco books	3		s	shelves_silo	0	2,1	A1 KHS	0,0,0\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 SHS	0,0,0,0,#A2C6C8,#A2C6C8\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 STS	0,0,#A2C6C8,#A2C6C8,0\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 PPS	0,#A2C6C8,0,#A2C6C8\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 silovi	0,0,0,#A2C6C8\rp:Screen	Stylish sectioning	3		s	divider_silo2	0	2,1	a1 sildiv	0,0,0\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 silkp	0,#A2C6C8,0,#A2C6C8\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 TUS	0,0,#A2C6C8,#A2C6C8,0\rp:Safe Minibar	Totally shatter-proof!	3		s	safe_silo	0	1,1	3 safe_silo	0,#A2C6C8,0\rp:Bar Stool	Practical and convenient	3		s	barchair_silo	0	1,1	3 barchair_silo	0,#A2C6C8,0\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 PYS	0,#8FAEAF\r');
INSERT INTO `catalogue` VALUES ('Gothic', 'i:Gothic\rn:Gothic\rl:ctlg_layout2\rg:catalog_gothic_headline1\rw:Click on the item you want for more information.\rs:\rh:The Gothic section is full of medieval looking Furni. Check back for additions to this section as there are still some unreleased items to come!\re:catalog_gothic_teaser1,\rp:Red Gothic Chair	The head of the table	10		s	gothic_chair*3	0	1,1	a3 gothicchair	#ffffff,#dd0000,#ffffff,#dd0000\rp:Red Gothic Sofa	Not great for hiding behind	7		s	gothic_sofa*3	0	2,1	a3 gothicsofa	#ffffff,#dd0000,#ffffff,#ffffff,#dd0000,#ffffff\rp:Red Gothic Stool	Be calm. Be seated	5		s	gothic_stool*3	0	1,1	a3 gothicstool	#ffffff,#dd0000,#ffffff\rp:Cobbled Path	The route less travelled	5		s	gothic_carpet	0	2,4	a3 gothic_carpet1	0,0,0\rp:Dungeon Floor	What lies beneath?	5		s	gothic_carpet2	0	2,4	a3 gothic_carpet2	0,0,0\rp:Gothic Table	A table with two heads	15		s	goth_table	0	1,5	a0 goth_table	0,0,0\rp:Gothic Railing	Keep out!	8		s	gothrailing	0	2,1	a0 gothrailing	0,0,0\rp:Gothic Torch	Keeping dungeons light	10		i	torch			a0 torch	\rp:Gothic Fountain	The dark side of Habbo	10		i	gothicfountain			a0 gothicfountain	\rp:Gothic Candleabra	Through darkness came light	10		s	gothiccandelabra	0	1,1	a0 gothiccandelabra	0,0,0\rp:Gothic Portcullis	Dont get caught beneath!	10		s	gothgate	0	2,1	a0 gothgate	0,0,0\rp:Industrial Turbine	Powerful and resilient	10		i	industrialfan			a0 industrialfan	\r');
INSERT INTO `catalogue` VALUES ('Grunge', 'i:Grunge\rn:Grunge\rl:ctlg_layout2\rg:catalog_gru_headline1\rw:\rs:\rh:Introducing the Grunge Range. Alternative Habbos with alternative style or rebellious students with a point to prove. The Grunge range will get your bedroom looking just the way you like it - organised, neat and tidy!\re:catalog_gru_teaser,\rp:Grunge Chair	Alternative chair for alternative people	4		s	grunge_chair	0	1,1	Grunge Chair	\rp:Grunge Mattress	Beats sleeping on the floor!	3		s	grunge_mattress	0	3,1	Grunge Mattress	\rp:Radiator	Started cool but now its hot!	3		s	grunge_radiator	0	1,1	Grunge Radiator	\rp:Grunge Bookshelf	Scrap books and photo albums	5		s	grunge_shelf	2	3,1	Grunge Shelf	\rp:Road Sign	Bought legitimately from an M1 cafe.	3		s	grunge_sign	0	1,1	Grunge Sign	\rp:Grunge Table	Students of the round table!	4		s	grunge_table	0	2,2	Grunge Table	\r\n');
INSERT INTO `catalogue` VALUES ('Trax', 'i:Trax\rn:Trax\rl:ctlg_soundmachine\rh:With the Traxmachine you can play musin on Habbo! Just buy a machine and a song from this page and listen!\rg:catalog_djshop_headline1\re:catalog_djshop_teaser1,\rp:Traxmachine Pack	Traxmachine With DJ Fuses Duck Funk	10		d				deal0110		2	sound_machine*1	1	#FFFFFF,#FFFFFF,#828282,#FFFFFF	sound_set_1	1	\rp:DJ Fuses Duck Funk	Music	5		s	sound_set_1	0	1,1	A0 sound_set1	\rp:DJ Fuses Habbo Theme	Music	5		s	sound_set_2	0	1,1	A0 sound_set2	\rp:Snow Storm Theme	Music	5		s	sound_set_3	0	1,1	A0 sound_set3	\rp:Sunset Adventure	Music	5		s	sound_set_4	0	1,1	A0 sound_set4	\rp:Dark Skies	Music	5		s	sound_set_5	0	1,1	A0 sound_set5\rp:Ambiences	Music	5		s	sound_set_6	0	1,1	A0 sound_set6\rp:Furni Sounds	Music	5		s	sound_set_7	0	1,1	A0 sound_set7\rp:Electronica	Music soundeja	5		s	sound_set_8	0	1,1	A0 sound_set8\rp:Mysto Magica	Music	5		s	sound_set_9	0	1,1	A0 sound_set9\rp:Sound Set	null	5		s	sound_set_10	0	1,1	A0 sound_set10\rp:Sound Set	null	5		s	sound_set_11	0	1,1	A0 sound_set11\rp:Sound Set	null	5		s	sound_set_12	0	1,1	A0 sound_set12\rp:Sound Set	null	5		s	sound_set_13	0	1,1	A0 sound_set13\rp:Sound Set	null	5		s	sound_set_14	0	1,1	A0 sound_set14\rp:Sound Set	null	5		s	sound_set_15	0	1,1	A0 sound_set15\rp:Sound Set	null	5		s	sound_set_16	0	1,1	A0 sound_set16\rp:Sound Set	null	5		s	sound_set_17	0	1,1	A0 sound_set17\rp:Sound Set	null	5		s	sound_set_18	0	1,1	A0 sound_set18\rp:Sound Set	null	5		s	sound_set_19	0	1,1	A0 sound_set19\rp:Sound Set	null	5		s	sound_set_20	0	1,1	A0 sound_set20\rp:Sound Set	null	5		s	sound_set_21	0	1,1	A0 sound_set21\rp:Sound Set	null	5		s	sound_set_22	0	1,1	A0 sound_set22\rp:Sound Set	null	5		s	sound_set_23	0	1,1	A0 sound_set23\rp:Sound Set	null	5		s	sound_set_24	0	1,1	A0 sound_set24p:Sound Set	null	5		s	sound_set_25	0	1,1	A0 sound_set25\rp:Sound Set	null	5		s	sound_set_26	0	1,1	A0 sound_set26\rp:Sound Set	null	5		s	sound_set_27	0	1,1	A0 sound_set27\rp:Sound Set	null	5		s	sound_set_28	0	1,1	A0 sound_set28p:Sound Set 29	null	5		s	sound_set_29	0	1,1	A1 sound_set29	0,0,0\rp:Sound Set 30	null	5		s	sound_set_30	0	1,1	A1 sound_set30	0,0,0\rp:Sound Set 31	null	5		s	sound_set_31	0	1,1	A1 sound_set31	0,0,0\rp:Sound Set 32	null	5		s	sound_set_32	0	1,1	A1 sound_set32	0,0,0\rp:Sound Set 33	null	5		s	sound_set_33	0	1,1	A1 sound_set33	0,0,0\rp:Sound Set 34	null	5		s	sound_set_34	0	1,1	A1 sound_set34	0,0,0\rp:Sound Set 35	null	5		s	sound_set_35	0	1,1	A1 sound_set35	0,0,0\rp:Sound Set 36	null	5		s	sound_set_36	0	1,1	A1 sound_set36	0,0,0\rp:Sound Set 36	null	5		s	sound_set_37	0	1,1	A1 sound_set37	0,0,0\rp:Sound Set 36	null	5		s	sound_set_38	0	1,1	A1 sound_set38	0,0,0\rp:Sound Set 36	null	5		s	sound_set_39	0	1,1	A1 sound_set39	0,0,0\rp:Sound Set 36	null	5		s	sound_set_40	0	1,1	A1 sound_set40	0,0,0\rp:Sound Set 36	null	5		s	sound_set_41	0	1,1	A1 sound_set41	0,0,0\rp:Sound Set 36	null	5		s	sound_set_42	0	1,1	A1 sound_set42	0,0,0\rp:Sound Set 36	null	5		s	sound_set_43	0	1,1	A1 sound_set43	0,0,0\rp:Sound Set 36	null	5		s	sound_set_44	0	1,1	A1 sound_set44	0,0,0\r');
INSERT INTO `catalogue` VALUES ('Candy', 'i:Candy\rn:Candy\rl:ctlg_layout2\rs:2: Get off my chair fool!\rh:Candy Furni.\rg:catalog_candy_headline1\rw:Click an item for more details.\re:catalog_candy_teaser1,\rp:Pink Bar/desk	Perfect for work or play	3		s	bardesk_polyfon*5	0	2,1	A5 cbar	#ffffff,#ffffff,#FF9BBD,#FF9BBD\rp:Pink Corner	Tuck it away	3		s	bardeskcorner_polyfon*5	0	1,1	A5 ccbar	#ffffff,#FF9BBD\rp:Pink Gate (lockable)	All bars should have one	6		s	divider_poly3*5	0	1,1	A5 cgate	#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Armchair	Think pink	3		s	sofachair_polyfon_girl	0	1,1	A1 GIRLSTP	#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Two-seater Sofa	Romantic pink for two	4		s	sofa_polyfon_girl	0	2,1	A2 GIRLSHP	#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4\rp:Pink Faux-Fur Bear Rug	Cute	4		s	carpet_polar*1	0	2,3	A2 MURLOVE	#ffbbcf,#ffbbcf,#ffddef\rp:Armchair	Think pink	3		s	bed_polyfon_girl_one	0	1,3	A1 GIRLS1P	#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Double Bed	Snuggle down in princess pink	4		s	bed_polyfon_girl	0	2,3	A2 GIRLS2P	#ffffff,#ffffff,#EE7EA4,#EE7EA4');
INSERT INTO `catalogue` VALUES ('Romantique', 'i:Romantique\rn:Romantique\rl:ctlg_layout2\rs:2: Its my piano!\rw:Click on the item you want for more information.\rg:catalog_romantique_headline1\rh:Exclusive: the new romantique furni line. Only at Habbo!\re:catalog_romantique_teaser1,\rp:Grand Piano	Grand Piano	5		s	grand_piano*1	0	2,2	a0 grand_piano	#fffffff,#ff3366,#ffffff\rp:Romantique Pianochair	Romantique Pianochair	3		s	romantique_pianochair	0	1,1	a0 pianochair	#ffffff,#ff3366,#ffffff\rp:Romantique Divan	Romantique Divan	4		s	romantique_divan*1	0	2,1	a0 romantique_divan	#ffffff,#ffffff,#ffffff,#ff3366\rp:Romantique Divider	Romantique Divider	3		s	romantique_divider*1	0	2,1	a0 romantique_divider	#ff3366,#ff3366,#ffffff,#ffffff\rp:Romantique Tray 1	Romantique Tray 1	3		s	romantique_tray1	0	1,1	a6 romantique_tray1	0,0,0\rp:Romantique Tray 2	Romantique Tray 2	3		s	romantique_tray2	0	1,1	a6 romantique_tray2	0,0,0\rp:Romantique Chair	Romantique Chair	3		s	romantique_chair*1	0	1,1	a6 romantique_chair	#ffffff,#ff3366,#ffffff\rp:Romantique Lamp	Romantique Lamp	3		s	rom_lamp	0	1,1	a6 rom_lamp	0,0,0\rp:Mirror	Mirror	10		i	wallmirror			a0 wallmirror	\rp:Cauldron	Cauldron	5		s	val_cauldron	0	1,1	a0 val_cauldron	0,0,0\rp:Small Table	Small Tabel	3		s	romantique_smalltabl*1	0	1,1	a0 romantique_smalltabl_1	#ffffff,#ff3366,#ffffff\rp:Mirror Table	Mirror Table	5		s	romantique_mirrortabl	0	1,1	a0 romantique_mirrortabl	0,0,0\rp:Romantique Clock	Tick tack..	8		s	romantique_clock	0	1,1	a0 romantique_clock	0,0,0');
INSERT INTO `catalogue` VALUES ('Recycler', 'i:Recycler\rn:Ecotron\rl:ctlg_recycler\rg:catalog_recycler_headline1\re:\r\n');
INSERT INTO `catalogue` VALUES ('Asian', 'i:Asian\rn:Asian\rl:ctlg_layout2\rg:catalog_asian_headline1\rh:Dit pure haandwerk uit de eeuwenoude oosterse pixeltraditie brengt balans in elk Habbointerieur. Jin en Yang vloeien samen met Feng en Shui in een uitgebalanceerde collectie meubi. \rs:\rw:\re:catalog_asian_teaser1,\rp:Drakenscherm	Voor je eigen Grote Muur	8		s	wall_china	0	1,1	a2 wall_china	0,0,0\rp:Hoekstuk Drakenscherm	Stevig en vuurvast	8		s	corner_china	0	1,1	a2 corner_china	0,0,0\rp:Lakwerk boekenkast	Bewaarder van je boekenschat	8		s	china_shelve	0	2,1	a0 chinashelf	0,0,0\rp:Yin Yang tafel	Exotic and classy	5		s	china_table	0	1,1	a2 china_table	0,0,0\rp:Yin Yang stoel	Zitten in evenwicht	5		s	chair_china	0	1,1	a2 chair_china	0,0,0\rp:Kalligrafie	Een kwast, vaste hand en concentratie	3		i	poster 57			poster 57	\rp:Chinese rode knopen	Veel geluk!	5		i	poster 58			poster 58	\rp:Yin Yang bank	Zitten in evenwicht!	10		s	cn_sofa	0	3,1	a0 cn_sofa	0,0,0\rp:Rode lantaarn	Zacht licht voor je Habbo Kamer	15		s	cn_lamp	0	1,1	a0 cn_lamp	0,0,0');
INSERT INTO `catalogue` VALUES ('Japanese', 'i:Japanese\rn:Japanese\rl:ctlg_layout2\rs:1: Brand new furni!\rh:Here you can find the new Japanese furni! Get them now!l\rg:catalog_limited_headline1\rw:Click on the item you want for more information.\re:catalog_limited_teaser1,\rp:Bamboo Forest	Dont get lost	25		s	jp_bamboo	0	2,2	A1 jp_bamboo	0,0,0\rp:Pillow	null	5		s	jp_pillow	0	1,1	A1 jp_pillow	0,0,0\rp:Sushi Bar	null	10		s	jp_irori	0	2,2	A1 jp_irori	0,0,0\rp:Tatami	null	6		s	jp_tatami	0	2,2	A1 jp_tatami	0,0,0\rp:Tatami	null	8		s	jp_tatami2	0	2,4	A1 jp_tatami2	0,0,0\rp:Lantern	null	10		s	jp_lantern	0	1,1	A1 jp_lantern	0,0,0\rp:Drawers	null	6		s	jp_drawer	0	1,1	A1 jp_drawer	0,0,0\rp:Ninjastars	Ouch!	10		i	jp_ninjastars			a0 jp_ninjastars	0,0,0\r\r');
INSERT INTO `catalogue` VALUES ('Habbowood', 'i:Habbowood\rn:Habbowood\rl:ctlg_layout2\rs:1: Light, Camera, Action!\rw:Click on the item you want for more information.\rg:catalog_limited_headline1\rh:DebboProject V4 Betá - Fix\r\re:catalog_limited_teaser1,\rp:Habbowood Chair	null	5		s	habbowood_chair	0	1,1	a0 habbowood_chair	0,0,0\r\rp:Rope Divider	null	5		s	rope_divider	0	2,1	a0 rope_divider	0,0,0\rp:Spotlight	Light, camera, action!	15		s	spotlight	0	1,1	a2 spotlight	0,0,0\rp:Theatre Seat	Its a Theatre Seat	10		s	theatre_seat	0	1,1	a1 theatre_seat	0,0,0\rp:Icecream Machine	null	25		s	rare_icecream_campaign	0	1,1	a1 rare_icecream_campaign	0,0,0\r\rp:Habbowood Mirror	Starts only!	10		i	habw_mirror			a0 habw_mirror	0,0,0\r\r');
INSERT INTO `catalogue` VALUES ('Iced', 'i:Iced\rn:Iced\rl:ctlg_layout2\rs:2: These chairs are so comfy.\rw:Click on the item you want for more information.\rg:catalog_iced_headline1\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 TUN	0,#E2DAAC,#E2DAAC,#E2DAAC\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 PEN	0,0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 PYN	0,#E2DAAC\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 HYN	#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 stn	0,#E2DAAC,#E2DAAC\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 PSN	#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 nordiv	0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 norkp	0,#E2DAAC,0,0,0,0\rp:Iced Auto Shutter	Habbos, roll out!	3		s	divider_nor4	0	2,1	a1 divider_nor4	0,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Iced Angle	Cool cornering for your crib y0!	3		s	divider_nor5	0	1,1	a1 divider_nor5	0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 norovi	0,0,#E2DAAC,#E2DAAC');
INSERT INTO `catalogue` VALUES ('Lodge', 'i:Lodge\rn:Lodge\rl:ctlg_layout2\rs:2: I LOVE this wood Furni!\rh:Introducing the Lodge Collection...  Do you appreciate the beauty of wood?  For that ski lodge effect, or to match that open fire... Lodge is the Furni of choice for Habbos with that no frills approach to decorating.  <br>\rg:catalog_lodge_headline1\rw:Click on the item you want for more information.\re:catalog_lodge_teaser1,\rp:Double Bed	King-sized pine comfort	3		s	bed_armas_two	0	2,3	A2 S2A	0,0,0\rp:Single Bed	Rustic charm for one	3		s	bed_armas_one	0	1,3	A1 S1A	0,0,0\rp:Fireplace	Authentic, real flame fire	4		s	fireplace_armas	0	2,1	A2 TAA	0,0,0\rp:Bardesk	Bar-Style Table - essential for extra guests	3		s	bartable_armas	0	1,3	A1 BTA	\rp:Dining Table	For informal dining	3		s	table_armas	0	2,2	A2 PIA	0,0,0\rp:Bench	To complete the dining set	3		s	bench_armas	0	2,1	A1 PEA	0,0,0\rp:Gate (lockable)	Knock, knock...	6		s	divider_arm3	0	1,1	a2 armovi	0,0,0\rp:Corner plinth	Good solid wood	3		s	divider_arm1	0	1,1	a1 armkp	0,0,0\rp:Room divider	I wooden go there	3		s	divider_arm2	0	2,1	a1 armdiv	0,0,0\rp:Bookcase	For all those fire-side stories	3		s	shelves_armas	0	2,1	A1 KHA	0,0,0\rp:Barrel Minibar	Its a barrel of laughs and a great talking point	4		s	bar_armas	0	1,1	A2 BAA	\rp:Barrel Stool	The ultimate recycled furniture	1		s	bar_chair_armas	0	1,1	A1 BJA	\rp:Table Lamp	Ambient lighting is essential	3		s	lamp_armas	0	1,1	A1 JLA	0,0,0\rp:Lodge candle	Wax lyrical with some old-world charm	3		s	lamp2_armas	0	1,1	a2 kya	0,0,0\rp:Occasional Table	Practical and beautiful	2		s	small_table_armas	0	1,1	A1 PPA	0,0,0\rp:Stool	Rustic charm at its best	1		s	small_chair_armas	0	1,1	A1 JAA	0,0,0');
INSERT INTO `catalogue` VALUES ('Plastic', 'i:Plastic\rn:Plastic\rl:ctlg_plasto\rt2:Select The Colour\rs:New colours!\rt3:Preview\rt1:Choose An Item\rw:Select an item and a colour and buy!\rg:catalog_plasto_headline1\rh:Introducing The Plastic Collection...  Can you feel that 1970s vibe?  Decorate with Plastic and add some colour to your life. Choose a colour that reflect your mood, or just pick your favourite shade.\re:\rp:Chair	Hip plastic furniture	3		s	chair_plasto*16	0	1,1	a1 newplch16	#ffffff,#CC3399,#ffffff,#CC3399\rp:Chair	Hip plastic furniture	3		s	chair_plasto*15	0	1,1	a1 newplch2	#ffffff,#FF97BA,#ffffff,#FF97BA\rp:Chair	Hip plastic furniture	3		s	chair_plasto*5	0	1,1	A1 E3P	#ffffff,#54ca00,#ffffff,#54ca00\rp:Chair	Hip plastic furniture	3		s	chair_plasto	0	1,1	A1 EHP	0,0,0\rp:Chair	Hip plastic furniture	3		s	chair_plasto*8	0	1,1	A1 E7P	#ffffff,#c38d1a,#ffffff,#c38d1a\rp:Chair	Hip plastic furniture	3		s	chair_plasto*7	0	1,1	A1 E6P	#ffffff,#ff6d00,#ffffff,#ff6d00\rp:Chair	Hip plastic furniture	3		s	chair_plasto*1	0	1,1	A1 E1P	#ffffff,#ff1f08,#ffffff,#ff1f08\rp:Chair	Hip plastic furniture	3		s	chair_plasto*4	0	1,1	A1 E8P	#ffffff,#ccddff,#ffffff,#ccddff\rp:Chair	Hip plastic furniture	3		s	chair_plasto*6	0	1,1	A1 E2P	#ffffff,#3444ff,#ffffff,#3444ff\rp:Chair	Hip plastic furniture	3		s	chair_plasto*3	0	1,1	A1 E5P	#ffffff,#ffee00,#ffffff,#ffee00\rp:Chair	Hip plastic furniture	3		s	chair_plasto*2	0	1,1	A1 E4P	#ffffff,#99DCCC,#ffffff,#99DCCc\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_square*15	0	1,1	a1 newplsq2	#ffffff,#FF97BA\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_square*14	0	1,1	a1 newplsq1	#ffffff,#CC3399\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_square*1	0	1,1	A1 B1P	#ffffff,#ff1f08\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*7	0	1,1	A1 B6P	#ffffff,#ff6d00\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_square	0	1,1	A1 BHP	0,0,0\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_square*2	0	1,1	A1 B4P	#ffffff,#99DCCC\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*4	0	1,1	A1 B8P	#ffffff,#ccddff\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*6	0	1,1	A1 B2P	#ffffff,#3444ff\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*3	0	1,1	A1 B5P	#ffffff,#ffee00\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*9	0	1,1	A1 B9P	#ffffff,#533e10\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*5	0	1,1	A1 B3P	#ffffff,#54ca00\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_square*8	0	1,1	A1 B7P	#ffffff,#c38d1a\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_round*15	0	2,2	a1 newplrnd2	#ffffff,#FF97BA\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_round*14	0	2,2	a1 newplrnd1	#ffffff,#CC3399\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*7	0	2,2	A1 C6P	#ffffff,#ff6d00\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*1	0	2,2	A1 C1P	#ffffff,#ff1f08\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*2	0	2,2	A1 C4P	#ffffff,#99DCCC\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_round*4	0	2,2	A1 C8P	#ffffff,#ccddff\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*6	0	2,2	A1 C2P	#ffffff,#3444ff\rp:Round Dining Table	Hip plastic furniture?	3		s	table_plasto_round*3	0	2,2	A1 C5P	#ffffff,#ffee00\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*9	0	2,2	A1 C9P	#ffffff,#533e10\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round	0	2,2	A1 CHP	0,0,0\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*5	0	2,2	A1 C3P	#ffffff,#54ca00\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_round*8	0	2,2	A1 C7P	#ffffff,#c38d1a\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_bigsquare*15	0	2,2	a1 newplbsq2	#ffffff,#FF97BA\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_bigsquare*14	0	2,2	a1 newplbsq1	#ffffff,#CC3399\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*7	0	2,2	A1 D6P	#ffffff,#ff6d00\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*1	0	2,2	A1 D1P	#ffffff,#ff1f08\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*2	0	2,2	A1 D4P	#ffffff,#99DCCC\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare	0	2,2	A1 DHP	0,0,0\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*8	0	2,2	A1 D7P	#ffffff,#c38d1a\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*5	0	2,2	A1 D3P	#ffffff,#54ca00\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*9	0	2,2	A1 D9P	#ffffff,#533e10\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*3	0	2,2	A1 D5P	#ffffff,#ffee00\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*6	0	2,2	A1 D2P	#ffffff,#3444ff\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_bigsquare*4	0	2,2	A1 D8P	#ffffff,#ccddff\rp:Occasional table Table	Hip plastic furniture	3		s	table_plasto_4leg*6	0	2,2	A1 A2P	#ffffff,#3444ff\rp:Square Dining Table	Hip plastic furniture	3		s	table_plasto_4leg*1	0	2,2	A1 A1P	#ffffff,#ff1f08\rp:Round Dining Table	Hip plastic furniture	3		s	table_plasto_4leg*3	0	2,2	A1 A5P	#ffffff,#ffee00\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*9	0	2,2	A1 A9P	#ffffff,#533e10\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg	0	2,2	A1 AHP	0,0,0\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*5	0	2,2	A1 A3P	#ffffff,#54ca00\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*2	0	2,2	A1 A4P	#ffffff,#99DCCC\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*8	0	2,2	A1 A7P	#ffffff,#c38d1a\rp:Occasional table	Hip plastic furniture	3		s	table_plasto_4leg*7	0	2,2	A1 A6P	#ffffff,#ff6d00\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*10	0	2,2	a1 newa8p	#ffffff,#ccddff\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*15	0	2,2	a1 newpl4lg2	#ffffff,#FF97BA\rp:Occasional Table	Hip plastic furniture	3		s	table_plasto_4leg*16	0	2,2	a1 newpltb4lg16	#ffffff,#CC3399\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty	0	1,1	A2 PL1	0,0,0\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*1	0	1,1	A2 PL2	#ffffff,#8EB5D1,#ffffff,#8EB5D1\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*2	0	1,1	A2 PL3	#ffffff,#ff9900,#ffffff,#ff9900\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*3	0	1,1	A2 PL4	#ffffff,#ff2200,#ffffff,#ff2200\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*4	0	1,1	A2 PL5	#ffffff,#00cc00,#ffffff,#00cc00\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*4	0	1,1	A2 navypod	#ffffff,#0033CC,#ffffff,#0033CC\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*4	0	1,1	A2 blackpod	#ffffff,#333333,#ffffff,#333333\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*7	0	1,1	a1 newplty1	#ffffff,#99DCCc,#ffffff,#99DCCc\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*8	0	1,1	a1 newplty2	#ffffff,#c38d1a,#ffffff,#c38d1a\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*9	0	1,1	a1 newplty3	#ffffff,#533e10,#ffffff,#533e10\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*10	0	1,1	a1 newplty4	#ffffff,#CC3399,#ffffff,#CC3399\rp:Plastic Pod Chair	Hip plastic furniture	3		s	chair_plasty*11	0	1,1	a1 newplty5	#ffffff,#FF97BA,#ffffff,#FF97BA\rp:Chair	Hip plastic furniture	2	January Sale - Save 33%	s	chair_plasto*9	0	1,1	A1 E9P	#ffffff,#533e10,#ffffff,#533e10');
INSERT INTO `catalogue` VALUES ('Pura', 'i:Pura\rn:Pura\rl:ctlg_layout2\rs:\rh:Introducing the Pura Collection...  This collection breathes fresh, clean air and cool tranquillity. Use it to create a special haven away from the hullabaloo of life outside the Hotel.\rg:catalog_pura_headline1\rw:Klik op een artikel voor meer details.\re:catalog_pura_teaser1,\rp:Plain Single Bed	All you need for a good night	3		s	bed_budgetb_one	0	2,3	A1 S1BVALKO	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:Plain Double Bed	Sweet dreams for two	3		s	bed_budgetb	0	2,3	A1 S2BVALKO	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:Aquamarine Single Bed	All you need for a good night	3		s	bed_budget_one	0	2,3	A1 S1B	#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2\rp:Aquamarine Double Bed	Sweet dreams for two	3		s	bed_budget	0	2,3	A1 S2B	#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2\rp:Pura Shelves	Pura Series 404 shelves	3		s	shelves_basic	0	2,1	a2 bookcase	0,0,0\rp:A Pura Minibar	A Pura series 300 minibar	4		s	bar_basic	0	1,1	A2 baba	\rp:Pura Refridgerator	Keep cool with a chilled snack or drink	6		s	fridge	0	1,1	A2 FDG	0,0,0\rp:Pura Lamp	Switch on the atmosphere with this sophisticated light	3		s	lamp_basic	0	1,1	A1 BLMP	0,0,0\rp:Aqua Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_aqua	#FFFFFF,#ABD0D2,#FFFFFF\r\rp:Red Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_red	#FFFFFF,#E14218,#FFFFFF\rp:Yellow Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_yellow	#FFFFFF,#FFD837,#FFFFFF\rp:Green Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_green	#FFFFFF,#92D13D,#FFFFFF\rp:Blue Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_blue	#FFFFFF,#5EAAF8,#FFFFFF\rp:Beige Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_beige	#FFFFFF,#F7EBBC,#FFFFFF\rp:White Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_white	#FFFFFF,#FFFFFF,#FFFFFF\rp:Black Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_black	#FFFFFF,#525252,#FFFFFF\rp:Pink Retro Chair	Sitback and relax	5		s	chair_basic*1	0	1,1	DEV pura_chair_pink	#FFFFFF,#FF99BC,#FFFFFF\r\rp:Aqua Pura module 1	Endless fun!	2		s	pura_mdl1*1	0	1,1	DEV pura_mdl11	#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF\rp:Aqua Pura module 2	Endless fun!	2		s	pura_mdl2*1	0	1,1	DEV pura_mdl21	#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF\rp:Aqua Pura module 3	Endless fun!	2		s	pura_mdl3*1	0	1,1	DEV pura_mdl31	#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF\rp:Aqua Pura module 4	Endless fun!	2		s	pura_mdl4*1	0	1,1	DEV pura_mdl41	#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2\rp:Aqua Pura module 5	Endless fun!	1		s	pura_mdl5*1	0	1,1	DEV pura_mdl51	#FFFFFF,#ABD0D2,#FFFFFF\rp:Red Pura module 1	Endless fun!	2		s	pura_mdl1*9	0	1,1	DEV pura_mdl19	#FFFFFF,#E14218,#E14218,#FFFFFF\rp:Red Pura module 2	Endless fun!	2		s	pura_mdl2*9	0	1,1	DEV pura_mdl29	#FFFFFF,#E14218,#E14218,#FFFFFF\rp:Red Pura module 3	Endless fun!	2		s	pura_mdl3*9	0	1,1	DEV pura_mdl39	#FFFFFF,#E14218,#E14218,#FFFFFF\rp:Red Pura module 4	Endless fun!	2		s	pura_mdl4*9	0	1,1	DEV pura_mdl49	#FFFFFF,#E14218,#E14218,#E14218\rp:Red Pura module 5	Endless fun!	1		s	pura_mdl5*9	0	1,1	DEV pura_mdl59	#FFFFFF,#E14218,#E14218,#FFFFFF\rp:Yellow Pura module 1	Endless fun!	2		s	pura_mdl1*8	0	1,1	DEV pura_mdl18	#FFFFFF,#FFD837,#FFD837,#FFFFFF\rp:Yellow Pura module 2	Endless fun!	2		s	pura_mdl2*8	0	1,1	DEV pura_mdl28	#FFFFFF,#FFD837,#FFD837,#FFFFFF\rp:Yellow Pura module 3	Endless fun!	2		s	pura_mdl3*8	0	1,1	DEV pura_mdl38	#FFFFFF,#FFD837,#FFD837,#FFFFFF\rp:Yellow Pura module 4	Endless fun!	2		s	pura_mdl4*8	0	1,1	DEV pura_mdl48	#FFFFFF,#FFD837,#FFD837,#FFD837\rp:Yellow Pura module 5	Endless fun!	1		s	pura_mdl5*8	0	1,1	DEV pura_mdl58	#FFFFFF,#FFD837,#FFD837,#FFFFFF\rp:Green Pura module 1	Endless fun!	2		s	pura_mdl1*7	0	1,1	DEV pura_mdl17	#FFFFFF,#92D13D,#92D13D,#FFFFFF\rp:Green Pura module 2	Endless fun!	2		s	pura_mdl2*7	0	1,1	DEV pura_mdl27	#FFFFFF,#92D13D,#92D13D,#FFFFFF\rp:Green Pura module 3	Endless fun!	2		s	pura_mdl3*7	0	1,1	DEV pura_mdl37	#FFFFFF,#92D13D,#92D13D,#FFFFFF\rp:Green Pura module 4	Endless fun!	2		s	pura_mdl4*7	0	1,1	DEV pura_mdl47	#FFFFFF,#92D13D,#92D13D,#92D13D\rp:Green Pura module 5	Endless fun!	1		s	pura_mdl5*7	0	1,1	DEV pura_mdl57	#FFFFFF,#92D13D,#92D13D,#FFFFFF\rp:Blue Pura module 1	Endless fun!	2		s	pura_mdl1*6	0	1,1	DEV pura_mdl16	#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF\rp:Blue Pura module 2	Endless fun!	2		s	pura_mdl2*6	0	1,1	DEV pura_mdl26	#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF\rp:Blue Pura module 3	Endless fun!	2		s	pura_mdl3*6	0	1,1	DEV pura_mdl36	#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF\rp:Blue Pura module 4	Endless fun!	2		s	pura_mdl4*6	0	1,1	DEV pura_mdl46	#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8\rp:Blue Pura module 5	Endless fun!	1		s	pura_mdl5*6	0	1,1	DEV pura_mdl56	#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF\rp:Beige Pura module 1	Endless fun!	2		s	pura_mdl1*5	0	1,1	DEV pura_mdl15	#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF\rp:Beige Pura module 2	Endless fun!	2		s	pura_mdl2*5	0	1,1	DEV pura_mdl25	#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF\rp:Beige Pura module 3	Endless fun!	2		s	pura_mdl3*5	0	1,1	DEV pura_mdl35	#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF\rp:Beige Pura module 4	Endless fun!	2		s	pura_mdl4*5	0	1,1	DEV pura_mdl45	#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC\rp:Beige Pura module 5	Endless fun!	1		s	pura_mdl5*5	0	1,1	DEV pura_mdl55	#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF\rp:White Pura module 1	Endless fun!	2		s	pura_mdl1*4	0	1,1	DEV pura_mdl14	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:White Pura module 2	Endless fun!	2		s	pura_mdl2*4	0	1,1	DEV pura_mdl24	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:White Pura module 3	Endless fun!	2		s	pura_mdl3*4	0	1,1	DEV pura_mdl34	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:White Pura module 4	Endless fun!	2		s	pura_mdl4*4	0	1,1	DEV pura_mdl44	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:White Pura module 5	Endless fun!	1		s	pura_mdl5*4	0	1,1	DEV pura_mdl54	#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:Black Pura module 1	Endless fun!	2		s	pura_mdl1*3	0	1,1	DEV pura_mdl13	#FFFFFF,#525252,#525252,#FFFFFF\rp:Black Pura module 2	Endless fun!	2		s	pura_mdl2*3	0	1,1	DEV pura_mdl23	#FFFFFF,#525252,#525252,#FFFFFF\rp:Black Pura module 3	Endless fun!	2		s	pura_mdl3*3	0	1,1	DEV pura_mdl33	#FFFFFF,#525252,#525252,#FFFFFF\rp:Black Pura module 4	Endless fun!	2		s	pura_mdl4*3	0	1,1	DEV pura_mdl43	#FFFFFF,#525252,#525252,#525252\rp:Black Pura module 5	Endless fun!	1		s	pura_mdl5*3	0	1,1	DEV pura_mdl53	#FFFFFF,#525252,#525252,#FFFFFF\rp:Pink Pura module 1	Endless fun!	2		s	pura_mdl1*2	0	1,1	DEV pura_mdl12	#FFFFFF,#FF99BC,#FF99BC,#FFFFFF\rp:Pink Pura module 2	Endless fun!	2		s	pura_mdl2*2	0	1,1	DEV pura_mdl22	#FFFFFF,#FF99BC,#FF99BC,#FFFFFF\rp:Pink Pura module 3	Endless fun!	2		s	pura_mdl3*2	0	1,1	DEV pura_mdl32	#FFFFFF,#FF99BC,#FF99BC,#FFFFFF\rp:Pink Pura module 4	Endless fun!	2		s	pura_mdl4*2	0	1,1	DEV pura_mdl42	#FFFFFF,#FF99BC,#FF99BC,#FF99BC\rp:Pink Pura module 5	Endless fun!	1		s	pura_mdl5*2	0	1,1	DEV pura_mdl52	#FFFFFF,#FF99BC,#FF99BC,#FFFFFF');
INSERT INTO `catalogue` VALUES ('Mode', 'i:Mode\rn:Mode\rl:ctlg_layout2\rs:2: So shiny and new..\rw:Click on the item you want for more information.\rg:catalog_mode_headline1\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	4 mdbed	0,0,#8FAEB0,#8FAEB0,0,0\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	3 msbed	0,0,0,#8FAEB0,#8FAEB0,0\rp:Fireplace	Comfort in stainless steel	5		s	fireplace_polyfon	2	2,1	5 mfire	0,0,0\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	4 msofa	0,0,0,0,#8FAEB0,#8FAEB0\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	3 mschair	0,0,#8FAEB0,#8FAEB0,0\rp:Mini-Bar	You naughty Habbo!	5		s	bar_polyfon	2	1,1	5 mmbar	\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	6 mgate	0,0,0,#8FAEB0,#8FAEB0\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	3 mbar	0,0,#8FAEB0,#8FAEB0\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	3 mcbar	0,#8FAEB0,0\rp:Dining Chair	Metallic seating experience	3		s	chair_polyfon	0	1,1	3 mmchair	0,0,0\rp:Large Coffee Table	For larger gatherings	4		s	table_polyfon	0	2,2	4 modetable	\rp:Large Dining Table	For larger gatherings	4		s	smooth_table_polyfon	0	2,2	4 R2P	\rp:Large Coffee Table	For larger gatherings	3		s	table_polyfon_med	0	2,2	3 PMP	0,0,0\rp:Small Coffee Table	For serving a stylish latte	1		s	table_polyfon_small	0	2,2	1 PPP	0,0,0\rp:Bookcase	For the arty pad	4		s	shelves_polyfon	0	2,1	4 KHP	0,0,0\rp:Shelf	Tidy up	1		s	stand_polyfon_z	0	1,1	1 LTP	0,0,0');
INSERT INTO `catalogue` VALUES ('Accessories', 'i:Accessories\rn:Accessories\rl:ctlg_layout2\rs:2: I love my rabbit...\rw:Click on the item you want for more information.\rg:catalog_extra_headline1\rh:Is your room missing something?  Well, now you can add the finishing touches that express your true personality. And dont forget, like everything else, these accessories can be moved about to suit your mood.\re:catalog_extra_teaser1,\rp:Digital TV	Bang up to date	6		s	tv_luxus	0	1,3	A2 DIGITV	\rp:Large TV	For family viewing	4		s	wood_tv	0	1,2	A2 WTV	\rp:Portable TV	Don?t miss those soaps	3		s	red_tv	0	1,1	A2 RTV	\rp:Pad of stickies	Pad of stickies	3		i	post.it 20			A2 tlp 20	\rp:Pizza Box	You dirty Habbo	3		s	pizza	0	1,1	A1 PIZ	\rp:Empty Cans	Are you a slob too?	3		s	drinks	0	1,1	A1 DRK	\rp:Empty Spinning Bottle	For interesting games!	3	!	s	bottle	0	1,1	A2 PUL	\rp:Holo-dice	Whats your lucky number?	6		s	edice	0	1,1	A2 NOPPA	0,0,0\rp:Cake	Save me a slice!	4		s	habbocake	0	1,1	a2 habbocake	0,0,0\rp:Menorah	Light up your room	3		s	menorah	0	1,1	a2 menorah	0,0,0\rp:Squidgy Bunny	Yours to cuddle up to	3		s	bunny	0	1,1	a2 bunny	0,0,0\rp:Mummy	Beware the curse...	3		i	poster 44			poster 75	\rp:White Candle Plate	Simple but stylish	3		s	wcandleset	0	1,1	a2 wcandles	0,0,0\rp:Red Candles on a Plate	Simple but stylish	3		s	rcandleset	0	1,1	a2 rcandles	0,0,0\rp:Joint of Ham	Tuck in	3		s	ham	0	1,1	A2 ham	0,0,0\rp:Lert	Set it off.	5		s	hockey_light	0	1,1	a0 goallight	0,0,0');
INSERT INTO `catalogue` VALUES ('Bathroom', 'i:Bathroom\rn:Bathroom\rl:ctlg_layout2\rs:2:  Every Habbo needs one!\rh:Introducing the Bathroom Collection...  Have some fun with the cheerful bathroom collection. Give yourself and your guests somewhere to freshen up - vital if you want to avoid nasty niffs. Put your loo in a corner though...\rg:catalog_bath_headline1\rw:Click on the item you want for more information.\re:catalog_bath_teaser1,\rp:Bubble Bath	The ultimate in pampering	6		s	bath	0	1,2	A2 AMME	\rp:Sink	Hot and cold thrown in for no charge	3		s	sink	0	1,1	A1 LAVUAARI	\rp:Rubber Duck	Every bather needs one	1		s	duck	0	1,1	A1 KUMIANKKA	\rp:Loo Seat	Loo Seat	4		s	toilet	0	1,1	A2 PYTTYSIN	\rp:Loo Seat	Loo Seat	4		s	toilet_red	0	1,1	A2 PYTTYPUN	\rp:Loo Seat	Loo Seat	4		s	toilet_yell	0	1,1	A2 PYTTYKELT	\rp:Floor Tiles	In a choice of colours	3		s	tile	0	4,4	A2 KAAKELISIN	\rp:Floor Tiles	In a choice of colours	3		s	tile_red	0	4,4	A2 KAAKELIPUN	\rp:Floor Tiles	In a choice of colours	3		s	tile_yell	0	4,4	A2 KAAKELIKELT	');
INSERT INTO `catalogue` VALUES ('Plants', 'i:Plants\rn:Plants\rl:ctlg_layout2\rs:2: No Habbo here, just us trees...\rw:Click on the item you want for more information.\rg:catalog_plants_headline1\rh:Introducing the Plant Collection...  Every room needs a plant! Not only do they bring a bit of the outside inside, they also enhance the air quality! \re:catalog_plants_teaser1,\rp:Vase of Flowers	Guaranteed to stay fresh	4		s	giftflowers	0	1,1	a2 giftflowers	0,0,0\rp:Cut Roses	Sleek and chic	3		s	plant_rose	0	1,1	a2 ruusu	\rp:Cut Sunflower	For happy Habbos	3		s	plant_sunflower	0	1,1	a2 aurinko	\rp:Yukka Plant	Easy to care for	3		s	plant_yukka	0	1,1	A2 JUKKA	\rp:Pineapple Plant	Needs loving glances	3		s	plant_pineapple	0	1,1	A1 ANANAS	\rp:Bonsai Tree	You can be sure it lives	3		s	plant_bonsai	0	1,1	A2 BONSAI	\rp:Mature Cactus	Habbo Dreams monster in hiding!  Shhhh	3		s	plant_big_cactus	0	1,1	A2 ISOKAKTUS	\rp:Small Cactus	Even less watering than the real world	1		s	plant_small_cactus	0	1,1	A1 PIKKUKAKTUS	\rp:Fruit Tree	Great yield and sweet fruit	3		s	plant_fruittree	0	1,1	A1 PUU	\rp:Maze shrubbery	Labyrinths Galore!	5		s	plant_maze	0	2,1	A1 plant_maze	\rp:Maze Shrubbery Gate	Labyrinths Galore!	6		s	plant_mazegate	0	2,1	A1 plant_mazegate	\rp:Bulrush	Ideal for the riverside	3		s	plant_bulrush	0	1,1	A1 plant_bulrush	');
INSERT INTO `catalogue` VALUES ('Sports', 'i:Sports\rn:Sports\rl:ctlg_layout2\rs:2\rh:For the sporty habbos, here is the sports section!\rg:catalog_sports_headline1\rw:\re:catalog_sports_teaser1,\rp:Hockey stick	whack that ball!	3		i	poster 52			poster 52\rp:Hockey stick	whack that ball!	3		i	poster 53			poster 53\rp:Hockey stick	whack that ball!	3		i	poster 54			poster 54\rp:Scoreboard	...for keeping your score	6		s	hockey_score	2	1,1	10 hockey_score	0,0,0\rp:Basketball Trophy	For the winning team	3		s	legotrophy	2	1,1	10 legotrophy	0,0,0\rp:Basketball Hoop	2 points for every basket	3		i	poster 51			poster 51\rp:Basketball Court	Line up your slam dunk	3		s	carpet_legocourt	2	3,3	10 court	0,0,0\rp:Team Bench	For your reserve players	6		s	bench_lego	2	4,1	10 teambench	0,0,0\rp:Sport track straight	Lets get sporty!	3		s	sporttrack1*1	2	2,2	10 track11	#ffffff,#e4592d,#ffffff\rp:Sport track straight asphalt	Lets get sporty!	3		s	sporttrack1*2	2	2,2	10 track12	#ffffff,#62818b,#ffffff\rp:Sport track straight grass	Lets get sporty!	3		s	sporttrack1*3	2	2,2	10 track13	#ffffff,#5cb800,#ffffff\rp:Sport corner	Lets get sporty!	3		s	sporttrack2*1	2	2,2	10 track21	#ffffff,#e4592d,#ffffff\rp:Sport corner asphalt	Lets get sporty!	3		s	sporttrack2*2	2	2,2	10 track22	#ffffff,#62818b,#ffffff\rp:Sport corner grass	Lets get sporty!	3		s	sporttrack2*3	2	2,2	10 track23	#ffffff,#5cb800,#ffffff\rp:Sport goal	Lets get sporty!	3		s	sporttrack3*1	2	2,2	10 track31	#ffffff,#e4592d,#ffffff\rp:Sport goal asphalt	Lets get sporty!	3		s	sporttrack3*2	2	2,2	10 track32	#ffffff,#62818b,#ffffff\rp:Sport goal grass	Lets get sporty!	3		s	sporttrack3*3	2	2,2	10 track33	#ffffff,#5cb800,#ffffff\rp:Football Lamp	Lets get sporty!	10		s	footylamp	2	2,2	10 football_lamp	0,0,0\r');
INSERT INTO `catalogue` VALUES ('Rugs', 'i:Rugs\rn:Rugs\rl:ctlg_layout2\rs:2: We have rugs for ANY room!\rh:We have rugs for all occasions.  All rugs are non-slip and washable.\rg:catalog_rugs_headline1\rw:Click on the item you want for more information.\re:catalog_rugs_teaser1,\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*4	0	3,5	A1 BM3	#ccddff\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*5	0	3,5	A1 BM4	#ddccff\rp:Floor rug	Available in a variety of colours	3		s	carpet_standard	0	3,5	A1 BM7	0,0,0\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*b	0	3,5	A1 BMC	#336666,#336666,#336666\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*a	0	3,5	A1 BMB	#55AC00,#55AC00,#55AC00\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*3	0	3,5	A1 BM6	#ffee00\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*2	0	3,5	A1 BM5	#99DCCC\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*8	0	3,5	A1 BM9	#999966,#999966,#999966\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*7	0	3,5	A1 BM8	#99CCFF,#99CCFF,#99CCFF\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*1	0	3,5	A1 BM2	#ff1f08\rp:Floor Rug	Available in a variety of colours	3		s	carpet_standard*6	0	3,5	A1 BM1	#777777\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft	0	2,4	A1 MM1	\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*1	0	2,4	A1 MM2	#CC3333\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*2	0	2,4	A1 MM3	#66FFFF\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*3	0	2,4	A1 MM4	#FFCC99\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*4	0	2,4	A1 MM5	#FFCCFF\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*5	0	2,4	A1 MM6	#FFFF66\rp:Soft Wool Rug	Soft Wool Rug	3		s	carpet_soft*6	0	2,4	A1 MM7	#669933\rp:Doormat	Welcome Habbos in style	1		s	doormat_love	0	1,1	A1 OSB	0,0,0\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*6	0	1,1	A1 BV1	#777777\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*1	0	1,1	A1 BV2	#ff1f08\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*4	0	1,1	A1 BV3	#ccddff\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*5	0	1,1	A1 BV4	#ddccff\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*2	0	1,1	A1 BV5	#99DCCC\rp:Doormat	Available in a variety of colours	1		s	doormat_plain*3	0	1,1	A1 BV6	#ffee00\rp:Doormat	Available in a variety of colours	1		s	doormat_plain	0	1,1	A1 BV7	0,0,0\rp:Hand-Woven Rug	Adds instant warmth	3		s	carpet_armas	0	2,4	A1 RMA	0,0,0\rp:Faux-Fur Bear Rug	For cuddling up on	4		s	carpet_polar	0	2,3	A2 MUR	#ffffff,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('Gallery', 'i:Gallery\rn:Gallery\rl:ctlg_layout2\rs:2: Brighten up your walls!\rh:Adorn your walls with wondrous works of art, posters, plaques and wall hangings. We have items to suit all tastes, from kitsch to cool, traditional to modern.\rg:catalog_gallery_headline1\rw:Click on the item you want for more information.\re:catalog_posters_teaser1,\rp:Rug on the wall	Rug	10		i	poster 2001			poster 2001\rp:DJ Carlos	DJ Carlos	3		i	poster 2003			poster 2003	\rp:Rastaman	Rasta tarjoaa rakkautta	3		i	poster 2004			poster 2004	\rp:Suom kartta	Suom kartta	3		i	poster 2000			poster 2000	\rp:Presidentin Muotokuva	Presidentin Muotokuva	10		i	poster 2002			poster 2002	\rp:Johnny Squabble	Sportly	10		i	poster 1005			poster 1005	\rp:Hammer Cabinet	for emergencies only	3		i	poster 7			poster 7	\rp:Skyline Poster	skyscrapers at night	3		i	poster 12			poster 12	\rp:BW Skyline Poster	skyscrapers in arty black and white	3		i	poster 13			poster 13	\rp:Fox Poster	a truly cunning design	3		i	poster 14			poster 14	\rp:Three Wise Men Poster	Following the star!	3		i	poster 24			poster 24	\rp:Butterfly Cabinet	beautiful reproduction butterfly	3		i	poster 17			poster 17	\rp:Butterfly Cabinet (blue)	beautiful reproduction butterfly	3		i	poster 18			poster 18	\rp:Bars	high security for your room	3		i	poster 16			poster 16	\rp:UK Map	get the lovely isles on your walls	3		i	poster 1003			poster 1003	\rp:Himalaya Poster	marvellous mountains	3		i	poster 15			poster 15	\rp:Hoot Poster	The eyes follow you...	3		i	poster 1006			poster 1006	\rp:Siva Poster	The Auspicious One	3		i	poster 32			poster 32	\rp:Save the Panda	We cant bear to lose them	3		i	poster 33			poster 33	\rp:Carrot Plaque	take pride in your veg!	3		i	poster 2			poster 2	\rp:Fish Plaque	smells fishy, looks cool	3		i	poster 3			poster 3	\rp:Bear Plaque	fake of course!	3		i	poster 4			poster 4	\rp:Duck Poster	quacking good design!	3		i	poster 5			poster 5	\rp:Ancestor Poster	a touch of history	3		i	poster 1			poster 1	\rp:Abstract Poster	but is it the right way up?	3		i	poster 6			poster 6	\rp:Queen Mum Poster	aw, bless...	3		i	poster 1002			poster 1002	\rp:Prince Charles Poster	Even walls have ears	3		i	poster 1001			poster 1001	\rp:Habbo Colours Poster	Habbos come in all colours	3		i	poster 8			poster 8	\rp:Rainforest Poster	do your bit for the environment	3		i	poster 9			poster 9\rp:Eid Mubarak	Celebrate with us	3		i	poster 1004			poster 1004	\rp:DJ Throne	He is the magic Habbo	3		i	poster 2006			poster 2006	\rp:The Father of Habbo	The Founder	3		i	poster 2007			poster 2007\rp:Green Gecko Art	Like a gecko it wont fall of your wall	3		i	poster 2008			poster 2008	\rp:Certificate	award, charter or the Habbo Way - you decide	3		i	poster 11			poster 11	\rp:Habbo Golden Record	For the best music-makers	3		i	poster 41			poster 41	\rp:Bonnie Blonde	The one and only. Adore her!	3		i	poster 40			poster 40	\rp:The Habbo Babes 1	The Hotels girlband. Dream on!	3		i	poster 35			poster 35	\rp:The Habbo Babes 2	The Hotels girlband. Dream on!	3		i	poster 36			poster 36	\rp:The Habbo Babes 3	The Hotels girlband. Dream on!	3		i	poster 37			poster 37	\rp:Johnny Squabble	The muscly movie hero	3		i	poster 1005			poster 1005	\rp:Scammed	Habbo-punk for the never-agreeing	3		i	poster 34			poster 34	\rp:Screaming Furnies	The rock masters of virtual music	3		i	poster 39			poster 39	\rp:Scammed	Habbo-punk for the never-agreeing	3		i	poster 34			poster 34	\rp:Presidentin muotokuva	Urho Kaleva Kekkonen	3		i	poster 2002			poster 2002	\rp:Suomen kartta	Suomen kartta	3		i	poster 2000			poster 2000	\rp:Smiling Headbangerz	For really TOUGH Habbos!	3		i	poster 38			poster 38	\rp:Habbo Cola Poster	For serious bubblers	3		i	poster 2008			poster 2008	\rp:The Father Of Habbo	The legendary founder of the Hotel	3		i	poster 2007			poster 2007	\rp:Dodgy Geezer	Would you trust this man?	3		i	poster 2003			poster 2003	\rp:Save the Panda	We cant bear to lose them	3		i	poster 33			poster 33	\rp:System of a Ban	Pure and unbridled nu-metal	3		i	poster 31			poster 31	\rp:Beach Tree Poster	Natural	3		i	poster 55			poster 55	\rp:Jolly Roger	For pirates everywhere	3		i	poster 501			poster 501	');
INSERT INTO `catalogue` VALUES ('Flags', 'i:Flags\rn:Flags\rl:ctlg_layout2\rs:2:  Flag this section for later!\rw:Click on the item you want for more information.\rg:catalog_flags_headline1\rh:If youre feeling patriotic, get a flag to prove it. Our finest cloth flags will brighten up the dullest walls.\re:catalog_flags_teaser1,\rp:Union Jack	The UK flag	5		i	poster 500			poster 500	\rp:The Swedish flag	Waved by Swedes everywhere	3		i	poster 515			poster 515\rp:The Australian flag	Aussies rule!	3		i	poster 513			poster 513	\rp:The EU flag	Be proud to be in the Union!	3		i	poster 514			poster 514	\rp:The Irish flag	The flag of Ireland	3		i	poster 512			poster 512	\rp:The Dutch flag	The flag of The Netherlands	3		i	poster 511			poster 511	\rp:The Italian flag	The flag of Italy	3		i	poster 510			poster 510	\rp:The Jamaican flag	The flag of Jamaica	3		i	poster 509			poster 509	\rp:The Spanish flag	The flag of Spain	3		i	poster 508			poster 508	\rp:The Bundesflagge	The German flag	3		i	poster 504			poster 504	\rp:The flag of Finland	To Finnish your decor...	3		i	poster 506			poster 506	\rp:The French Tricolore	The French flag	3		i	poster 507			poster 507	\rp:The Maple Leaf	The Canadian flag	3		i	poster 505			poster 505	\rp:The English flag	Eng-er-land	3		i	poster 516			poster 516	\rp:The Rainbow Flag	Every colour for everyone	3		i	poster 520			poster 520	\rp:The Scottish flag	Wheres your kilt?	3		i	poster 517			poster 517	\rp:The Welsh flag	A fiery dragon for your wall	3		i	poster 518			poster 518	\rp:The Stars and Stripes	The US flag	3		i	poster 502			poster 502	\rp:The Swiss flag	Theres no holes in this...	3		i	poster 503			poster 503	\rp:Flag of Brazil	The flag of Brazil	3		i	poster 521			poster 521	\rp:Jolly Roger	For pirates everywhere	3		i	poster 501			poster 501	');
INSERT INTO `catalogue` VALUES ('Trophies', 'i:Trophies\rn:Trophies\rl:ctlg_trophies\rt1:Type your inscription CAREFULLY, its permanent!\rg:catalog_trophies_headline1\rh:Reward your Habbo friends, or yourself with one of our fabulous glittering array of bronze, silver and gold trophies.<br><br>First choose the trophy model (click on the arrows to see all the different styles) and then the metal (click on the seal below the trophy). Type your inscription below and well engrave it on the trophy along with your name and todays date.<br>\re:\rp:Duck trophy	Breathtaking bronze	8		s	prizetrophy2*3	0	1,1	a0 prizetrophy2_b	#ffffff,#ffffff,#996600\rp:Duo trophy	Breathtaking bronze	8		s	prizetrophy5*3	0	1,1	a0 prizetrophy5_b	#ffffff,#ffffff,#996600\rp:Classic trophy	Glittery gold	12		s	prizetrophy*1	0	1,1	a0 prizetrophy_g	#ffffff,#ffffff,#FFDD3F\rp:Duck trophy	Glittery gold	12		s	prizetrophy2*1	0	1,1	a0 prizetrophy2_g	#ffffff,#ffffff,#FFDD3F\rp:Duo trophy	Glittery gold	12		s	prizetrophy5*1	0	1,1	a0 prizetrophy5_g	#ffffff,#ffffff,#FFDD3F\rp:Classic trophy	Shiny silver	10		s	prizetrophy*2	0	1,1	a0 prizetrophy_s	#ffffff,#ffffff,#ffffff\rp:Duck trophy	Shiny silver	10		s	prizetrophy2*2	0	1,1	a0 prizetrophy2_s	#ffffff,#ffffff,#ffffff\rp:Duo trophy	Shiny silver	10		s	prizetrophy5*2	0	1,1	a0 prizetrophy5_s	#ffffff,#ffffff,#ffffff\rp:Classic trophy	Breathtaking bronze	8		s	prizetrophy*3	0	1,1	a0 prizetrophy_b	#ffffff,#ffffff,#996600');
INSERT INTO `catalogue` VALUES ('Offers', 'i:Offers\rn:Offers\rl:ctlg_layout2\rs:\rw:Click on a deal to find out whats included and how much it costs.\rg:catalog_deals_headline1\rh:Special Offers are great if you’re just starting out. Take a look at our special collections, all at a great price.<br><br>Check them out!\re:catalog_deals_teaser1,\rp:Dining Chair	Keep it simple	5		d				deal01		2	chair_silo	3	#ffffff,#ffffff,#ABD0D2,#ABD0D2	table_silo_med	1	#ffffff,#ABD0D2\rp:Doormat	Welcome Habbos in style	5		d				deal02		3	table_norja_med	1	#ffffff,#F7EBBC	chair_norja	2	#ffffff,#ffffff,#F7EBBC,#F7EBBC	doormat_love	1	0,0,0\rp:Large Coffee Table	For larger gatherings	5		d				deal03		3	table_polyfon_med	1	0,0,0	doormat_plain	1	0,0,0	chair_polyfon	2	0,0,0\rp:Shelf	Tidy up	5		d				deal04		3	red_tv	1		chair_plasty*3	1	#ffffff,#ff2200,#ffffff,#ff2200	stand_polyfon_z	1	0,0,0\rp:Chair	Hip plastic furniture	5		d				deal05		1	chair_plasto*3	6	#ffffff,#533e10,#ffffff,#533e10\rp:Stool	Rustic charm at its best	5		d				deal06		2	small_table_armas	1	0,0,0	small_chair_armas	3	0,0,0\rp:Chair	Hip plastic furniture	5		d				deal07		2	chair_plasto*8	4	#ffffff,#c38d1a,#ffffff,#c38d1a	table_plasto_4leg*8	1	#ffffff,#c38d1a\rp:Doormat	Welcome Habbos in style	5		d				deal08		4	doormat_love	1	0,0,0	table_silo_small	1	#ffffff,#ABD0D2	carpet_standard*a	1	#55AC00,#55AC00,#55AC00	plant_sunflower	1	\rp:Queen Mum Poster	aw, bless...	5		d				deal09		3	poster 1002	1		plant_pineapple	1		plant_fruittree	2	\rp:Prince Charles Poster	Even walls have ears	5		d				deal10		3	plant_fruittree	2		poster 1001	1		plant_pineapple	1	');
INSERT INTO `catalogue` VALUES ('One Way Doors', 'i:One Way Doors\rn:One Way Doors\rl:ctlg_layout2\rs:1: Brand new furni!\rh:Here you can find the special one way doors! Get them now! Use :changetoll to set their toll!l\rg:catalog_rares_headline1\rw:Click on the item you want for more information.\re:catalog_presents_teaser2,\rp:Aqua One Way Door	One side in, the other out!	10		s	one_way_door*1	0	1,1	A1 one_way_door_aqua	#ABD0D2,#FFFFFF,#ABD0D2\rp:Pink One Way Door	One side in, the other out!	10		s	one_way_door*2	0	1,1	A1 one_way_door_pink	#FF99BC,#FFFFFF,#FF99BC\rp:Black One Way Door	One side in, the other out!	10		s	one_way_door*3	0	1,1	A1 one_way_door_black	#525252,#FFFFFF,#525252\rp:White One Way Door	One side in, the other out!	10		s	one_way_door*4	0	1,1	A1 one_way_door_white	#ffffff,#FFFFFF,#ffffff\rp:Beige One Way Door	One side in, the other out!	10		s	one_way_door*5	0	1,1	A1 one_way_door_beige	#F7EBBC,#FFFFFF,#F7EBBC\rp:Blue One Way Door	One side in, the other out!	10		s	one_way_door*6	0	1,1	A1 one_way_door_blue	#5EAAF8,#FFFFFF,#5EAAF8\rp:Green One Way Door	One side in, the other out!	10		s	one_way_door*7	0	1,1	A1 one_way_door_green	#92D13D,#FFFFFF,#92D13D\rp:Yellow One Way Door	One side in, the other out!	10		s	one_way_door*8	0	1,1	A1 one_way_door_yellow	#FFD837,#FFFFFF,#FFD837\rp:Red One Way Door	One side in, the other out!	10		s	one_way_door*9	0	1,1	A1 one_way_door_red	#E14218,#FFFFFF,#E14218');
INSERT INTO `catalogue` VALUES ('Rare Trophies', 'i:Rare Trophies\rn:Rare Trophies\rl:ctlg_trophies\rh:Reward your Habbo friends, or yourself with one of our fabulous glittering array of bronze, silver and gold trophies.<br><br>First choose the trophy model (click on the arrows to see all the different styles) and then the metal (click on the seal below the trophy). Type your inscription below and well engrave it on the trophy along with your name and todays date.<br>\rg:catalog_trophies_headline1\rt1:Type your inscription CAREFULLY, its permanent!\re:\rp:Globe trophy	Breathtaking bronze	8		s	prizetrophy3*3	0	1,1	a0 prizetrophy3_b	#ffffff,#ffffff,#996600\rp:Fish trophy	Breathtaking bronze	8		s	prizetrophy4*3	0	1,1	a0 prizetrophy4_b	#ffffff,#ffffff,#996600\rp:Habbo trophy	Breathtaking bronze	8		s	prizetrophy7*3	0	1,1	a0 prizetrophy7_b	#ffffff,#ffffff,#996600\rp:Champion trophy	Glittery gold	12		s	prizetrophy6*1	0	1,1	a0 prizetrophy6_g	#ffffff,#ffffff,#FFDD3F\rp:Habbo trophy	Glittery gold	12		s	prizetrophy7*1	0	1,1	a0 prizetrophy7_g	#ffffff,#ffffff,#FFDD3F\rp:Globe trophy	Glittery gold	12		s	prizetrophy3*1	0	1,1	a0 prizetrophy3_g	#ffffff,#ffffff,#FFDD3F\rp:Fish trophy	Glittery gold	12		s	prizetrophy4*1	0	1,1	a0 prizetrophy4_g	#ffffff,#ffffff,#FFDD3F\rp:Champion trophy	Shiny silver	10		s	prizetrophy6*2	0	1,1	a0 prizetrophy6_s	#ffffff,#ffffff,#ffffff\rp:Globe trophy	Shiny silver	10		s	prizetrophy3*2	0	1,1	a0 prizetrophy3_s	#ffffff,#ffffff,#ffffff\rp:Habbo trophy	Shiny silver	10		s	prizetrophy7*2	0	1,1	a0 prizetrophy7_s	#ffffff,#ffffff,#ffffff\rp:Fish trophy	Shiny silver	10		s	prizetrophy4*2	0	1,1	a0 prizetrophy4_s	#ffffff,#ffffff,#ffffff\rp:Champion trophy	Breathtaking bronze	8		s	prizetrophy6*3	0	1,1	a0 prizetrophy6_b	#ffffff,#ffffff,#996600');
INSERT INTO `catalogue` VALUES ('Green Iced', 'i:Green Iced\rn:Green Iced\rl:ctlg_layout2\rs:2: These chairs are so green.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_green	#ffffff,#ffffff,#7CB135,#7CB135\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_green	#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_green	#ffffff,#7CB135\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_green	#ffffff,#7CB135\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_green	#ffffff,#7CB135,#7CB135\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_green	#ffffff,#7CB135,#ffffff,#7CB135,#7CB135,#7CB135\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_green	#ffffff,#ffffff,#7CB135,#7CB135\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_green	#ffffff,#7CB135\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_green	#ffffff,#ffffff,#7CB135,#7CB135');
INSERT INTO `catalogue` VALUES ('Green Mode', 'i:Green Mode\rn:Green Mode\rl:ctlg_layout2\rs:2: So shiny and green..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_green	#ffffff,#ffffff,#7CB135,#7CB135\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_green	#ffffff,#ffffff,#ffffff,#7CB135,#7CB135\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_green	#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_green	#ffffff,#ffffff,#7CB135,#7CB135\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_green	#ffffff,#ffffff,#ffffff,#7CB135,#7CB135\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_green	#ffffff,#ffffff,#7CB135,#7CB135\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_green	#ffffff,#7CB135');
INSERT INTO `catalogue` VALUES ('Green Area', 'i:Green Area\rn:Green Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_green	#ffffff,#ffffff,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D,#92D13D\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_green	#ffffff,#ffffff,#92D13D,#92D13D\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_green	#ffffff,#92D13D\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_green	#ffffff,#ffffff,#ffffff,#92D13D\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_green	#ffffff,#92D13D\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_green	#ffffff,#ffffff,#92D13D,#92D13D\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_green	#ffffff,#92D13D');
INSERT INTO `catalogue` VALUES ('Blue Iced', 'i:Blue Iced\rn:Blue Iced\rl:ctlg_layout2\rs:2: These chairs are so blue.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_blue	#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_blue	#ffffff,#5EAAF8\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_blue	#ffffff,#5EAAF8\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_blue	#ffffff,#5EAAF8,#5EAAF8\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_blue	#ffffff,#5EAAF8,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_blue	#ffffff,#5EAAF8\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8');
INSERT INTO `catalogue` VALUES ('Blue Mode', 'i:Blue Mode\rn:Blue Mode\rl:ctlg_layout2\rs:2: So shiny and blue..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_blue	#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_blue	#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_blue	#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_blue	#ffffff,#5EAAF8');
INSERT INTO `catalogue` VALUES ('Blue Area', 'i:Blue Area\rn:Blue Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_blue	#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_blue	#ffffff,#5EAAF8\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_blue	#ffffff,#ffffff,#ffffff,#5EAAF8\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_blue	#ffffff,#5EAAF8\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_blue	#ffffff,#ffffff,#5EAAF8,#5EAAF8\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_blue	#ffffff,#5EAAF8');
INSERT INTO `catalogue` VALUES ('Red Iced', 'i:Red Iced\rn:Red Iced\rl:ctlg_layout2\rs:2: These chairs are so red.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_red	#ffffff,#ffffff,#E14218,#E14218\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_red	#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_red	#ffffff,#E14218\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_red	#ffffff,#E14218\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_red	#ffffff,#E14218,#E14218\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_red	#ffffff,#E14218,#ffffff,#E14218,#E14218,#E14218\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_red	#ffffff,#ffffff,#E14218,#E14218\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_red	#ffffff,#E14218\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_red	#ffffff,#ffffff,#E14218,#E14218');
INSERT INTO `catalogue` VALUES ('Red Mode', 'i:Red Mode\rn:Red Mode\rl:ctlg_layout2\rs:2: So shiny and red..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_red	#ffffff,#ffffff,#E14218,#E14218\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_red	#ffffff,#ffffff,#ffffff,#E14218,#E14218\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_red	#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_red	#ffffff,#ffffff,#E14218,#E14218\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_red	#ffffff,#ffffff,#ffffff,#E14218,#E14218\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_red	#ffffff,#ffffff,#E14218,#E14218\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_red	#ffffff,#E14218');
INSERT INTO `catalogue` VALUES ('Red Area', 'i:Red Area\rn:Red Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_red	#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_red	#ffffff,#ffffff,#E14218,#E14218\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_red	#ffffff,#E14218\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_red	#ffffff,#ffffff,#ffffff,#E14218\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_red	#ffffff,#E14218\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_red	#ffffff,#ffffff,#E14218,#E14218\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_red	#ffffff,#E14218');
INSERT INTO `catalogue` VALUES ('Pink Iced', 'i:Pink Iced\rn:Pink Iced\rl:ctlg_layout2\rs:2: These chairs are so pink.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_pink	#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_pink	#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_pink	#ffffff,#EE7EA4\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_pink	#ffffff,#EE7EA4\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_pink	#ffffff,#EE7EA4,#EE7EA4\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_pink	#ffffff,#EE7EA4,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_pink	#ffffff,#ffffff,#EE7EA4,#EE7EA4\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_pink	#ffffff,#EE7EA4\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_pink	#ffffff,#ffffff,#EE7EA4,#EE7EA4');
INSERT INTO `catalogue` VALUES ('Pink Area', 'i:Pink Area\rn:Pink Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_pink	#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC,#FF99BC,#FF99BC,#FF99BC\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_pink	#ffffff,#ffffff,#FF99BC,#FF99BC\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_pink	#ffffff,#FF99BC\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_pink	#ffffff,#ffffff,#ffffff,#FF99BC\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_pink	#ffffff,#FF99BC\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_pink	#ffffff,#ffffff,#FF99BC,#FF99BC\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_pink	#ffffff,#FF99BC');
INSERT INTO `catalogue` VALUES ('Beige Mode', 'i:BeAige Mode\rn:Beige Mode\rl:ctlg_layout2\rs:2: So shiny and beige..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_beige	#ffffff,#ffffff,#D0C6A5,#D0C6A5\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_beige	#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_beige	#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_beige	#ffffff,#ffffff,#F7EBBC,#F7EBBC\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_beige	#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_beige	#ffffff,#ffffff,#F7EBBC,#F7EBBC\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_beige	#ffffff,#F7EBBC');
INSERT INTO `catalogue` VALUES ('White Mode', 'i:White Mode\rn:White Mode\rl:ctlg_layout2\rs:2: So shiny and white..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_white	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_white	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_white	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_white	#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('White Iced', 'i:White Iced\rn:White Iced\rl:ctlg_layout2\rs:2: These chairs are so white.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_white	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_white	#ffffff,#ffffff\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_white	#ffffff,#ffffff\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_white	#ffffff,#ffffff,#ffffff\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_white	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_white	#ffffff,#ffffff\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_white	#ffffff,#ffffff,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('White Area', 'i:White Area\rn:White Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_white	#ffffff,#ffffff,#ffffff,#ffffff,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_white	#ffffff,#ffffff,#FFFFFF,#FFFFFF\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_white	#ffffff,#FFFFFF\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_white	#ffffff,#ffffff,#ffffff,#FFFFFF\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_white	#ffffff,#FFFFFF\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_white	#ffffff,#ffffff,#FFFFFF,#FFFFFF\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_white	#ffffff,#FFFFFF');
INSERT INTO `catalogue` VALUES ('Black Mode', 'i:Black Mode\rn:Black Mode\rl:ctlg_layout2\rs:2: So shiny and black..\rh:Introducing the Mode Collection...  Steely grey functionality combined with sleek designer upholstery. The Habbo that chooses this furniture is a cool urban cat - streetwise, sassy and so slightly untouchable.\rg:catalog_mode_headline1\rw:Click on the item you want for more information.\re:catalog_mode_teaser1,\rp:Double Bed	Give yourself space to stretch out	4		s	bed_polyfon	0	2,3	A2 mode_2bed_black	#ffffff,#ffffff,#525252,#525252\rp:Single Bed	Cot of the artistic	3		s	bed_polyfon_one	0	1,3	A1 mode_1bed_black	#ffffff,#ffffff,#ffffff,#525252,#525252\rp:Two-seater Sofa	Comfort for stylish couples	4		s	sofa_polyfon	0	2,1	A2 mode_sofa_black	#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252\rp:Armchair	Loft-style comfort	3		s	sofachair_polyfon	0	1,1	A1 mode_chair_black	#ffffff,#ffffff,#525252,#525252\rp:Hatch (Lockable)	All bars should have one	6		s	divider_poly3	0	1,1	a2 mode_gate_black	#ffffff,#ffffff,#ffffff,#525252,#525252\rp:Bar/desk	Perfect for work or play	3		s	bardesk_polyfon	0	2,1	A1 mode_bar_black	#ffffff,#ffffff,#525252,#525252\rp:Corner Cabinet/Desk	Tuck it away	3		s	bardeskcorner_polyfon	0	1,1	A1 mode_corner_black	#ffffff,#525252');
INSERT INTO `catalogue` VALUES ('Black Iced', 'i:Black Iced\rn:Black Iced\rl:ctlg_layout2\rs:2: These chairs are so black.\rh:Introducing the Iced Collection...  For the Habbo who needs no introduction. Its so chic, it says everything and nothing. Its a blank canvas, let your imagination to run wild!\rg:catalog_iced_headline1\rw:Click on the item you want for more information.\re:catalog_iced_teaser1,\rp:Chair	Sleek and chic for each cheek	3		s	chair_norja	0	1,1	A1 iced_stool_black	#ffffff,#ffffff,#525252,#525252\rp:Bench	Two can perch comfortably	3		s	couch_norja	0	2,1	A1 iced_bench_black	#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252\rp:Coffee Table	Elegance embodied	3		s	table_norja_med	0	2,2	A1 iced_table_black	#ffffff,#525252\rp:Bookcase	For nic naks and art deco books	3		s	shelves_norja	0	1,1	A1 iced_bookcase_black	#ffffff,#525252\rp:iced sofachair	Soft iced sofachair	3		s	soft_sofachair_norja	0	1,1	a2 iced_chair_black	#ffffff,#525252,#525252\rp:iced sofa	A soft iced sofa	4		s	soft_sofa_norja	0	2,1	A2 iced_sofa_black	#ffffff,#525252,#ffffff,#525252,#525252,#525252\rp:Ice Bar-Desk	Strong, yet soft looking	3		s	divider_nor2	0	2,1	a1 iced_bar_black	#ffffff,#ffffff,#525252,#525252\rp:Ice Corner	Looks squishy, but isnt	3		s	divider_nor1	0	1,1	a1 iced_corner_black	#ffffff,#525252\rp:Door (Lockable)	Do go through...	6		s	divider_nor3	0	1,1	a2 iced_gate_black	#ffffff,#ffffff,#525252,#525252');
INSERT INTO `catalogue` VALUES ('Black Area', 'i:Black Area\rn:Black Area\rl:ctlg_layout2\rs:2: Beautiful in its simplicity!\rh:Introducing the Area Collection...  Clean, chunky lines set this collection apart as a preserve of the down-to-earth Habbo. Its beautiful in its simplicity, and welcoming to everyone.\rg:catalog_area_headline1\rw:Click on the item you want for more information.\re:catalog_area_teaser1,\rp:Two-Seater Sofa	Cushioned, understated comfort	3		s	sofa_silo	0	2,1	A1 area_sofa_black	#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252\rp:Armchair	Large, but worth it	3		s	sofachair_silo	0	1,1	A1 area_chair_black	#ffffff,#ffffff,#525252,#525252\rp:Occasional Table	For those random moments	1		s	table_silo_small	0	1,1	A1 area_stable_black	#ffffff,#525252\rp:Gate (lockable)	Form following function	6		s	divider_silo3	0	1,1	a2 area_gate_black	#ffffff,#ffffff,#ffffff,#525252\rp:Corner Shelf	Neat and natty	3		s	divider_silo1	0	1,1	a1 area_corner_black	#ffffff,#525252\rp:Dining Chair	Keep it simple	3		s	chair_silo	0	1,1	A1 area_stool_black	#ffffff,#ffffff,#525252,#525252\rp:Coffee Table	Wipe clean and unobtrusive	3		s	table_silo_med	0	2,2	A1 area_table_black	#ffffff,#525252');
INSERT INTO `catalogue` VALUES ('Limited Edition', 'i:Limited Edition\rn:Limited Edition\rl:ctlg_layout2\rs:\rh:Get it while its hot.. <br><br>LIMITED EDITION FURNITURE!\rg:catalog_limited_headline1\rw:For a limited time only!\re:catalog_limited_teaser1,\rp:Spotlight	Lights.. Camera.. ACTION!	25		s	spotlight	0	1,1	7 spotlight	0,0,0\rp:Lazy Boy	With a serve of popcorn.	25		s	theatre_seat	0	1,1	7 theatre_seat	0,0,0\rp:Overgrown Bamboo	Dont get lost!	25		s	jp_bamboo	0	2,2	7 jp_bamboo	0,0,0\rp:Wooden Pillow	Soft and cozy	25		s	jp_pillow	0	1,1	7 jp_pillow	0,0,0\rp:Floor Rug	Japanese Styled	25		s	jp_tatami	0	2,2	7 jp_tatami	0,0,0\rp:Floor Rug	Japanese Styled	25		s	jp_tatami2	0	2,4	7 jp_tatami2	0,0,0\rp:Ninja Stars	Ouch	10		i	jp_ninjastars			a0 jp_ninjastars\r\n\rp:Sushi Table	Want some Soysause with that?	25		s	jp_irori	0	2,2	3 jp_irori	0,0,0\r\n\rp:Bed Side Drawer	Japanese Styled!	25		s	jp_drawer	0	1,1	3 jp_drawer	0,0,0\rp:Habbowood Rope	Habbowood celebs only past this point...	25		s	rope_divider	0	2,1	3 rope_divider	0,0,0\rp:Habbowood Mirror	No spare bulbs, sorry!	25		I	habw_mirror	0	1,1	3 habw_mirror	0\rp:Romantique Clock	Tick-Tock!	25		s	romantique_clock	0	1,1	3 romantique_clock	0,0,0\rp:Japanese Latern	Careful, its hot!	25		s	jp_lantern	0	1,1	3 jp_lantern	0,0,0\r');
INSERT INTO `catalogue` VALUES ('Love', 'i:Love\rn:Love\rl:ctlg_layout2\rg:catalog_love_headline1\rw:Click on an item to see a bigger version of it!\rh:The love collection has everything to create the perfect love room, for a good price!\rp:Heart Sofa	Perfect for snuggling up on	3		s	heartsofa	0	2,1	10 heartsofa	0,0,0\rp:Cupid Statue	Watch out for those arrows!	3		s	statue	0	1,1	10 statue	0,0,0\rp:Giant Heart	Full of love	6		s	heart	0	2,1	10 heart	0,0,0\rp:Valentines Duck	Hes lovestruck	2		s	valeduck	0	1,1	10 valeduck	0,0,0\rp:Heart stickies	Heart stickies	3		i	post.it.vd			A2 tlp2 20	\rp:Red Carpet	For making an entrance.	15		s	carpet_valentine	0	2,7	10 val_carpet	0,0,0\rp:Valentines lamp	Valentines lamp	10		i	val_heart			a0 val_heart	\r\r\rp:Valentinerose Red	For a love that it true	8		s	plant_valentinerose*1	0	1,1	A2 val_rose	#FFFFFF,#FF1E1E,#FFFFFF,#FFFFFF\r\r');
INSERT INTO `catalogue` VALUES ('Easter', 'i:Easter\rn:Easter\rl:ctlg_layout2\rs:2: I love my bunny!\rw:Click on an item to see a bigger version of it!\rg:catalog_easter_headline1\rh:Its easter! Time for some easter furni. Here is the collection of this year...\re:catalog_easter_teaser1,\r\rp:Wannabe bunny	Can you tell what it is yet?	2		s	easterduck	0	1,1	2 easterduck	0,0,0\r\r\rp:Pop-up Egg	Cheep (!) and cheerful	5		s	birdie	0	1,1	5 birdie	0,0,0\r\r\rp:Basket Of Eggs	Eggs-actly what you want for Easter	4		s	basket	0	1,1	4 basket	0,0,0\r\r\rp:Squidgy Bunny	Yours to cuddle up to	3		s	bunny	0	1,1	3 bunny	0,0,0\r');
INSERT INTO `catalogue` VALUES ('Halloween', 'i:Halloween\rn:Halloween\rl:ctlg_layout2\rg:catalog_halloween_headline1\rw:Click on an item to see a bigger version of it!\rh:Yes, its a spookfest! Get your boney hands on our creepy collection of ghoulish goodies. But be quick - theyll be gone from the Catalogue after two weeks!\rs:2:Halloween is MY day!\re:catalog_halloween_teaser,\rp:Pumpkin Lamp	Cast a spooky glow	6		s	pumpkin	0	1,1	6 pumpkin	0,0,0\rp:Spiderweb	Not something you want to run into	3		i	poster 42			poster 42\rp:Chains	Shake, rattle and roll!	4		i	poster 43			poster 43\rp:Skull Candle Holder	Alas poor Yorrick...	4		s	skullcandle	0	1,1	4 skullcandle	0,0,0\rp:Skeleton	Needs a few more Habburgers	3		i	poster 45			poster 45\rp:Mummy	Beware the curse...	3		i	poster 44			poster 44\rp:Dead Duck	Blood, but no guts 8	2		s	deadduck	0	1,1	2 deadduck	0,0,0\rp:Dead Duck 2	Someone forgot to feed me...	2		s	deadduck2	0	1,1	2 deadduck2	0,0,0\rp:Dead Duck 3	With added ectoplasm	2		s	deadduck3	0	1,1	2 deadduck3	0,0,0\rp:Bat Poster	flap, flap, screech, screech...	3		i	poster 50			poster 50\rp:Jolly Roger	For pirates everywhere	3		i	poster 501			poster 501\rp:Eaten Ham	Looks like youre too late!	3		s	ham2	0	1,1	2 ham2	0,0,0\rp:HabboWheen Crypt	HabboWheen Crypt	5		s	habboween_crypt	0	1,1	5 habboween_crypt	0,0,0\rp:HabboWheen Grass	HabboWheen Grass	5		s	habboween_grass	0	1,1	3 habboween_grass	0,0,0\rp:HabboWheen Cauldron	HabboWheen Cauldron	5		s	hal_cauldron	0	1,1	3 hal_cauldron	0,0,0\rp:HabboWheen Grave	HabboWheen Grave	5		s	hal_grave	0	1,1	3 hal_grave	0,0,0');
INSERT INTO `catalogue` VALUES ('Christmas', 'i:Christmas\rn:Christmas\rl:ctlg_layout2\rg:catalog_xmas_headline1\rw:Click on an item to see a bigger version of it!\rh:The Habbo Christmas catalogue has everything you need to make the perfect festive room: Trees, ducks with santa hats on, puddings and of course, Menorahs!\rs:2:Tuck into Christmas!\re:catalog_xmas_teaser,\rp:Christmas Tree 1	Any presents under it yet?	6		s	tree3	0	1,1	10 xmas1	0,0,0\rp:Christmas Tree 2	Any presents under it yet?	6		s	tree4	0	1,1	10 xmas2	0,0,0\rp:Christmas Tree 3	Any presents under it yet?	6		s	tree5	0	1,1	10 xmas3	0,0,0\rp:Electric Candles	No need to worry about wax drips	3		s	triplecandle	0	1,1	10 electriccandles	0,0,0\rp:Roast Turkey	Wheres the cranberry sauce?	3		s	turkey	0	1,1	10 turkeys	0,0,0\rp:Holly Garland	Deck the halls!	3		i	poster 27			poster 27\rp:Gingerbread House 	Good enough to eat	3		s	house	0	1,1	10 gbread1	0,0,0\rp:Reindeer Poster	Doing a hard nights work	3		i	poster 25			poster 25\rp:Three Wise Men Poster	Following the star!	3		i	poster 24			poster 24\rp:Santa Poster Poster	The jolly fat man himself	3		i	poster 23			poster 23\rp:Stocking	Hung yours up yet?	3		i	poster 26			poster 26\rp:Christmas Pudding 	Will you get the lucky sixpence?	3		s	pudding	0	1,1	10 pudding	0,0,0\rp:Mistletoe	Pucker up	3		i	poster 30			poster 30\rp:Christmas Rubber Duck 	A right Christmas quacker!	2		s	xmasduck	0	1,1	10 xmasduck	0,0,0\rp:Pink Hyacinth 	Beautiful bulb	3		s	hyacinth1	0	1,1	10 hyacinth1	0,0,0\rp:Blue Hyacinth 	Beautiful bulb	3		s	hyacinth2	0	1,1	10 hyacinth2	0,0,0\rp:Poinsetta 	Christmas in a pot	3		s	joulutahti	0	1,1	10 joulutahti	0,0,0\rp:Red Candle 	Xmas tea light	3		s	rcandle	0	1,1	10 rcandle	0,0,0\rp:White Candle 	Xmas tea light	3		s	wcandle	0	1,1	10 wcandle	0,0,0\rp:Winter Wonderland Poster	A chilly snowy scene	3		i	poster 22			poster 22\rp:Snowman Poster	A new use for carrots!	3		i	poster 20			poster 20\rp:Large gold star	All that glitters...	3		i	poster 48			poster 48\rp:Large silver star	All that glitters...	3		i	poster 49			poster 49\rp:Tinsel (gold)	A touch of festive sparkle	3		i	poster 29			poster 29\rp:Tinsel (silver)	A touch of festive sparkle	3		i	poster 28			poster 28\rp:Small gold star	Twinkle, twinkle	3		i	poster 46			poster 46\rp:Small silver star	Twinkle, twinkle	3		i	poster 47			poster 47\rp:Angel Poster	See that halo gleam!	3		i	poster 21			poster 21\r');
INSERT INTO `catalogue` VALUES ('Club Shop', 'i:Club Shop\rn:Club Shop\rl:ctlg_layout2\rg:catalog_club_headline1\rh:Welcome to the Brand New Habbo Club Shop, where Habbo Club members can purchase exclusive items!<br>The Furni in this section can only be purchased by Habbos who have joined Habbo Club.\rs:For Habbo Club members only!\rw:Click on an item to see more details\re:catalog_hc_teaser,\rp:Blue Solarium	Rejuvenate your pixels!	10		s	solarium_norja*6	0	1,1	a6 solarium	#ffffff,#5EAAF8,#ffffff\r\n');
INSERT INTO `catalogue` VALUES ('Ice Cream Machines', 'i:Ice Cream Machines\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Ice Cream page, you can purchase any colour for only a few credits, but be quick because they wont be here long!\rw:\re:catalog_presents_teaser2,\rp:Red Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 red_ice	#FFFFFF,#F43100,0,0,0\rp:Blue Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 blue_ice	#FFFFFF,#3C75FF,0,0,0\rp:Choco Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 choco_ice	#FFFFFF,#97420C,0,0,0\rp:Aqua Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 aqua_ice	#FFFFFF,#00E5E2,0,0,0\rp:Green Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 green_ice	#FFFFFF,#55CD01,0,0,0\rp:Ochre Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 ochre_ice	#FFFFFF,#FF8000,0,0,0\rp:Fucsia Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 Fucsia_ice	#FFFFFF,#FF60B0,0,0,0\rp:Pink Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 pink_ice	#FFFFFF,#FF9898,0,0,0');
INSERT INTO `catalogue` VALUES ('Summer Pools', 'i:Summer Pools\rn:Summer Pools\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_limited_headline1\rh:Summer Pools By NGangsta For DebboSQL V4\rw:\re:catalog_presents_teaser2,\rp:Summer Pool Blue	Summer Pool Blue	5		s	summer_pool*1	0	1,1	5 summer_pool_blue	#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8,#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8\r\n\r\rp:Summer Pool Red	Summer Pool Red	5		s	summer_pool*2	0	1,1	3 summer_pool_red	#E14218,#E14218,#E14218,#E14218,#ffffff,#ffffff,#ffffff,#ffffff,#E14218\r\n\r\rp:Summer Pool Yellow	Summer Pool Yellow	5		s	summer_pool*4	0	1,1	3 summer_pool_yellow	#FFD837,#FFD837,#FFD837,#FFD837,#ffffff,#ffffff,#ffffff,#ffffff,#FFD837\r\n\r\rp:Summer  Pool Green	Summer Pool Green	5		s	summer_pool*3	0	1,1	3 summer_pool_green	#92D13D,#92D13D,#92D13D,#92D13D,#ffffff,#ffffff,#ffffff,#ffffff,#92D13D\r\n');
INSERT INTO `catalogue` VALUES ('Pillows', 'i:Pillows\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the pillows page. Here you can buy any colour pillow that will make your habbo comfortable!\rw:\re:catalog_presents_teaser2,\rp:Turquoise Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 turquoise_pillow	#63C9A0,#63C9A0,#ffffff,#ffffff\rp:Blue Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 blue_pillow	#5DAAC9,#5DAAC9,#ffffff,#ffffff\rp:Pink Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 pink_pillow	#FF8888,#FF8888,#ffffff,#ffffff\rp:Navy Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 navy_pillow	#214E68,#214E68,#ffffff,#ffffff\rp:Black Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 black_pillow	#494D29,#494D29,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('Oriental Screens', 'i:Oriental Screens\rn:Oriental Screens\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the oriental Screens page. Here you can buy any oriental screen to give your room that Chinese feel!\rw:\re:catalog_presents_teaser2,\rp:Pink Oriental screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 pink_screen	#ffffff,#ffffff,#FFA795,#FFA795,#ffffff,#ffffff\rp:Purple Oriental Screen	Adds an exotic vibe to any room	  25		s	wooden_screen*7	0	1,2	3 purple_screen	#ffffff,#ffffff,#DA2591,#DA2591,#ffffff,#ffffff\rp:Teal Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 teal_screen	#ffffff,#ffffff,#004B5E,#004B5E,#ffffff,#ffffff\rp:Gray Oriental Screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 gray_screen	#ffffff,#ffffff,#778B61,#778B61,#ffffff,#ffffff\rp:Green Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 green_screen	ffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff\rp:Golden Oriental Screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 golden_screen	#ffffff,#ffffff,#F7B800,#F7B800,#ffffff,#ffffff\rp:Blue Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 blue_screen	#ffffff,#ffffff,#72B6D1,#72B6D1,#ffffff,#ffffff\rp:Aqua Oriental Screen  	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 aqua_screen	#ffffff,#ffffff,#79E4B3,#79E4B3,#ffffff,#ffffff');
INSERT INTO `catalogue` VALUES ('Pillars', 'i:Pillars\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the pillars page. Here you can buy any pillar that will make your room feel like ancient Greek!\rw:\re:catalog_presents_teaser2,\rp:Greek Pillar	Classy architect, for holding up ceilings!	25		s	pillar*0	1	1,1	3 greek_pillar	#ffffff,#ffffff,#ffffff\rp:Atlantean Pillar	Recovered from Habblantis	25		s	pillar*7	1	1,1	3 atlant_pillar	#ffffff,#e3ca0e,#e3ca0e\rp:Terracotta Pillar	Ancient and stately	25		s	pillar*6	1	1,1	3 terra_pillar	#ffffff,#972e2a,#972e2a\rp:Rock Pillar	Classy architect, for holding up ceilings!	25		s	pillar*9	1	1,1	3 rock_pillar	#ffffff,#B2A69D,#B2A69D\rp:Olive Green Pillar	Classy architect, for holding up ceilings!	25		s	pillar*8	1	1,1	3 olive_pillar	#ffffff,#9A924B,#9A924B\rp:Wood Pillar	Classy architect, for holding up ceilings!	25		s	pillar*2	1	1,1	3 wood_pillar	#ffffff,#7B5922,#7B5922\rp:Green Pillar	Classy architect, for holding up ceilings!	25		s	pillar*5	1	1,1	3 green_pillar	#ffffff,#CEDD65,#CEDD65\rp:Graphite Pillar	Classy architect, for holding up ceilings!	25		s	pillar*4	1	1,1	3 graphite_pillar	#ffffff,#71797C,#71797C\rp:Pink Pillar	Classy architect, for holding up ceilings!	25		s	pillar*0	1	1,1	3 pink_pillar	#ffffff,#FFD0D2,#FFD0D2p:Blue Pillar	Ancient and stately	25		s	pillar*3	0	1,1	3 blue_pillar	#ffffff,#BDCDEA,#BDCDEA');
INSERT INTO `catalogue` VALUES ('Laser Gates', 'i:Laser Gates\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Laser page You can Purchase any colour Laser for just a few credits!\rw:\re:catalog_presents_teaser2,,\rp:Red Laser Door	Energy beams. No trespassers!	25		s	scifiport*0	0	1,1	3 red_laser	#ffffff,#dd2d22,#ffffff,#ffffff,#ffffff,#dd2d22\rp:Violet Laser Portal	Energy beams. No trespassers!	25		s	scifiport*9	0	1,1	3 violet_laser	#ffffff,#7733ff,#ffffff,#ffffff,#ffffff,#7733ff\rp:Purple Laser Portal	Energy beams. No trespassers!	25		s	scifiport*8	0	1,1	3 purple_laser	#ffffff,#bb55cc,#ffffff,#ffffff,#ffffff,#bb55cc\rp:Turquoise Laser Portal	Energy beams. No trespassers!	25		s	scifiport*7	0	1,1	3 Turquoise_Laser	#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc\rp:White Laser Portal	Energy beams. No trespassers!	25		s	scifiport*6	0	1,1	3 white_laser	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Black Laser Portal	Energy beams. No trespassers!	25		s	scifiport*5	0	1,1	3 black_laser	#ffffff,#555555,#ffffff,#ffffff,#ffffff,#555555\rp:Pink Laser Portal	Energy beams. No trespassers!	25		s	scifiport*4	0	1,1	3 pink_laser	#ffffff,#ff5577,#ffffff,#ffffff,#ffffff,#ff5577\rp:Jade Laser Portal	Energy beams. No trespassers!	25		s	scifiport*3	0	1,1	3 jade_laser	#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70\rp:Blue Laser Portal	Energy beams. No trespassers!	25		s	scifiport*2	0	1,1	3 blue_laser	#ffffff,#5599ff,#ffffff,#ffffff,#ffffff,#5599ff\rp:Yellow Laser Door	Energy beams. No trespassers!	25		s	scifiport*1	0	1,1	3 yellow_laser	#ffffff,#ffbc00,#ffffff,#ffffff,#ffffff,#ffbc00\r\n');
INSERT INTO `catalogue` VALUES ('Guitars', 'i:Guitars\rn:Gallery\rl:ctlg_layout2\rs:2: Brighten up your walls!\rh:Guitars And HabboWheel By NGangsta Special For DebboSQL v4\rg:catalog_limited_headline1\rw:Click on the item you want for more information.\re:catalog_posters_teaser1,\rp:V-Guitar	V-Guitar	5		i	guitar_v			a0 guitar_v	0,0,0\rp:Skull-Guitar	Skull-Guitar	5		i	guitar_skull			a0 guitar_skull	0,0,0\rp:HabboWheel	HabboWheel	5		i	habbowheel			a0 habbowheel	0,0,0	');
INSERT INTO `catalogue` VALUES ('Monoliths', 'i:Monoliths\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Monotliths page.Take a pick of any colour and buy for only 25creds!\rw:\re:catalog_presents_teaser2,\rp:Black Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono	#ffffff,#333333,#333333,#333333,#ffffff\rp:Blue Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_blue	#ffffff,#4488ff,#4488ff,#4488ff,#ffffff\rp:Pink Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_pink	#ffffff,#ffaaaa,#ffaaaa,#ffaaaa,#ffffff\rp:Aqua Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_aqua	#ffffff,#aaffff,#aaffff,#aaffff,#ffffff\rp:White Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_white	#ffffff,#ffffff,#ffffff, #ffffff,#ffffff\rp:Sky Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_sky	#ffffff,#aaccff,#aaccff,#aaccff,#ffffff\rp:Jade Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_jade	#ffffff,#99dd77,#99dd77,#99dd77,#ffffff\rp:Purple Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_purple	#ffffff,#ff99cc,#ff99cc,#ff99cc,#ffffff\rp:Violet Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_violet	#ffffff,#bb99ff,#bb99ff,#bb99ff,#ffffffp:Yellow Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_yellow	#ffffff,#ffee66,#ffee66,#ffee66,#ffffff');
INSERT INTO `catalogue` VALUES ('Smoke Machines', 'i:Smoke Machines\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Smoke Machines page. Here you can buy any smoke that will give your room that cloudy feel!\rw:\re:catalog_presents_teaser2,\rp:Aqua Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 aqua_rocket	#ffffff,#ffffff,#00cccc,#ffffff\rp:Red Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 red_rocket	#ffffff,#ffffff,#dd2d22,#ffffff\rp:Purple Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 purple_rocket	#ffffff,#ffffff,#bb55cc,#ffffff\rp:Violet Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 violet_rocket	#ffffff,#ffffff,#7733ff,#ffffff\rp:Pink Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 pink_rocket	#ffffff,#ffffff,#ff5577,#ffffff\rp:Jade Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 jade_rocket	#ffffff,#ffffff,#02bb70,#ffffff\rp:Blue Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 blue_rocket	#ffffff,#ffffff,#5599ff,#ffffff\rp:Yellow Smoke Machine	Retro-mystification	25		s	scifirocket*1	0	1,1	3 yellow_rocket	#ffffff,#ffffff,#ffbc00,#ffffff');
INSERT INTO `catalogue` VALUES ('Fans', 'i:Fans\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the fans page. Here you can buy any colour fan that blows you away!\rw:\re:catalog_presents_teaser2,\rp:Purple Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 purple_fan	#C05DFF,0,0,0\rp:Brown Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 brown_fan	#97420C,0,0,0\rp:Ochre Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 ochre_fan	#FF8000,0,0,0\rp:Fucsia Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 fucsia_fan	#FF60B0,0,0,0\rp:Yellow Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 yellow_fan	#E1CC00,0,0,0\rp:Blue Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 blue_fan	#3C75FF,0,0,0\rp:Turquoise  Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 turquoise_fan	#00E5E2,0,0,0');
INSERT INTO `catalogue` VALUES ('Marquee', 'i:Marquee\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the Marquee page. Here you can buy any colour Marquee for just a few credits!\rw:\re:catalog_presents_teaser2,\rp:Blue Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 blue_marquee #ffffff,#ffffff,#ffffff,#719EFD\rp:Aqua Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 aqua_marquee	#ffffff,#ffffff,#ffffff,#68DADA\rp:Red Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 red_marquee	#ffffff,#ffffff,#ffffff,#C60000\rp:Purple Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 purple_marquee	#ffffff,#ffffff,#ffffff,#D600E2\rp:Pink Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 pink_marquee	#ffffff,#ffffff,#ffffff,#FF798F\rp:Navy Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 navy_marquee	#ffffff,#ffffff,#ffffff,#004AA0\rp:White Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 white_marquee	#ffffff,#ffffff,#ffffff,#ffffff\rp:Graphite Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 graphite_marquee	#ffffff,#ffffff,#ffffff,#707070');
INSERT INTO `catalogue` VALUES ('Rare Recolours', 'i:Rare Recolours\rn:Rare Recolours\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Rare Page\rw:\re:catalog_presents_teaser2,\rp:Fire Dragon Lamp	Scary & Scorching!	25		s	rare_dragonlamp*0	0	1,1	3 drag1	#ffffff,#fa2d00,#fa2d00\rp:Sea Dragon Lamp	Out of the deepes blue sea	25		s	rare_dragonlamp*1	0	1,1	3 drag2	#ffffff,#3470ff,#3470ff\rp:Jade Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*2	0	1,1	3 drag3	#ffffff,#02bb70,#02bb70\rp:Silver Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*3	0	1,1	3 drag4	#ffffff,#ffffff,#ffffff\rp:Black Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*4	0	1,1	3 drag5	#ffffff,#3e3d40,#3e3d40\rp:Elf Green Dragon Lamp	Roast your chestnuts here!	25		s	rare_dragonlamp*5	0	1,1	3 drag6	#ffffff,#589a03,#589a03\rp:Gold Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*6	0	1,1	3 drag7	#ffffff,#ffbc00,#ffbc00\rp:Sky Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*7	0	1,1	3 drag8	#ffffff,#83aeff,#83aeff\rp:Bronze Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*8	0	1,1	3 drag9	#ffffff,#ff5f01,#ff5f01\rp:Purple Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*9	0	1,1	3 drag10	#FFFFFF,#B357FF,#B357FF\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair	#CFCFCF,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair*6	0	1,1	5 rubber_chair_purp	#7733ff,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair_blue	#0080FF,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair_ocean	#00E5E2,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair*5	0	1,1	5 rubber_chair_lime	#89ca35,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair_pink	#ff5577,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair_orange	#FF6600,0,0\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair_black	#333333,0,0\rp:Red Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 red_ice	#FFFFFF,#F43100,0,0,0\rp:Blue Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 blue_ice	#FFFFFF,#3C75FF,0,0,0\rp:Choco Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 choco_ice	#FFFFFF,#97420C,0,0,0\rp:Aqua Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 aqua_ice	#FFFFFF,#00E5E2,0,0,0\rp:Green Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 green_ice	#FFFFFF,#55CD01,0,0,0\rp:Ochre Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 ochre_ice	#FFFFFF,#FF8000,0,0,0\rp:Fucsia Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 Fucsia_ice	#FFFFFF,#FF60B0,0,0,0\rp:Pink Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*0	1	1,1	3 pink_ice	#FFFFFF,#FF9898,0,0,0\rp:Red Laser Door	Energy beams. No trespassers!	25		s	scifiport*0	0	1,1	3 red_laser	#ffffff,#dd2d22,#ffffff,#ffffff,#ffffff,#dd2d22\rp:Violet Laser Portal	Energy beams. No trespassers!	25		s	scifiport*9	0	1,1	3 violet_laser	#ffffff,#7733ff,#ffffff,#ffffff,#ffffff,#7733ff\rp:Purple Laser Portal	Energy beams. No trespassers!	25		s	scifiport*8	0	1,1	3 purple_laser	#ffffff,#bb55cc,#ffffff,#ffffff,#ffffff,#bb55cc\rp:Turquoise Laser Portal	Energy beams. No trespassers!	25		s	scifiport*7	0	1,1	3 Turquoise_Laser	#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc\rp:White Laser Portal	Energy beams. No trespassers!	25		s	scifiport*6	0	1,1	3 white_laser	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:Black Laser Portal	Energy beams. No trespassers!	25		s	scifiport*5	0	1,1	3 black_laser	#ffffff,#555555,#ffffff,#ffffff,#ffffff,#555555\rp:Pink Laser Portal	Energy beams. No trespassers!	25		s	scifiport*4	0	1,1	3 pink_laser	#ffffff,#ff5577,#ffffff,#ffffff,#ffffff,#ff5577\rp:Jade Laser Portal	Energy beams. No trespassers!	25		s	scifiport*3	0	1,1	3 jade_laser	#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70\rp:Blue Laser Portal	Energy beams. No trespassers!	25		s	scifiport*2	0	1,1	3 blue_laser	#ffffff,#5599ff,#ffffff,#ffffff,#ffffff,#5599ff\rp:Yellow Laser Door	Energy beams. No trespassers!	25		s	scifiport*1	0	1,1	3 yellow_laser	#ffffff,#ffbc00,#ffffff,#ffffff,#ffffff,#ffbc00\rp:Blue Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 blue_marquee #ffffff,#ffffff,#ffffff,#719EFD\rp:Aqua Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 aqua_marquee	#ffffff,#ffffff,#ffffff,#68DADA\rp:Red Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 red_marquee	#ffffff,#ffffff,#ffffff,#C60000\rp:Purple Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 purple_marquee	#ffffff,#ffffff,#ffffff,#D600E2\rp:Pink Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 pink_marquee	#ffffff,#ffffff,#ffffff,#FF798F\rp:Navy Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 navy_marquee	#ffffff,#ffffff,#ffffff,#004AA0\rp:White Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 white_marquee	#ffffff,#ffffff,#ffffff,#ffffff\rp:Graphite Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 graphite_marquee	#ffffff,#ffffff,#ffffff,#707070\rp:Black Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono	#ffffff,#333333,#333333,#333333,#ffffff\rp:Blue Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_blue	#ffffff,#4488ff,#4488ff,#4488ff,#ffffff\rp:Pink Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_pink	#ffffff,#ffaaaa,#ffaaaa,#ffaaaa,#ffffff\rp:Aqua Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_aqua	#ffffff,#aaffff,#aaffff,#aaffff,#ffffff\rp:White Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_white	#ffffff,#ffffff,#ffffff, #ffffff,#ffffff\rp:Sky Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_sky	#ffffff,#aaccff,#aaccff,#aaccff,#ffffff\rp:Jade Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_jade	#ffffff,#99dd77,#99dd77,#99dd77,#ffffff\rp:Purple Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_purple	#ffffff,#ff99cc,#ff99cc,#ff99cc,#ffffff\rp:Violet Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_violet	#ffffff,#bb99ff,#bb99ff,#bb99ff,#ffffffp:Yellow Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_yellow	#ffffff,#ffee66,#ffee66,#ffee66,#ffffff\rp:Pink Oriental screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 pink_screen	#ffffff,#ffffff,#FFA795,#FFA795,#ffffff,#ffffff\rp:Purple Oriental Screen	Adds an exotic vibe to any room	  25		s	wooden_screen*7	0	1,2	3 purple_screen	#ffffff,#ffffff,#DA2591,#DA2591,#ffffff,#ffffff\rp:Teal Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 teal_screen	#ffffff,#ffffff,#004B5E,#004B5E,#ffffff,#ffffff\rp:Gray Oriental Screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 gray_screen	#ffffff,#ffffff,#778B61,#778B61,#ffffff,#ffffff\rp:Green Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 green_screen	ffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff\rp:Golden Oriental Screen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 golden_screen	#ffffff,#ffffff,#F7B800,#F7B800,#ffffff,#ffffff\rp:Blue Oriental Screen 	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 blue_screen	#ffffff,#ffffff,#72B6D1,#72B6D1,#ffffff,#ffffff\rp:Aqua Oriental Screen  	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 aqua_screen	#ffffff,#ffffff,#79E4B3,#79E4B3,#ffffff,#ffffff\rp:Turquoise Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 turquoise_pillow	#63C9A0,#63C9A0,#ffffff,#ffffff\rp:Blue Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 blue_pillow	#5DAAC9,#5DAAC9,#ffffff,#ffffff\rp:Pink Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 pink_pillow	#FF8888,#FF8888,#ffffff,#ffffff\rp:Navy Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 navy_pillow	#214E68,#214E68,#ffffff,#ffffff\rp:Black Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 black_pillow	#494D29,#494D29,#ffffff,#ffffff\rp:Aqua Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 aqua_rocket	#ffffff,#ffffff,#00cccc,#ffffff\rp:Red Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 red_rocket	#ffffff,#ffffff,#dd2d22,#ffffff\rp:Purple Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 purple_rocket	#ffffff,#ffffff,#bb55cc,#ffffff\rp:Violet Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 violet_rocket	#ffffff,#ffffff,#7733ff,#ffffff\rp:Pink Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 pink_rocket	#ffffff,#ffffff,#ff5577,#ffffff\rp:Jade Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 jade_rocket	#ffffff,#ffffff,#02bb70,#ffffff\rp:Blue Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 blue_rocket	#ffffff,#ffffff,#5599ff,#ffffff\rp:Yellow Smoke Machine	Retro-mystification	25		s	scifirocket*1	0	1,1	3 yellow_rocket	#ffffff,#ffffff,#ffbc00,#ffffff\rp:Purple Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 purple_fan	#C05DFF,0,0,0\rp:Brown Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 brown_fan	#97420C,0,0,0\rp:Ochre Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 ochre_fan	#FF8000,0,0,0\rp:Fucsia Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 fucsia_fan	#FF60B0,0,0,0\rp:Yellow Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 yellow_fan	#E1CC00,0,0,0\rp:Blue Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 blue_fan	#3C75FF,0,0,0\rp:Turquoise  Powered Fan	Itll blow you away!	25		s	rare_fan*2	1	1,1	3 turquoise_fan	#00E5E2,0,0,0\rp:Greek Pillar	Classy architect, for holding up ceilings!	25		s	pillar*0	1	1,1	3 greek_pillar	#ffffff,#ffffff,#ffffff\rp:Atlantean Pillar	Recovered from Habblantis	25		s	pillar*7	1	1,1	3 atlant_pillar	#ffffff,#e3ca0e,#e3ca0e\rp:Terracotta Pillar	Ancient and stately	25		s	pillar*6	1	1,1	3 terra_pillar	#ffffff,#972e2a,#972e2a\rp:Rock Pillar	Classy architect, for holding up ceilings!	25		s	pillar*9	1	1,1	3 rock_pillar	#ffffff,#B2A69D,#B2A69D\rp:Olive Green Pillar	Classy architect, for holding up ceilings!	25		s	pillar*8	1	1,1	3 olive_pillar	#ffffff,#9A924B,#9A924B\rp:Wood Pillar	Classy architect, for holding up ceilings!	25		s	pillar*2	1	1,1	3 wood_pillar	#ffffff,#7B5922,#7B5922\rp:Green Pillar	Classy architect, for holding up ceilings!	25		s	pillar*5	1	1,1	3 green_pillar	#ffffff,#CEDD65,#CEDD65\rp:Graphite Pillar	Classy architect, for holding up ceilings!	25		s	pillar*4	1	1,1	3 graphite_pillar	#ffffff,#71797C,#71797C\rp:Pink Pillar	Classy architect, for holding up ceilings!	25		s	pillar*0	1	1,1	3 pink_pillar	#ffffff,#FFD0D2,#FFD0D2p:Blue Pillar	Ancient and stately	25		s	pillar*3	0	1,1	3 blue_pillar	#ffffff,#BDCDEA,#BDCDEA\rp:Grand Piano	Grand Piano	5		s	grand_piano*1	0	2,2	a0 black_piano	#fffffff,#2F2F2F,#ffffff\rp:Grand Piano	Grand Piano	5		s	grand_piano*1	0	2,2	a0 white_piano	#fffffff,#ffffff,#ffffff\rp:Black Pianochair	Black Pianochair	3		s	romantique_pianochair	0	1,1	a0 pianochair2	#fffffff,#2F2F2F,#ffffff\rp:White Pianochair	White Pianochair	3		s	romantique_pianochair	0	1,1	a0 pianochair3	#fffffff,#ffffff,#ffffff\r');
INSERT INTO `catalogue` VALUES ('Rares', 'i:Rares\rn:Rares\rl:ctlg_layout2\rt1:Rare txt\rg:catalog_rares_headline1\rh:Welcome to the rares page. Here you can buy any rare for just a few credits!\rw:\re:catalog_presents_teaser2,\rp:Throne	Important Habbos only	25		s	throne	0	1,1	5 throne	0,0,0\rp:Dragon Egg	The stuff of legend	25		s	spyro	0	1,1	10 dino	0,0,0\rp:Typewriter	Write that bestseller	25		s	typingmachine	0	1,1	7 typo	0,0,0\rp:Gold Trophy	Gorgeously glittery	25		s	prize1	2	1,1	5 prize1	0,0,0\rp:Silver Trophy	Nice and shiny	25		s	prize2	0	1,1	4 prize2	0,0,0\rp:Bronse Trophy	A weighty award	25		s	prize3	0	1,1	3 prize3	0,0,0\rp:Petal Patch	A little bit of outdoors indoors...	25		s	rare_daffodil_rug	0	2,2	3 petal	0,0,0\rp:Habbo Turntable	For the retro music-lover	25		s	djesko_turntable	0	1,1	6 djdecks	0,0,0\rp:Holopod	As if by magic...	25		s	hologram	0	1,1	3 holoboy	0,0,0\rp:Holo-girl	Youre her only hope...	25		s	redhologram	0	1,1	3 hologirl	0,0,0\rp:Russian Samovar	Click for a refreshing cuppa	25		s	samovar	0	1,1	5 samovar	0,0,0\rp:Habbo Cola Machine	A sparkling and refreshing pixel drink!	25		s	md_limukaappi	0	1,1	3 cola	0,0,0\rp:Fire Dragon Lamp	Scary & Scorching!	25		s	rare_dragonlamp*0	0	1,1	3 drag1	#ffffff,#fa2d00,#fa2d00\rp:Sea Dragon Lamp	Out of the deepes blue sea	25		s	rare_dragonlamp*1	0	1,1	3 drag2	#ffffff,#3470ff,#3470ff\rp:Jade Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*2	0	1,1	3 drag3	#ffffff,#02bb70,#02bb70\rp:Silver Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*3	0	1,1	3 drag4	#ffffff,#ffffff,#ffffff\rp:Black Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*4	0	1,1	3 drag5	#ffffff,#3e3d40,#3e3d40\rp:Elf Green Dragon Lamp	Roast your chestnuts here!	25		s	rare_dragonlamp*5	0	1,1	3 drag6	#ffffff,#589a03,#589a03\rp:Gold Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*6	0	1,1	3 drag7	#ffffff,#ffbc00,#ffbc00\rp:Sky Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*7	0	1,1	3 drag8	#ffffff,#83aeff,#83aeff\rp:Bronze Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*8	0	1,1	3 drag9	#ffffff,#ff5f01,#ff5f01\rp:Purple Dragon Lamp	Scary and scorching!	25		s	rare_dragonlamp*9	0	1,1	3 drag10	#FFFFFF,#B357FF,#B357FF\rp:Disco Sign	Serious partying going on!	15		i	poster 56			poster 56	\rp:Blue Bear Rug	Snuggle up on a Funky bear rug...	10		s	carpet_polar*2	0	2,3	A2 blue_bear	#ccddff,#ccddff,#ffffff\rp:Green Bear Rug	Snuggle up on a Funky bear rug...	10		s	carpet_polar*4	0	2,3	A2 green_bear	#ddffaa,#ddffaa,#ffffff\rp:Yellow Bear Rug	Snuggle up on a Funky bear rug...	10		s	carpet_polar*3	0	2,3	A2 yellow_bear	#ffee99,#ffee99,#ffffff\rp:Aloe Vera	Goodbye Bert...	25		s	plant_cruddy	0	1,1	5 plant_cruddy	0,0,0\rp:Hammock	Eco bed	25		s	rare_hammock	0	1,3	5 rare_hammock	0,0,0\rp:Holiday Romance	Peep through and smile!	25		s	valentinescreen	0	2,1	5 valentinescreen	0,0,0\rp:Lappland Greetings	Ho Ho Ho!	25		s	rare_xmas_screen	0	2,1	5 rare_xmas_screen	0,0,0\rp:Green Parasol	Block those rays!	25		s	rare_parasol*0	0	1,1	5 green_para	#ffffff,#ffffff,#ffffff,#94f718\rp:Yellow Parasol	Block those rays!	25		s	rare_parasol*1	0	1,1	5 yellow_para	#ffffff,#ffffff,#ffffff,#ffff11\rp:Violet Parasol	Block those rays!	25		s	rare_parasol*3	0	1,1	5 violet_para	#ffffff,#ffffff,#ffffff,#d47fff\rp:Orange Parasol	Block those rays!	25		s	rare_parasol*2	0	1,1	5 orange_para	#ffffff,#ffffff,#ffffff,#ff8f61\rp:Bird Bath (green)	For our feathered friends	25		s	rare_fountain*2	0	1,1	5 green_bath	#ffffff,#ffffff,#b8cf00\rp:Bird Bath (grey)	For our feathered friends	25		s	rare_fountain*1	0	1,1	5 grey_bath	#ffffff,#ffffff,#ffffff\rp:Bird Bath (red)	For our feathered friends	25		s	rare_fountain	0	1,1	5 red_bath	#ffffff,#ffffff,#ef5a5a\rp:Bird Bath (blue)	For our feathered friends	25		s	rare_fountain*3	0	1,1	5 blue_bath	#ffffff,#ffffff,#52bdbd\rp:Golden Elephant	Say hello to Nelly	25		s	rare_elephant_statue	0	1,1	5 gold_elephant	#ffffff,#ffcc00\rp:Silver Elephant	Say hello to Nelly	25		s	rare_elephant_statue*1	0	1,1	5 silver_elephant	#ffffff,#bfbfbf\rp:Bronze Elephant	Say hello to Nelly	25		s	rare_elephant_statue*2	0	1,1	5 bronze_elephant	#ffffff,#cc6600\rp:Blue Amber Lamp	A honey-hued glow	25		s	rare_beehive_bulb	0	1,1	5 blue_amber	#ffffff,#ffffff,#ffffff,#ffffff,#55c4de,#ffffff\rp:Red Amber Lamp	A honey-hued glow	25		s	rare_beehive_bulb*1	0	1,1	5 red_amber	#ffffff,#ffffff,#ffffff,#ffffff,#de5555,#ffffff\rp:Yellow Amber Lamp	A honey-hued glow	25		s	rare_beehive_bulb*2	0	1,1	5 yellow_amber	#ffffff,#ffffff,#ffffff,#ffffff,#ffcc00,#ffffff\rp:Speakers Corner	Stand and Deliver!	25		s	rare_stand	0	1,1	5 speaker	0,0,0\rp:Snow Globe	Its all white..	25		s	rare_globe	0	1,1	5 rare_globe	0,0,0\rp:Red Silk Pillow	Puffy, soft and huge	25		s	pillow*2	1	1,1	3 red_pillow	#ef0000,#ffffff,#ffffff\rp:Green Wooly Pillow	Puffy, soft and VERY fluffy!	25		s	pillow*2	1	1,1	3 green_pillow	#b8ff4a,#ffffff,#ffffff\rp:White Lace Pillow	Minimalist comfort!	25		s	pillow*0	1	1,1	3 white_pillow	#ffffff,#ffffff,#ffffff\rp:Bonnie’s Pillow	For Habbo Stars only!	25		s	pillow*7	1	1,1	3 bonnie_pillow	#e431c9,#ffffff,#ffffff\rp:Gold Feather Pillow	Puffy, soft and huge	25		s	pillow*4	1	1,1	3 gold_pillow	#ffbd10,#ffffff,#ffffff\rp:Gold Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*5	1	1,1	3 gold_ice	#FFFFFF,#E1CC00\rp:Purple Ice Cream Maker	Virtual vanilla rocks!	25		s	rare_icecream*3	1	1,1	3 purple_ice	#FFFFFF,#B357FF\rp:White Oriental Screen	Add an exotic touch to your room	25		s	wooden_screen*0	1	1,2	3 white_screen	#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\rp:RosewoodScreen	Add an exotic touch to your room	25		s	wooden_screen*2	1	1,2	3 rosewood_screen	#ffffff,#ffffff,#bb0000,#bb0000,#ffffff,#ffffff\rp:Yellow Marquee	Its both door and a shade!	25		s	marquee*4	1	1,1	3 yellow_marquee	#ffffff,#ffffff,#ffffff,#efbf00\rp:Green Marquee	Its both door and a shade!	25		s	marquee*9	1	1,1	3 green_marquee	#ffffff,#ffffff,#ffffff,#89ca35\rp:Alien Artifact  # 1337	From the unknown depths of space	25		s	scifirocket*5	1	1,1	3 1337_rocket	#ffffff,#ffffff,#555555,#ffffff\rp:White Smoke Machine	High technology in a retro frame	25		s	scifirocket*6	1	1,1	3 white_rocket	#ffffff,#ffffff,#ffffff,#ffffff\rp:Black Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono	#ffffff,#333333,#333333,#333333,#ffffff\rp:Greek Pillar	Classy architect, for holding up ceilings!	25		s	pillar*0	1	1,1	3 greek_pillar	#ffffff,#ffffff,#ffffff\rp:Atlantean Pillar	Recovered from Habblantis	25		s	pillar*7	1	1,1	3 atlant_pillar	#ffffff,#e3ca0e,#e3ca0e\rp:Terracotta Pillar	Ancient and stately	25		s	pillar*6	1	1,1	3 terra_pillar	#ffffff,#972e2a,#972e2a\rp:Festive Fan	As red as Rudolphs nose	25		s	rare_fan*0	1	1,1	3 fest_fan	#F43100,0,0,0\rp:SUPERLOVE Fan	Fanning the fires of SUPERLOVE...	25		s	rare_fan*4	1	1,1	3 love_fan	#e78b8b,0,0,0\rp:Snow Rug	Lets get sporty!	25		s	rare_snowrug	0	2,2	3 snow	0,0,0\rp:Moon Rug	Made in 1969	25		s	rare_moonrug	0	2,2	3 moon	0,0,0\rp:Jamaican Sand Patch	Your own paradise island	25		s	sandrug	0	2,2	3 sand	0,0,0\rp:Infobus	The Special Infobus Poster	15		i	poster 2005			poster 2005	\rp:Red Laser Door	Energy beams. No trespassers!	25		s	scifiport*0	1	1,1	3 red_laser	#ffffff,#d02a1f,#ffffff,#ffffff,#ffffff,#d02a1f\rp:Yellow Laser Door	Energy beams. No trespassers!	25		s	scifiport*1	1	1,1	3 yellow_laser	#ffffff,#f1b000,#ffffff,#ffffff,#ffffff,#f1b000\rp:White Habbo Roller	The power of movement	7		s	queue_tile1*0	0	1,1	a4 queue_white	#ffffff,#ffffff,#ffffff,#ffffff\rp:Aqua Habbo Roller	The power of movement	7		s	queue_tile1*3	0	1,1	a4 queue_aqua	#ffffff,#67c39c,#ffffff,#ffffff\rp:Inflatable Chair	Soft and tearproof!	25		s	rubberchair	0	1,1	5 rubber_chair	#CFCFCF,0,0\rp:Sleeping bag	Ultimate Coziness	25		s	sleepingbag	0	1,3	5 sleepingbag	#BB5F54,0,#BB5F54,0,#BB5F54\rp:Road Barrier	No trespassing, please!	25		s	barrier	0	1,2	5 barrier	0,0,#FFC927,#FFC927\rp:Traffic Lights	Chill and wait your turn	25		s	traffic_light	0	1,1	5 traffic_light	0,#D91E26,0\rp:Solarium	Rejuvenate your pixels!	25		s	solarium_norja	0	1,1	5 solarium_norja	0,#E2DAAC\rp:Red Monolith	Monolith goes up! Monolith goes down!	25		s	scifidoor*6	1	1,1	3 mono_red	#ffffff,#8B0F01,#8B0F01,#8B0F01,#ffffff\rp:Area Master Desk	For the true Habbo Scholars	3		s	silo_studydesk	0	2,1	3 silo_studydesk	0,0\rp:Maze Shrubbery Gate	Lol maze.	7		s	plant_mazegate	0	2,1	a4 mazegate	#ffffff,#ffffff,#ffffff,#ffffff\rp:Maze Shrubbery Thing	Lol maze.	7		s	plant_maze	0	2,1	a4 maze	#ffffff,#ffffff,#ffffff,#ffffff\rp:Bulrushes	All nature n stuff...	7		s	plant_bulrush	0	1,1	a4 bulrush	#ffffff,#ffffff,#ffffff,#ffffff\rp:Habbowood Chair	Habbowood Chair	25		s	habbowood_chair	0	1,1	a9 habbowood_chair	0,0,0\rp:Grand Piano White	Classical	5		s	grand_piano*1	0	2,2	a0 grand_piano_white	#ffffff,#ffffff,#ffffff\rp:Grand Piano Black	Classical	5		s	grand_piano*1	0	2,2	a0 grand_piano_black	#ffffff,#282828,#ffffff\rp:White Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 pianochair3	#ffffff,#ffffff,#ffffff\rp:Black Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 pianochair2	#ffffff,#1C1C1C,#ffffff\rp:Red Rose	Red rose	3		s	plant_valentinerose*1	0	1,1	a2 rose_red	#FFFFFF,#FF0000,#99CCFF\rp:White Rose	White rose	3		s	plant_valentinerose*2	0	1,1	a2 rose_white	#FFFFFF,#FFFFFF,#99CCFF\rp:Yellow Rose	Yellow Rose	3		s	plant_valentinerose*3	0	1,1	a2 rose_yellow	#FFFFFF,#FFD700,#99CCFF\rp:Pink Rose	Pink rose	3		s	plant_valentinerose*4	0	1,1	a2 rose_pink	#FFFFFF,#FF1493,#99CCFF\rp:Purple Rose	Purple Rose	3		s	plant_valentinerose*5	0	1,1	a2 rose_violet	#FFFFFF,#FF00FF,#99CCFF\rp:Grand Piano Grey	Classical	5		s	grand_piano*1	0	2,2	a0 grand_piano_grey	#ffffff,#666666,#ffffff\rp:Grand Piano Lime	Classical	5		s	grand_piano*1	0	2,2	a0 grand_piano_lime	#ffffff,#80AF52,#ffffff\rp:Grand Piano Cream	Classical	5		s	grand_piano*1	0	2,2	a0 grand_piano_cream	#ffffff,#DCCAAF,#ffffff\rp:Grey Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 grey_piano_stool	#ffffff,#666666,#ffffff\rp:Lime Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 lime_piano_stool	#ffffff,#80AF52,#ffffff\rp:Cream Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 cream_piano_stool	#ffffff,#DCCAAF,#ffffff\rp:Black Piano Stool	Elegant	3		s	romantique_pianochair	0	1,1	a0 black_piano_stool	#ffffff,#1C1C1C,#ffffff\rp:Chocolate Dragon Lamp	Scary & Scorching!	25		s	rare_dragonlamp*9	0	1,1	3 choc_drag	#ffffff,#996633,#996633\rp:Man Eating Plant	How do you give it water?	25		s	rare_mnstr	0	1,1	A2 rare_mnstr	0,0,0\rp:Aqua Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_aqua	#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2\rp:Pink Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_pink	#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC\rp:Black Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_black	#ffffff,#ffffff,#ffffff,#ffffff,#525252\rp:White Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_white	#ffffff,#ffffff,#ffffff,#FFFFFF,#ffffff\rp:Beige Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_beige	#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC\rp:Blue Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_blue	#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8\rp:Green Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_green	#ffffff,#ffffff,#ffffff,#ffffff,#92D13D\rp:Yellow Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_yellow	#ffffff,#ffffff,#ffffff,#ffffff,#FFD837\rp:Red Deck Chair	Enjoy the sun!	5		s	summer_chair*1	0	1,1	A1 summer_chair_red	#ffffff,#ffffff,#ffffff,#ffffff,#E14218\rp:Blue BBQ	Dont let it burn!	10		s	summer_grill*1	0	2,1	A2 summer_grill_blue	#ffffff,#5EAAF8,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8\rp:Red BBQ	Dont let it burn!	10		s	summer_grill*1	0	2,1	A2 summer_grill_red	#ffffff,#E14218,#ffffff,#ffffff,#E14218,#E14218,#E14218\rp:Green BBQ	Dont let it burn!	10		s	summer_grill*1	0	2,1	A2 summer_grill_green	#ffffff,#92D13D,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D\rp:Yellow BBQ	Dont let it burn!	10		s	summer_grill*1	0	2,1	A2 summer_grill_yellow	#ffffff,#FFD837,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837\rp:Disco Rug	Wow	5		s	exe_rug	0	3,3	A1 exe_rug	0,0,0\rp:Light up Table	Turn on the light!	4		s	exe_s_table	0	2,2	a2 exe_s_table	0,0,0\rp:Star Tile	For your own Hall of Fame!	1		s	tile_stella	0	1,1	A1 tile_stella	0,0,0\rp:Marmer Tile	For your own Hall of Fame!	1		s	tile_marble	0	1,1	A1 tile_marble	0,0,0\rp:Brown Tile	For your own Hall of Fame!	1		s	tile_brown	0	1,1	A1 tile_brown	0,0,0\rp:Sound Set 29	null	5		s	sound_set_29	0	1,1	A1 sound_set29	0,0,0\rp:Sound Set 30	null	5		s	sound_set_30	0	1,1	A1 sound_set30	0,0,0\rp:Sound Set 31	null	5		s	sound_set_31	0	1,1	A1 sound_set31	0,0,0\rp:Sound Set 32	null	5		s	sound_set_32	0	1,1	A1 sound_set32	0,0,0\rp:Sound Set 33	null	5		s	sound_set_33	0	1,1	A1 sound_set33	0,0,0\rp:Sound Set 34	null	5		s	sound_set_34	0	1,1	A1 sound_set34	0,0,0\rp:Sound Set 35	null	5		s	sound_set_35	0	1,1	A1 sound_set35	0,0,0\rp:Sound Set 36	null	5		s	sound_set_36	0	1,1	A1 sound_set36	0,0,0');
INSERT INTO `furniture_template` VALUES ('1337', 'scifirocket*5', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('1337_rocket', 'scifirocket*5', '11#ffffff,#ffffff,#555555,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('A1P', 'table_plasto_4leg*1', '22#ffffff,#ff1f08', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A2P', 'table_plasto_4leg*6', '22#ffffff,#3444ff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A3P', 'table_plasto_4leg*5', '22#ffffff,#54ca00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A4P', 'table_plasto_4leg*2', '22#ffffff,#99DCCC', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A5P', 'table_plasto_4leg*3', '22#ffffff,#ffee00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A6P', 'table_plasto_4leg*7', '22#ffffff,#ff6d00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A7P', 'table_plasto_4leg*8', '22#ffffff,#c38d1a', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('A9P', 'table_plasto_4leg*9', '22#ffffff,#533e10', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('AHP', 'table_plasto_4leg', '220,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('AMME', 'bath', '120,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('ANANAS', 'plant_pineapple', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('aqua_chair', 'chair_plasto*14', '11#ffffff,#3CB4F0,#ffffff,#3CB4F0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('aqua_ice', 'rare_icecream*8', '11#FFFFFF,#00E5E2,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('aqua_marquee', 'marquee*3', '11#ffffff,#ffffff,#ffffff,#68DADA', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('aqua_rocket', 'scifirocket*7', '11#ffffff,#ffffff,#00cccc,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('aqua_screen', 'wooden_screen*3', '12#ffffff,#ffffff,#79E4B3,#79E4B3,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('aqua_table', 'table_plasto_4leg*14', '22#ffffff,#3CB4F0,#ffffff,#3CB4F0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area', 'table_plasto_4leg*14', '22#ffffff,#3CB4F0,#ffffff,#3CB4F0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_chair_beige', 'sofachair_silo*4', '11#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_black', 'sofachair_silo*2', '11#ffffff,#ffffff,#525252,#525252', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_blue', 'sofachair_silo*6', '11#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_green', 'sofachair_silo*7', '11#ffffff,#ffffff,#92D13D,#92D13D', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_pink', 'sofachair_silo*5', '11#ffffff,#ffffff,#FF99BC,#FF99BC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_red', 'sofachair_silo*9', '11#ffffff,#ffffff,#E14218,#E14218', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_white', 'sofachair_silo*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_chair_yellow', 'sofachair_silo*8', '11#ffffff,#ffffff,#FFD837,#FFD837', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_corner_beige', 'divider_silo1*4', '11#ffffff,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_black', 'divider_silo1*2', '11#ffffff,#525252', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_blue', 'divider_silo1*6', '11#ffffff,#5EAAF8', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_green', 'divider_silo1*7', '11#ffffff,#92D13D', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_pink', 'divider_silo1*5', '11#ffffff,#FF99BC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_red', 'divider_silo1*9', '11#ffffff,#E14218', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_white', 'divider_silo1*3', '11#ffffff,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_corner_yellow', 'divider_silo1*8', '11#ffffff,#FFD837', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_beige', 'divider_silo3*4', '11#ffffff,#ffffff,#ffffff,#F7EBBC', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_black', 'divider_silo3*2', '11#ffffff,#ffffff,#ffffff,#525252', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_blue', 'divider_silo3*6', '11#ffffff,#ffffff,#ffffff,#5EAAF8', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_green', 'divider_silo3*7', '11#ffffff,#ffffff,#ffffff,#92D13D', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_pink', 'divider_silo3*5', '11#ffffff,#ffffff,#ffffff,#FF99BC', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_red', 'divider_silo3*9', '11#ffffff,#ffffff,#ffffff,#E14218', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_white', 'divider_silo3*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_gate_yellow', 'divider_silo3*8', '11#ffffff,#ffffff,#ffffff,#FFD837', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('area_sofa_beige', 'sofa_silo*4', '21#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_black', 'sofa_silo*2', '21#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_blue', 'sofa_silo*6', '21#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_green', 'sofa_silo*7', '21#ffffff,#ffffff,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D,#92D13D', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_pink', 'sofa_silo*5', '21#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC,#FF99BC,#FF99BC,#FF99BC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_red', 'sofa_silo*9', '21#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_white', 'sofa_silo*3', '21#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_sofa_yellow', 'sofa_silo*8', '21#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_beige', 'table_silo_small*4', '11#ffffff,#F7EBBC', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_black', 'table_silo_small*2', '11#ffffff,#525252', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_blue', 'table_silo_small*6', '11#ffffff,#5EAAF8', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_green', 'table_silo_small*7', '11#ffffff,#92D13D', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_pink', 'table_silo_small*5', '11#ffffff,#FF99BC', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_red', 'table_silo_small*9', '11#ffffff,#E14218', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_white', 'table_silo_small*3', '11#ffffff,#ffffff', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stable_yellow', 'table_silo_small*8', '11#ffffff,#FFD837', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('area_stool_beige', 'chair_silo*4', '11#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_black', 'chair_silo*2', '11#ffffff,#ffffff,#525252,#525252', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_blue', 'chair_silo*6', '11#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_green', 'chair_silo*7', '11#ffffff,#ffffff,#92D13D,#92D13D', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_pink', 'chair_silo*5', '11#ffffff,#ffffff,#FF99BC,#FF99BC', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_red', 'chair_silo*9', '11#ffffff,#ffffff,#E14218,#E14218', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_white', 'chair_silo*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_stool_yellow', 'chair_silo*8', '11#ffffff,#ffffff,#FFD837,#FFD837', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('area_table_beige', 'table_silo_med*4', '22#ffffff,#F7EBBC', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_black', 'table_silo_med*2', '22#ffffff,#525252', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_blue', 'table_silo_med*6', '22#ffffff,#5EAAF8', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_green', 'table_silo_med*7', '22#ffffff,#92D13D', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_pink', 'table_silo_med*5', '22#ffffff,#FF99BC', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_red', 'table_silo_med*9', '22#ffffff,#E14218', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_white', 'table_silo_med*3', '22#ffffff,#ffffff', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('area_table_yellow', 'table_silo_med*8', '22#ffffff,#FFD837', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('armdiv', 'divider_arm2', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('armkp', 'divider_arm1', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('armovi', 'divider_arm3', '110,0,0', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('atlant_pillar', 'pillar*7', '11#ffffff,#e3ca0e,#e3ca0e', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('aurinko', 'plant_sunflower', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('B1P', 'table_plasto_square*1', '11#ffffff,#ff1f08', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B2P', 'table_plasto_square*6', '11#ffffff,#3444ff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B3P', 'table_plasto_square*5', '11#ffffff,#54ca00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B4P', 'table_plasto_square*2', '11#ffffff,#99DCCC', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B5P', 'table_plasto_square*3', '11#ffffff,#ffee00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B6P', 'table_plasto_square*7', '11#ffffff,#ff6d00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B7P', 'table_plasto_square*8', '11#ffffff,#c38d1a', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B8P', 'table_plasto_square*4', '11#ffffff,#ccddff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('B9P', 'table_plasto_square*9', '11#ffffff,#533e10', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('BAA', 'bar_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('baba', 'bar_basic', '110,0,0', 'solid', 'HTRUE', '0');
INSERT INTO `furniture_template` VALUES ('barchair_silo', 'barchair_silo', '110,#A2C6C8,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_beige', 'barchair_silo', '110,#D0C6A5,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_black', 'barchair_silo', '110,#4C4C4C,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_blue', 'barchair_silo', '110,#9FC2C4,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_green', 'barchair_silo', '110,#73A531,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_pink', 'barchair_silo', '110,#DE7599,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_red', 'barchair_silo', '110,#D23D16,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('barchair_silo_yellow', 'barchair_silo', '110,#EFC933,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('bardeskcornerhc', 'bardeskcornerhc', '110,#8FAEB0,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('bardeskhc', 'bardeskhc', '210,0,#8FAEB0,#8FAEB0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('barrier', 'barrier', '120,0,#FFC927,#FFC927', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('basket', 'basket', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('batpost', 'poster_50', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bb', 'bb', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('bdrag', 'dragonlamp*1', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('beach', 'sandrug', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BHP', 'table_plasto_square', '110,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('birdie', 'birdie', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('BJA', 'bar_chair_armas', '110,0,0', 'sit', 'H', '1.4');
INSERT INTO `furniture_template` VALUES ('BKP', 'bardeskcorner_polyfon', '11#ffffff,#ABD0D2', 'solid', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('BKP_c', 'bardeskcorner_polyfon', '11#ffffff,#FF9BBD', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('Black_elephant', 'rare_elephant_statue*7', '11#ffffff,#000033', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('black_laser', 'scifiport*5', '11#ffffff,#333333,#ffffff,#ffffff,#ffffff,#333333', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('black_maj', 'black_maj', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('black_piano_stool', 'romantique_pianochair*5', '11#ffffff,#1C1C1C,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('black_pillow', 'pillow*5', '11#494D29,#494D29,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('black_throne', 'black_throne', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('blackarea', 'black_throne', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('blackdrag', 'dragonlamp*4', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('blackiced', 'dragonlamp*4', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('blackpod', 'chair_plasty*4', '11#ffffff,#333333,#ffffff,#333333', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('BLMP', 'lamp_basic', '110,0,0', 'solid', 'HTRUE', '0');
INSERT INTO `furniture_template` VALUES ('blue_amber', 'rare_beehive_bulb', '11#ffffff,#ffffff,#ffffff,#ffffff,#55c4de,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('blue_bath', 'rare_fountain*3', '11#ffffff,#ffffff,#52bdbd', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('blue_bear', 'carpet_polar*2', '23#ccddff,#ccddff,#ffffff', 'rug', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('blue_elephant', 'rare_elephant_statue*3', '11#ffffff,#52bdbd', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('blue_fan', 'rare_fan*1', '11#3C75FF,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blue_ice', 'rare_icecream*1', '11#FFFFFF,#55c4de', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('blue_laser', 'scifiport*2', '11#ffffff,#3470ff,#ffffff,#ffffff,#ffffff,#3470ff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blue_marquee', 'marquee*6', '11#ffffff,#ffffff,#ffffff,#719EFD', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blue_mono', 'scifidoor*7', '11#ffffff,#0077FF,#0077FF,#0077FF,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blue_pillar', 'pillar*3', '11#ffffff,#BDCDEA,#BDCDEA', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('blue_pillow', 'pillow*6', '11#5DAAC9,#5DAAC9,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('blue_rocket', 'scifirocket*9', '11#ffffff,#ffffff,#0077FF,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blue_screen', 'wooden_screen*6', '12#ffffff,#ffffff,#72B6D1,#72B6D1,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('bluearea', 'wooden_screen*6', '12#ffffff,#ffffff,#72B6D1,#72B6D1,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('bluehynacith', 'hyacinth2', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('blueiced', 'hyacinth2', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('bluelaser', 'scifiport*2', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('bluetraffic', 'traffic_light*2', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('BM1', 'carpet_standard*4', '35#777777', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM2', 'carpet_standard*1', '35#ff1f08', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM3', 'carpet_standard*4', '35#ccddff', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM4', 'carpet_standard*5', '35#ddccff', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM5', 'carpet_standard*2', '35#99DCCC', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM6', 'carpet_standard*3', '35#ffee00', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM7', 'carpet_standard', '350,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM8', 'carpet_standard*7', '35#99CCFF,#99CCFF,#99CCFF', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BM9', 'carpet_standard*8', '35#999966,#999966,#999966', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BMB', 'carpet_standard*a', '35#55AC00,#55AC00,#55AC00', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BMC', 'carpet_standard*b', '35#336666,#336666,#336666', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bonnie_pillow', 'pillow*7', '11#e431c9,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('BONSAI', 'plant_bonsai', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('bookcase', 'shelves_basic', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bpillow', 'pillow*5', '11#000000,#ffffff,#ffffff', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('brdrag', 'dragonlamp*8', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('brocket', 'scifirocket*3', '11#ffffff,#ffffff,#0000CC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bronze_elephant', 'rare_elephant_statue*2', '11#ffffff,#cc6600', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('brown_fan', 'rare_fan*7', '11#682B00,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('BTA', 'bartable_armas', '130,0,0', 'solid', 'HON', '1.4');
INSERT INTO `furniture_template` VALUES ('BTP', 'bardesk_polyfon', '21#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('BTP_c', 'bardesk_polyfon', '21#ffffff,#ffffff,#FF9BBD,#FF9BBD', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bulrush', 'plant_bulrush', '11#ffffff,#ffffff,#ffffff,#EECA23', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('bunny', 'bunny', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('BV1', 'doormat_plain*6', '11#777777', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV2', 'doormat_plain*1', '11#ff1f08', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV3', 'doormat_plain*4', '11#ccddff', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV4', 'doormat_plain*5', '11#ddccff', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV5', 'doormat_plain*2', '11#99DCCC', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV6', 'doormat_plain*6', '11#ffee00', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('BV7', 'doormat_plain*6', '110,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('C1P', 'table_plasto_round*1', '22#ffffff,#ff1f08', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C2P', 'table_plasto_round*6', '22#ffffff,#3444ff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C3P', 'table_plasto_round*5', '22#ffffff,#54ca00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C4P', 'table_plasto_round*2', '22#ffffff,#99DCCC', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C5P', 'table_plasto_round*3', '22#ffffff,#ffee00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C6P', 'table_plasto_round*7', '22#ffffff,#ff6d00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C7P', 'table_plasto_round*8', '22#ffffff,#c38d1a', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C8P', 'table_plasto_round*4', '22#ffffff,#ccddff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('C9P', 'table_plasto_round*9', '22#ffffff,#533e10', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('calsonic', 'calsonic', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('carpet_soft_tut', 'carpet_soft_tut', '110,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('carpet_valentine', 'carpet_valentine', '270,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('cbar', 'bardesk_polyfon', '21#ffffff,#ffffff,#FF9BBD,#FF9BBD', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ccbar', 'bardeskcorner_polyfon', '11#ffffff,#FF9BBD', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('CF_1_coin_bronze', 'CF_1_coin_bronze', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('CF_10_coin_gold', 'CF_10_coin_gold', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('CF_20_moneybag', 'CF_20_moneybag', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('CF_5_coin_silver', 'CF_5_coin_silver', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('CF_50_goldbar', 'CF_50_goldbar', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('CFC_100_gold_coin', 'CFC_100_gold_coin', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('CFC_100_moneybag_gold', 'CFC_100_moneybag_gold', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('CFC_200_moneybag', 'CFC_200_moneybag', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('CFC_500_goldbar', 'CFC_500_goldbar', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('cgate', 'divider_poly3', '11#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('chains', 'chain', '11#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('chair_china', 'chair_china', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('china_chair', 'chair_china', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('china_shelve', 'china_shelve', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('china_table', 'china_table', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('chinashelf', 'china_shelve', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('chinesechair', 'chair_china', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('chineselamp', 'cn_lamp', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('choc_drag', 'rare_dragonlamp*9', '110#FFFFFF,#996633,#996633', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('choco_ice', 'rare_icecream*7', '11#FFFFFF,#97420C,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('CHP', 'table_plasto_round', '220,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('classictraffic', 'traffic_light*1', '110,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('club_furni', 'traffic_light*1', '110,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('club_sofa', 'club_sofa', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('cn_book', 'china_shelve', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('cn_lamp', 'cn_lamp', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('cn_sofa', 'cn_sofa', '310,0,0', 'sit', 'HON', '1');
INSERT INTO `furniture_template` VALUES ('coinbronze', 'CF_1_coin_bronze', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('coingold', 'CF_10_coin_gold', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('coinsilver', 'CF_5_coin_silver', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('cola', 'md_limukaappi', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('Copy (2) of white_rose', 'plant_valentinerose*2', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('Copy of norovi', 'divider_nor3', '110,0,0', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('corner_china', 'corner_china', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('cornerstone', 'cornerstone', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('court', 'carpet_legocourt', '330,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('cream_piano_stool', 'romantique_pianochair*5', '11#ffffff,#DCCAAF,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('D1P', 'table_plasto_bigsquare*1', '22#ffffff,#ff1f08', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D2P', 'table_plasto_bigsquare*6', '22#ffffff,#3444ff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D3P', 'table_plasto_bigsquare*5', '22#ffffff,#54ca00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D4P', 'table_plasto_bigsquare*2', '22#ffffff,#99DCCC', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D5P', 'table_plasto_bigsquare*3', '22#ffffff,#ffee00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D6P', 'table_plasto_bigsquare*7', '22#ffffff,#ff6d00', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D7P', 'table_plasto_bigsquare*8', '22#ffffff,#c38d1a', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D8P', 'table_plasto_bigsquare*4', '22#ffffff,#ccddff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('D9P', 'table_plasto_bigsquare*9', '22#ffffff,#533e10', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('dafcola', 'md_dafcola', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dancetile', 'dancetile', '110,0,0', 'rug', 'H1', '1.1');
INSERT INTO `furniture_template` VALUES ('deadduck', 'deadduck', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('deadduck1', 'deadduck', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('deadduck2', 'deadduck2', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('deadduck3', 'deadduck3', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('deadyukka', 'plant_deadyukka', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('DHP', 'table_plasto_bigsquare', '220,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('dicey', 'edicehc', '110,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('DIGITV', 'tv_luxus', '130,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dino', 'spyro', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dinoblue', 'spyro', '110,#0000FF,#0000FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('divider_nor4', 'divider_nor4*9', '210,0,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_aqua', 'divider_nor4*9', '210,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_black', 'divider_nor4*9', '210,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_blue', 'divider_nor4*9', '210,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_green', 'divider_nor4*9', '210,0,#73A531,#73A531,#73A531,#73A531', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_pink', 'divider_nor4', '210,0,#DE7599,#DE7599,#DE7599,#DE7599', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_red', 'divider_nor4*9', '210,0,#D23D16,#D23D16,#D23D16,#D23D16', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor4_yellow', 'divider_nor4*9', '210,0,#EFC933,#EFC933,#EFC933,#EFC933', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5', 'divider_nor5*9', '110,#E2DAAC,#E2DAAC,#E2DAAC,#E2DAAC', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_aqua', 'divider_nor5*9', '110,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_black', 'divider_nor5*9', '110,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_blue', 'divider_nor5*9', '110,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_green', 'divider_nor5*9', '110,#73A531,#73A531,#73A531,#73A531', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_pink', 'divider_nor5', '110,#DE7599,#DE7599,#DE7599,#DE7599', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_red', 'divider_nor5*9', '110,#D23D16,#D23D16,#D23D16,#D23D16', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('divider_nor5_yellow', 'divider_nor5*9', '110,#EFC933,#EFC933,#EFC933,#EFC933', 'door', 'H', '1');
INSERT INTO `furniture_template` VALUES ('djdecks', 'djesko_turntable', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('djpanel', 'djpanel', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('drag1', 'rare_dragonlamp*0', '110#ffffff,#fa2d00,#fa2d00', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag10', 'rare_dragonlamp*9', '110#FFFFFF,#B357FF,#B357FF', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag11', 'rare_dragonlamp*10', '110#FFFFFF,#F5A0FF,#F5A0FF', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag12', 'rare_dragonlamp*11', '110#FFFFFF,#3fe5ff,#3fe5ff', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag2', 'rare_dragonlamp*1', '110#ffffff,#3470ff,#3470ff', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag3', 'rare_dragonlamp*2', '110#ffffff,#02bb70,#02bb70', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag4', 'rare_dragonlamp*3', '110#ffffff,#ffffff,#ffffff', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag5', 'rare_dragonlamp*4', '110#ffffff,#3e3d40,#3e3d40', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag6', 'rare_dragonlamp*5', '110#ffffff,#589a03,#589a03', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag7', 'rare_dragonlamp*6', '110#ffffff,#ffbc00,#ffbc00', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag8', 'rare_dragonlamp*7', '110#ffffff,#83aeff,#83aeff', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('drag9', 'rare_dragonlamp*8', '110#ffffff,#ff5f01,#ff5f01', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('dragblack', 'rare_dragonlamp*4', '11#0D0D0D,#0D0D0D', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragbronze', 'rare_dragonlamp*8', '110,#C74E00,#C74E00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('draggold', 'rare_dragonlamp*6', '110,#FFD400,#FFD400', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('draggreen', 'rare_dragonlamp*5', '110,#048A00,#048A00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragpink', 'rare_dragonlamp*1', '11#FF66FF,#FF66FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragpurple', 'rare_dragonlamp*9', '110,#AB00FF,#AB00FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragred', 'rare_dragonlamp*1', '110,#FF0000,#FF0000', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragsea', 'rare_dragonlamp*1', '110,#005FFF,#005FFF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragsky', 'rare_dragonlamp*7', '11#ffffff,#00ABFF,#00ABFF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('dragwhite', 'rare_dragonlamp*3', '11#C0C0C0,#C0C0C0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('drawer', 'drawer', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('drinks1', 'drinks1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('DRK', 'drinks', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('duck', 'duck', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('DVN', 'divider_nor4', '21#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('E1P', 'chair_plasto*1', '11#ffffff,#ff1f08,#ffffff,#ff1f08', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E2P', 'chair_plasto*6', '11#ffffff,#3444ff,#ffffff,#3444ff', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E3P', 'chair_plasto*5', '11#ffffff,#54ca00,#ffffff,#54ca00', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E4P', 'chair_plasto*2', '11#ffffff,#99DCCC,#ffffff,#99DCCc', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E5P', 'chair_plasto*3', '11#ffffff,#ffee00,#ffffff,#ffee00\r', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E6P', 'chair_plasto*7', '11#ffffff,#ff6d00,#ffffff,#ff6d00', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E7P', 'chair_plasto*8', '11#ffffff,#c38d1a,#ffffff,#c38d1a', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E8P', 'chair_plasto*4', '11#ffffff,#ccddff,#ffffff,#ccddff\r', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('E9P', 'chair_plasto*9', '11#ffffff,#533e10,#ffffff,#533e10', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('easterduck', 'easterduck', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('edicehc', 'edicehc', '110,0,0', 'solid', 'H0', '0');
INSERT INTO `furniture_template` VALUES ('EHP', 'chair_plasto', '110,0,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('electriccandles', 'triplecandle', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('exe_rug', 'exe_rug', '330,0,0', 'rug', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('exe_s_table', 'exe_s_table', '220,0,0', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('fanblack', 'rare_fan*7', '11#000000,#000000', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanblue', 'rare_fan*1', '11#0000FF,#0000FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fangreen', 'rare_fan*4', '11#00FF00,#00FF00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanlblue', 'rare_fan*1', '11#3399FF,#3399FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanorange', 'rare_fan*5', '11#FF9933,#FF9933', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanpink', 'rare_fan*7', '11#FF66FF,#FF66FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanpurple', 'rare_fan*7', '11#9900CC,#9900CC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanred', 'rare_fan*3', '11#FF0000,#FF0000', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('fanyellow', 'rare_fan*6', '11#FFFF00,#FFFF0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('FDG', 'fridge', '110,0,0', 'solid', 'HTRUE', '0');
INSERT INTO `furniture_template` VALUES ('fest_fan', 'rare_fan*0', '11#F43100,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('film', 'photo_film', '11#ffffff,#ffffff,#ffffff,#ffff11', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('FLIPnor', 'divider_nor5', '11#ffffff,#F7EBBC,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('floating', 'floating\r\n', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('football_lamp', 'footylamp', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('footylamp', 'footylamp', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('fucsia_fan', 'rare_fan*9', '11#FF60B0,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('Fucsia_ice', 'rare_icecream*9', '11#FFFFFF,#FF60B0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('Fullbluepillar', 'pillar*12', '11#0033FF,#0033FF,#0033FF', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('FullGoldPillar', 'pillar*10', '11#FFCC33,#FFCC33,#FFCC33', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('fullgreenpillar', 'pillar*13', '11#66FF33#66FF33,#66FF33,#66FF33', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('fullpinkpillar', 'pillar*11', '11#FF0099,#FF0099,#FF0099', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('gamingmachine', 'gamingmachine', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gate1', 'marquee*1', '110#fa2d00,#ffffff#,#fa2d00,#fa2d00,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate10', 'marquee*1', '110#B357FF,#ffffff#,#B357FF,#B357FF,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate2', 'marquee*2', '110#3470ff,#ffffff#,#3470ff,#3470ff,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate3', 'marquee*3', '110#02bb70,#ffffff#,#02bb70,#02bb70,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate4', 'marquee*4', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate5', 'marquee*5', '110#3e3d40,#ffffff#,#3e3d40,#3e3d40,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate6', 'marquee*6', '110#589a03,#ffffff#,#589a03,#589a03,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate7', 'marquee*7', '110#ffbc00,#ffffff#,#ffbc00,#ffbc00,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate8', 'marquee*8', '110#83aeff,#ffffff#,#83aeff,#83aeff,#ffffff#,#ffffff\r\n', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gate9', 'marquee*9', '110#ff5f01,#ffffff#,#ff5f01,#ff5f01,#ffffff#,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gbread1', 'house', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gbread2', 'house2', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gchair', 'gothic_chair*1', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('gdrag', 'dragonlamp*5', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gfountain', 'rare_fountain', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ghost', 'ghost', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('giftflowers', 'giftflowers', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('GIRLS1P', 'bed_polyfon_girl_one', '13#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('GIRLS2P', 'bed_polyfon_girl', '23#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('GIRLSHP', 'sofa_polyfon_girl', '21#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('GIRLSTP', 'sofachair_polyfon_girl', '11#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('glass_chair', 'glass_chair', '110,#C3C3C3,#C3C3C3', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_chair_1', 'glass_chair', '11#ffffff,#ABD0D2,#ABD0D2,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_chair_2', 'glass_chair', '11#ffffff,#5eaaf8,#5eaaf8,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_shelf', 'glass_shelf', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_sofa', 'glass_sofa', '210,#C3C3C3,#C3C3C3', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_sofa_1', 'glass_sofa', '21#ffffff,#ABD0D2,#ABD0D2,#ffffff,#ffffff,#ABD0D2,#ffffff,#ABD0D2', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_sofa_2', 'glass_sofa', '21#ffffff,#5eaaf8,#5eaaf8,#ffffff,#ffffff,#5eaaf8,#ffffff,#5eaaf8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_stool', 'glass_stool', '110,#C3C3C3,#C3C3C3', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_stool_1', 'glass_stool', '11#ffffff,#ABD0D2,#ABD0D2,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_stool_2', 'glass_stool', '11#ffffff,#5eaaf8,#5eaaf8,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_table', 'glass_table', '220,#C3C3C3,#C3C3C3', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_table_1', 'glass_table', '22#ffffff,#ABD0D2,#ABD0D2,#ffffff', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('glass_table_2', 'glass_table', '22#ffffff,#5eaaf8,#5eaaf8,#ffffff', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('goallight', 'hockey_light', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('godrag', 'dragonlamp*6', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gold_bath', 'rare_fountain*4', '11#ffffff,#ffffff,#ffcc00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gold_elephant', 'rare_elephant_statue', '11#ffffff,#ffcc00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gold_ice', 'rare_icecream*5', '11#FFFFFF,#E1CC00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gold_laser', 'scifiport*1', '11#ffffff,#f1b000,#ffffff,#ffffff,#ffffff,#f1b000', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('gold_mono', 'scifidoor*2', '11#ffffff,#f1b000,#f1b000,#f1b000,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('gold_pillow', 'pillow*4', '11#ffbd10,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('gold_rocket', 'scifirocket*1', '11#ffffff,#ffffff,#f1b000,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('goldbar', 'CF_50_goldbar', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('golden_screen', 'wooden_screen*4', '12#ffffff,#ffffff,#F7B800,#F7B800,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('goth_carpet', 'carpet_standard*5', '550,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('goth_table', 'goth_table', '150,0,0', 'solid', 'HON', '1');
INSERT INTO `furniture_template` VALUES ('gothgate', 'gothgate', '210,0,0', 'door', 'HON', '1.1');
INSERT INTO `furniture_template` VALUES ('gothic_carpet', 'gothic_carpet', '240,0,0', 'floor', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('gothic_carpet1', 'gothic_carpet', '240,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothic_carpet2', 'gothic_carpet2', '240,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothicbar', 'gothrailing', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothiccandelabra', 'gothiccandelabra', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothiccandle', 'gothiccandelabra', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothicchair', 'gothic_chair*3', '11#ffffff,#dd0000,#ffffff,#dd0000', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('gothicfountain', 'gothicfountain', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('gothicgate', 'gothgate', '210,0,0', 'door', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('gothicsofa', 'gothic_sofa*3', '21#ffffff,#dd0000,#ffffff,#ffffff,#dd0000,#ffffff', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('gothicstool', 'gothic_stool*3', '11#ffffff,#dd0000,#ffffff', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('gothrailing', 'gothrailing', '210,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('gothtable', 'goth_table', '150,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('grand_paino_black', 'grand_piano*3', '22#ffffff,#3e3d40,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_paino_black1', 'grand_piano*3', '22#ffffff,#1C1C1C,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano', 'grand_piano*3', '22#ffffff,#ff3366,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano_black', 'grand_piano*3', '22#ffffff,#282828,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano_cream', 'grand_piano*3', '22#ffffff,#DCCAAF,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano_grey', 'grand_piano*3', '22#ffffff,#666666,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano_lime', 'grand_piano*3', '22#ffffff,#80AF52,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano_white', 'grand_piano*3', '22#ffffff,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano2', 'grand_piano*2', '22#ffffff,#1C1C1C,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grand_piano3', 'grand_piano*3', '220#ffffff,#339999,#339999', 'solid', 'H1', '0');
INSERT INTO `furniture_template` VALUES ('graphite_marquee', 'marquee*5', '11#ffffff,#ffffff,#ffffff,#707070', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('graphite_pillar', 'pillar*4', '11#ffffff,#71797C,#71797C', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('gras', 'gras', '110,0,0', 'solid', 'HON', '1.0');
INSERT INTO `furniture_template` VALUES ('gray_screen', 'wooden_screen*5', '12#ffffff,#ffffff,#778B61,#778B61,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('greek_pillar', 'pillar*0', '11#ffffff,#ffffff,#ffffff', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('green_bath', 'rare_fountain*2', '11#ffffff,#ffffff,#b8cf00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('green_bear', 'carpet_polar*4', '23#ddffaa,#ddffaa,#ffffff', 'rug', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('Green_elephant', 'rare_elephant_statue*5', '11#ffffff,#66FF00', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('green_fan', 'rare_fan*2', '11#55CD01,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('green_ice', 'rare_icecream*2', '11#FFFFFF,#94f718', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('green_laser', 'scifiport*3', '11#ffffff,#55CD01,#ffffff,#ffffff,#ffffff,#55CD01', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('green_marquee', 'marquee*9', '11#ffffff,#ffffff,#ffffff,#89ca35', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('green_para', 'rare_parasol*0', '11#ffffff,#ffffff,#ffffff,#94f718', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('green_pillar', 'pillar*5', '11#ffffff,#CEDD65,#CEDD65', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('green_pillow', 'pillow*9', '11#b8ff4a,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('green_screen', 'wooden_screen*9', '12#ffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('greenarea', 'wooden_screen*9', '12#ffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('greeniced', 'wooden_screen*9', '12#ffffff,#ffffff,#A0BE1F,#A0BE1F,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('grey_bath', 'rare_fountain*1', '11#ffffff,#ffffff,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('grey_piano_stool', 'romantique_pianochair*5', '11#ffffff,#666666,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('grocket', 'scifirocket*2', '11#ffffff,#ffffff,#009900', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('grunge_chair', 'grunge_chair', '110,0,0', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('grunge_mattress', 'grunge_mattress', '310,0,0', 'sit', 'HON', '1');
INSERT INTO `furniture_template` VALUES ('grunge_radiator', 'grunge_radiator', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('grunge_shelf', 'grunge_shelf', '310,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('grunge_sign', 'grunge_sign', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('grunge_table', 'grunge_table', '220,0,0', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('gsofa', 'gothic_sofa', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('gthrone', 'gothic_chair', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('guitar_skull', 'guitar_skull', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('guitar_v', 'guitar_v', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('guiter', 'guiter', '11#ffffff,#ffffff', 'solid', 'H', '2.3');
INSERT INTO `furniture_template` VALUES ('habboween_crypt', 'habboween_crypt', '130,0,0', 'solid', 'H2', '1.0');
INSERT INTO `furniture_template` VALUES ('habboween_grass', 'habboween_grass', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('habbowheel', 'habbowheel', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('habbowood_chair', 'habbowood_chair', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('habw_mirror', 'habw_mirror', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hal_cauldron', 'hal_cauldron', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('hal_grave', 'hal_grave', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ham', 'ham', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ham2', 'ham2', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hammachine', 'hammachine', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hbrown_fan', 'rare_fan*6', '11#AF4900,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('hc_bkshlf', 'hc_bkshlf', '140,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_btlr', 'hc_btlr', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_chr', 'hc_chr', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hc_computer', 'hc_computer', '120,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_crpt', 'hc_crpt', '350,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_crtn', 'hc_crtn', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_djset', 'hc_djset', '310,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_dsk', 'hc_dsk', '120,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_frplc', 'hc_frplc', '130,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_lmp', 'hc_lmp', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_lmpst', 'hc_lmpst', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_machine', 'hc_machine', '130,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_rllr', 'hc_rllr', '11#ffffff,#67c39c,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('hc_rntgn', 'hc_rntgn', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_tbl', 'hc_tbl', '130,0,0', 'solid', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('hc_trll', 'hc_trll', '120,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hc_tv', 'hc_tv', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hc_wall_lamp', 'hc_wall_lamp', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hcamme', 'hcamme', '120,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hcbook', 'hc_bkshlf', '140,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcbutler', 'hc_btlr', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcdice', 'edicehc', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hcertain', 'hc_crtn', '210,0,0', 'door', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcfire', 'hc_frplc', '130,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcimp', 'doorD', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hclamp', 'hc_lmpst', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hcmachine', 'hc_machine', '130,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcmusic', 'hc_djset', '310,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcnordic', 'hc_tbl', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hcoil', 'hc_lmp', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hcscan', 'hc_rntgn', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hcsofa', 'club_sofa', '210,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hcsohva', 'hcsohva', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hcsohva1', 'hcsohva', '11#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hcstudy', 'hc_dsk', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hctrolly', 'hc_trll', '120,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hctub', 'hcamme', '210,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hctv', 'hc_tv', '210,0,0', 'sit', 'HON', '1.2');
INSERT INTO `furniture_template` VALUES ('heart', 'heart', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('heartsofa', 'heartsofa', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('hockey_score', 'hockey_score', '110,0,0', 'solid', 'Hx', '0.7');
INSERT INTO `furniture_template` VALUES ('holoboy', 'hologram', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hologirl', 'redhologram', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('house', 'house', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('house2', 'house2', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('hyacinth1', 'hyacinth1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('hyacinth2', 'hyacinth2', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('HYASINTTIP', 'hyacinth1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('HYASINTTIS', 'hyacinth2', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('HYN', 'shelves_norja', '11#ffffff,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ice1', 'rare_icecream*0', '110#ffffff,#fa2d00,#fa2d00', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice10', 'rare_icecream*9', '110#FFFFFF,#B357FF,#B357FF', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice2', 'rare_icecream*1', '110#ffffff,#3470ff,#3470ff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice3', 'rare_icecream*2', '110#ffffff,#02bb70,#02bb70', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice4', 'rare_icecream*3', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice5', 'rare_icecream*4', '110#ffffff,#3e3d40,#3e3d40', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice6', 'rare_icecream*5', '110#ffffff,#589a03,#589a03', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice7', 'rare_icecream*6', '110#ffffff,#ffbc00,#ffbc00', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice8', 'rare_icecream*7', '110#ffffff,#83aeff,#83aeff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('ice9', 'rare_icecream*8', '110#ffffff,#ff5f01,#ff5f01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('icechair', 'glass_chair', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_aqua', 'divider_nor2*4', '21#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_black', 'divider_nor2*2', '21#ffffff,#ffffff,#525252,#525252', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_blue', 'divider_nor2*6', '21#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_green', 'divider_nor2*7', '21#ffffff,#ffffff,#7CB135,#7CB135', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_pink', 'divider_nor2*5', '21#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_red', 'divider_nor2*9', '21#ffffff,#ffffff,#E14218,#E14218', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_white', 'divider_nor2*3', '21#ffffff,#ffffff,#ffffff,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bar_yellow', 'divider_nor2*8', '21#ffffff,#ffffff,#FFD837,#FFD837', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bench_aqua', 'couch_norja*4', '21#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_black', 'couch_norja*2', '21#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_blue', 'couch_norja*6', '21#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_green', 'couch_norja*7', '21#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_pink', 'couch_norja*5', '21#ffffff,#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4,#EE7EA4', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_red', 'couch_norja*9', '21#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_white', 'couch_norja*3', '21#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bench_yellow', 'couch_norja*8', '21#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_aqua', 'shelves_norja*4', '11#ffffff,#ABD0D2', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_black', 'shelves_norja*2', '11#ffffff,#525252', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_blue', 'shelves_norja*6', '11#ffffff,#5EAAF8', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_green', 'shelves_norja*7', '11#ffffff,#7CB135', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_pink', 'shelves_norja*5', '11#ffffff,#EE7EA4', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_red', 'shelves_norja*9', '11#ffffff,#E14218', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_white', 'shelves_norja*3', '11#ffffff,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_bookcase_yellow', 'shelves_norja*8', '11#ffffff,#FFD837', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_chair_aqua', 'soft_sofachair_norja*4', '11#ffffff,#ABD0D2,#ABD0D2', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_black', 'soft_sofachair_norja*2', '11#ffffff,#525252,#525252', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_blue', 'soft_sofachair_norja*6', '11#ffffff,#5EAAF8,#5EAAF8', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_green', 'soft_sofachair_norja*7', '11#ffffff,#7CB135,#7CB135', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_pink', 'soft_sofachair_norja*5', '11#ffffff,#EE7EA4,#EE7EA4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_red', 'soft_sofachair_norja*9', '11#ffffff,#E14218,#E14218', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_white', 'soft_sofachair_norja*3', '11#ffffff,#ffffff,#ffffff', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_chair_yellow', 'soft_sofachair_norja*8', '11#ffffff,#FFD837,#FFD837', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_corner_aqua', 'divider_nor1*4', '11#ffffff,#ABD0D2', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_black', 'divider_nor1*2', '11#ffffff,#525252', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_blue', 'divider_nor1*6', '11#ffffff,#5EAAF8', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_green', 'divider_nor1*7', '11#ffffff,#7CB135', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_pink', 'divider_nor1*5', '11#ffffff,#EE7EA4', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_red', 'divider_nor1*9', '11#ffffff,#E14218', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_white', 'divider_nor1*3', '11#ffffff,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_corner_yellow', 'divider_nor1*8', '11#ffffff,#FFD837', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_aqua', 'divider_nor3*4', '11#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_black', 'divider_nor3*2', '11#ffffff,#ffffff,#525252,#525252', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_blue', 'divider_nor3*6', '11#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_green', 'divider_nor3*7', '11#ffffff,#ffffff,#7CB135,#7CB135', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_pink', 'divider_nor3*5', '11#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_red', 'divider_nor3*9', '11#ffffff,#ffffff,#E14218,#E14218', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_white', 'divider_nor3*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_gate_yellow', 'divider_nor3*8', '11#ffffff,#ffffff,#FFD837,#FFD837', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('iced_sofa_aqua', 'soft_sofa_norja*4', '21#ffffff,#ABD0D2,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_black', 'soft_sofa_norja*2', '21#ffffff,#525252,#ffffff,#525252,#525252,#525252', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_blue', 'soft_sofa_norja*6', '21#ffffff,#5EAAF8,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_green', 'soft_sofa_norja*7', '21#ffffff,#7CB135,#ffffff,#7CB135,#7CB135,#7CB135', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_pink', 'soft_sofa_norja*5', '21#ffffff,#EE7EA4,#ffffff,#EE7EA4,#EE7EA4,#EE7EA4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_red', 'soft_sofa_norja*9', '21#ffffff,#E14218,#ffffff,#E14218,#E14218,#E14218', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_white', 'soft_sofa_norja*3', '21#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_sofa_yellow', 'soft_sofa_norja*8', '21#ffffff,#FFD837,#ffffff,#FFD837,#FFD837,#FFD837', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('iced_stool_aqua', 'chair_norja*4', '11#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_black', 'chair_norja*2', '11#ffffff,#ffffff,#525252,#525252', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_blue', 'chair_norja*6', '11#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_green', 'chair_norja*7', '11#ffffff,#ffffff,#7CB135,#7CB135', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_pink', 'chair_norja*5', '11#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_red', 'chair_norja*9', '11#ffffff,#ffffff,#E14218,#E14218', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_white', 'chair_norja*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_stool_yellow', 'chair_norja*8', '11#ffffff,#ffffff,#FFD837,#FFD837', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('iced_table_aqua', 'table_norja_med*4', '22#ffffff,#ABD0D2', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_black', 'table_norja_med*2', '22#ffffff,#525252', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_blue', 'table_norja_med*6', '22#ffffff,#5EAAF8', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_green', 'table_norja_med*7', '22#ffffff,#7CB135', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_pink', 'table_norja_med*5', '22#ffffff,#EE7EA4', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_red', 'table_norja_med*9', '22#ffffff,#E14218', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_white', 'table_norja_med*3', '22#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('iced_table_yellow', 'table_norja_med*8', '22#ffffff,#FFD837', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('icedminibar', 'icedminibar', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('icedsafe', 'icedsafe', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('industrialfan', 'industrialfan', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ISOKAKTUS', 'plant_big_cactus', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('Italie_Plus', 'Italie_Plus\r\n', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('JAA', 'small_chair_armas', '110,0,0', 'sit', 'HON', '1.2');
INSERT INTO `furniture_template` VALUES ('jade_laser', 'scifiport*3', '11#ffffff,#02bb70,#ffffff,#ffffff,#ffffff,#02bb70', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('jade_rocket', 'scifirocket*3', '11#ffffff,#ffffff,#02bb70,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('jadelaser', 'scifiport*3', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('JLA', 'lamp_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('jordycar', 'jordycar', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('joulutahti', 'joulutahti', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('jp_bamboo', 'jp_bamboo', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('jp_drawer', 'jp_drawer', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('jp_irori', 'jp_irori', '220,0,0', 'solid', 'H1', '0');
INSERT INTO `furniture_template` VALUES ('jp_lantern', 'jp_lantern', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('jp_ninjastars', 'jp_ninjastars', 'FFFF33', 'poster', ' ', '0');
INSERT INTO `furniture_template` VALUES ('jp_pillow', 'jp_pillow', '110,0,0', 'sit', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('jp_tatami', 'jp_tatami', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('jp_tatami2', 'jp_tatami2', '240,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('jpatch', 'sandrug', '220,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('jukebox', 'jukebox', '130,0,0', 'solid', 'H', '1.0');
INSERT INTO `furniture_template` VALUES ('JUKKA', 'plant_yukka', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('KAAKELIKELT', 'tile_yell', '440,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('KAAKELIPUN', 'tile_red', '440,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('KAAKELISIN', 'tile', '440,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('kamera', 'camera', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('KHA', 'shelves_armas', '210,0,0', 'solid', 'H', '3');
INSERT INTO `furniture_template` VALUES ('KHP', 'shelves_polyfon', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('KHS', 'shelves_silo', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('KUMIANKKA', 'duck', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('kya', 'lamp2_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('l', 'floor', 'null', 'null', 'null', '0');
INSERT INTO `furniture_template` VALUES ('lapland', 'rare_xmas_screen', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser1', 'scifiport*0', '110#ffffff,#fa2d00,#ffffff,#fa2d00,#ffffff,#fa2d00', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser10', 'scifiport*9', '110#B357FF,#ffffff,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser2', 'scifiport*2', '110#ffffff,#3470ff,#ffffff,#3470ff,#ffffff,#3470ff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser3', 'scifiport*3', '110#ffffff,#02bb70,#ffffff,#02bb70,#ffffff,#02bb70', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser4', 'scifiport*4', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser5', 'scifiport*5', '110#ffffff,#3e3d40,#ffffff,#3e3d40,#ffffff,#3e3d40', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser6', 'scifiport*6', '110#ffffff,#589a03,#ffffff,#589a03,#ffffff,#589a03', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser7', 'scifiport*5', '110#ffffff,#ffbc00,#ffffff,#ffbc00,#ffffff,#ffbc00', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser8', 'scifiport*8', '110#ffffff,#83aeff,#ffffff,#83aeff,#ffffff,#83aeff', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laser9', 'scifiport*9', '110#ffffff,#ff5f01,#ffffff,#ff5f01,#ffffff,#ff5f01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('laserred', 'scifiport*0', '110,#FF0000,#FF0000', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LAVUAARI', 'sink', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('lbar', 'divider_arm2', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('lbar_b', 'lbar_b', '110,0,0', 'solid', 'H', '1.0');
INSERT INTO `furniture_template` VALUES ('lbar_poly3', 'lbar_poly3', '11#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBARDESK', 'bartable_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBARREL', 'bar_chair_armas', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBENCH', 'bench_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBLOCK', 'divider_arm1', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBMINIBAR', 'bar_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LBOOKCASE', 'shelves_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LCANDLE', 'lamp2_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('lcorner', 'divider_arm1', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LDININGTABLE', 'table_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('LDOUBLEBED', 'bed_armas_two', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('legocourt', 'carpet_legocourt', '330,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('legotrophy', 'legotrophy', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('LFIREPLACE', 'fireplace_armas', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('lfridge', 'bar_armas', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('lgate', 'divider_arm3', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('LIC', 'divider_arm3', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('lighttv', 'lighttv', '11#ffffff,#ffffff', 'solid', 'H', '2.3');
INSERT INTO `furniture_template` VALUES ('lila_fan', 'rare_fan*3', '11#B357FF,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('lime_piano_stool', 'romantique_pianochair*5', '11#ffffff,#80AF52,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('livenudes', 'livenudes\r\n', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('LOCCATABLE', 'small_table_armas', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('lodgebar', 'lodgebar', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('love_fan', 'rare_fan*4', '11#e78b8b,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('love_pillar', 'pillar*1', '11#ffffff,#f2beb6,#f2beb6', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('LSINGLEBED', 'bed_armas_one', '210,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('LTP', 'stand_polyfon_z', '110,0,0', 'solid', 'HTRUE', '0.5');
INSERT INTO `furniture_template` VALUES ('luxurymocha', 'luxurymocha\r\n', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('majestic', 'hc_chr', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('marquee1', 'marquee*1', '11#ffffff,#ffffff,#ffffff,#e78b8b', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee2', 'marquee*2', '11#ffffff,#ffffff,#ffffff,#d02a1f', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee3', 'marquee*3', '11#ffffff,#ffffff,#ffffff,#3399FF', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee4', 'marquee*4', '11#ffffff,#ffffff,#ffffff,#efbf00', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee5', 'marquee*5', '11#ffffff,#ffffff,#ffffff,#666666', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee6', 'marquee*6', '11#ffffff,#ffffff,#ffffff,#0000FF', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee7', 'marquee*7', '11#ffffff,#ffffff,#ffffff,#B357FF', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee8', 'marquee*8', '11#ffffff,#ffffff,#ffffff,#006699', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('marquee9', 'marquee*9', '11#ffffff,#ffffff,#ffffff,#89ca35', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('maze', 'plant_maze', '21#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mazegate', 'plant_mazegate', '21#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mbar', 'bardesk_polyfon', '210,0,#8FAEB0,#8FAEB0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mbar_beige', 'bardesk_polyfon*4', '210,0,#D0C6A5,#D0C6A5', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mbar_black', 'bardesk_polyfon*2', '210,0,#686868,#686868', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mbar_blue', 'bardesk_polyfon*6', '210,0,#519AD1,#519AD1', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mbar_green', 'bardesk_polyfon*7', '210,0,#759C34,#759C34', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mbar_red', 'bardesk_polyfon*9', '210,0,#FFC927,#FFC927', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mbar_white', 'bardesk_polyfon*3', '210,0,#DFDFDF,#DFDFDF', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mbar_yellow', 'bardesk_polyfon*3', '210,0,#DAB831,#DAB831', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_beige', 'bardeskcorner_polyfon*4', '110,#D0C6A5,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_black', 'bardeskcorner_polyfon*2', '110,#686868,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mcbar_blue', 'bardeskcorner_polyfon*6', '110,#519AD1,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_green', 'bardeskcorner_polyfon*7', '110,#759C34,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_red', 'bardeskcorner_polyfon*9', '110,#FFC927,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_white', 'bardeskcorner_polyfon*3', '110,#DFDFDF,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mcbar_yellow', 'bardeskcorner_polyfon*3', '110,#DAB831,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('mchair', 'hc_chr', '210,0,0', 'Sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('md_sofa', 'md_sofa', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('mdbed', 'bed_polyfon', '230,0,#8FAEB0,#8FAEB0,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_beige', 'bed_polyfon*4', '230,0,#D0C6A5,#D0C6A5,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_black', 'bed_polyfon*2', '230,0,#686868,#686868,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_blue', 'bed_polyfon*6', '230,0,#519AD1,#519AD1,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_green', 'bed_polyfon*7', '230,0,#759C34,#759C34,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_red', 'bed_polyfon*9', '230,0,#FFC927,#FFC927,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_white', 'bed_polyfon*3', '230,0,#DFDFDF,#DFDFDF,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mdbed_yellow', 'bed_polyfon*3', '230,0,#DAB831,#DAB831,0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('menorah', 'menorah', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mfire', 'fireplace_polyfon', '210,0,0', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('mgate', 'divider_poly3', '110,0,0,#8FAEB0,#8FAEB0', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_beige', 'divider_poly3*4', '110,0,0,#D0C6A5,#D0C6A5', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_black', 'divider_poly3*2', '110,0,0,#686868,#686868', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_blue', 'divider_poly3*6', '110,0,0,#519AD1,#519AD1', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_green', 'divider_poly3*7', '110,0,0,#759C34,#759C34', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_red', 'divider_poly3*9', '110,0,0,#FFC927,#FFC927', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_white', 'divider_poly3*3', '110,0,0,#DFDFDF,#DFDFDF', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mgate_yellow', 'divider_poly3*3', '110,0,0,#DAB831,#DAB831', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM1', 'carpet_soft', '240,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM2', 'carpet_soft*1', '24#CC3333', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM3', 'carpet_soft*2', '24#66FFFF', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM4', 'carpet_soft*3', '24#FFCC99', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM5', 'carpet_soft*4', '24#FFCCFF', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM6', 'carpet_soft*5', '24#FFFF66', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MM7', 'carpet_soft*6', '24#669933', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mmbar', 'bar_polyfon', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mmchair', 'chair_polyfon', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('mocchamaster', 'mocchamaster', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('mocha', 'mocchamaster', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_1bed_beige', 'bed_polyfon_one*4', '13#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_black', 'bed_polyfon_one*2', '13#ffffff,#ffffff,#ffffff,#525252,#525252', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_blue', 'bed_polyfon_one*6', '13#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_green', 'bed_polyfon_one*7', '13#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_red', 'bed_polyfon_one*9', '13#ffffff,#ffffff,#ffffff,#E14218,#E14218', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_white', 'bed_polyfon_one*3', '13#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_1bed_yellow', 'bed_polyfon_one*8', '13#ffffff,#ffffff,#ffffff,#FFD837,#FFD837', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_beige', 'bed_polyfon*4', '23#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_black', 'bed_polyfon*2', '23#ffffff,#ffffff,#525252,#525252', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_blue', 'bed_polyfon*6', '23#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_green', 'bed_polyfon*7', '23#ffffff,#ffffff,#7CB135,#7CB135', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_red', 'bed_polyfon*9', '23#ffffff,#ffffff,#E14218,#E14218', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_white', 'bed_polyfon*3', '23#ffffff,#ffffff,#ffffff,#ffffff', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_2bed_yellow', 'bed_polyfon*8', '23#ffffff,#ffffff,#FFD837,#FFD837', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mode_bar_beige', 'bardesk_polyfon*4', '21#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_black', 'bardesk_polyfon*2', '21#ffffff,#ffffff,#525252,#525252', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_blue', 'bardesk_polyfon*6', '21#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_green', 'bardesk_polyfon*7', '21#ffffff,#ffffff,#7CB135,#7CB135', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_red', 'bardesk_polyfon*9', '21#ffffff,#ffffff,#E14218,#E14218', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_white', 'bardesk_polyfon*3', '21#ffffff,#ffffff,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_bar_yellow', 'bardesk_polyfon*8', '21#ffffff,#ffffff,#FFD837,#FFD837', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mode_chair_beige', 'sofachair_polyfon*4', '11#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_black', 'sofachair_polyfon*2', '11#ffffff,#ffffff,#525252,#525252', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_blue', 'sofachair_polyfon*6', '11#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_green', 'sofachair_polyfon*7', '11#ffffff,#ffffff,#7CB135,#7CB135', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_red', 'sofachair_polyfon*9', '11#ffffff,#ffffff,#E14218,#E14218', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_white', 'sofachair_polyfon*3', '11#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_chair_yellow', 'sofachair_polyfon*8', '11#ffffff,#ffffff,#FFD837,#FFD837', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_corner_beige', 'bardeskcorner_polyfon*4', '11#ffffff,#F7EBBC', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_black', 'bardeskcorner_polyfon*2', '11#ffffff,#525252', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_blue', 'bardeskcorner_polyfon*6', '11#ffffff,#5EAAF8', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_green', 'bardeskcorner_polyfon*7', '11#ffffff,#7CB135', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_red', 'bardeskcorner_polyfon*9', '11#ffffff,#E14218', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_white', 'bardeskcorner_polyfon*3', '11#ffffff,#ffffff', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_corner_yellow', 'bardeskcorner_polyfon*8', '11#ffffff,#FFD837', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('mode_gate_beige', 'divider_poly3*4', '11#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_black', 'divider_poly3*2', '11#ffffff,#ffffff,#ffffff,#525252,#525252\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_blue', 'divider_poly3*6', '11#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_green', 'divider_poly3*7', '11#ffffff,#ffffff,#ffffff,#7CB135,#7CB135', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_red', 'divider_poly3*9', '11#ffffff,#ffffff,#ffffff,#E14218,#E14218\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_white', 'divider_poly3*3', '11#ffffff,#ffffff,#ffffff,#ffffff,#ffffff\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_gate_yellow', 'divider_poly3*8', '11#ffffff,#ffffff,#ffffff,#FFD837,#FFD837\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mode_sofa_beige', 'sofa_polyfon*4', '21#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_black', 'sofa_polyfon*2', '21#ffffff,#ffffff,#ffffff,#ffffff,#525252,#525252,#525252,#525252', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_blue', 'sofa_polyfon*6', '21#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_green', 'sofa_polyfon*7', '21#ffffff,#ffffff,#ffffff,#ffffff,#7CB135,#7CB135,#7CB135,#7CB135', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_red', 'sofa_polyfon*9', '21#ffffff,#ffffff,#ffffff,#ffffff,#E14218,#E14218,#E14218,#E14218', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_white', 'sofa_polyfon*3', '21#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mode_sofa_yellow', 'sofa_polyfon*8', '21#ffffff,#ffffff,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837,#FFD837', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('modetable', 'table_polyfon', '220,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('money1', 'CF_1_coin_bronze', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money10', 'CF_10_coin_gold', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money100', 'CFC_100_moneybag_gold', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money20', 'CF_20_moneybag', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money200', 'CFC_200_moneybag', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money5', 'CF_5_coin_silver', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money50', 'CFC_50_coin_silver', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('money500', 'CFC_500_goldbar', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('moneybag', 'CF_20_moneybag', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('mono', 'scifidoor*6', '11#ffffff,#333333,#333333,#333333,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_aqua', 'scifidoor*7', '11#ffffff,#aaffff,#aaffff,#aaffff,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_black', 'scifidoor*6', '11#ffffff,#333333,#333333,#333333,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_blue', 'scifidoor*9', '11#ffffff,#55c4de,#55c4de,#55c4de,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_jade', 'scifidoor*4', '11#ffffff,#02bb70,#02bb70,#02bb70,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_pink', 'scifidoor*1', '11#ffffff,#e78b8b,#e78b8b,#e78b8b,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_purple', 'scifidoor*8', '11ffffff,#ff99cc,#ff99cc,#ff99cc,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_red', 'scifidoor*11', '11#ffffff,#8B0F01,#8B0F01,#8B0F01,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_sky', 'scifidoor*3', '11#ffffff,#aaccff,#aaccff,#aaccff,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_violet', 'scifidoor*10', '11#ffffff,#993399,#993399,#993399,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_white', 'scifidoor*5', '11#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono_yellow', 'scifidoor*2', '11#ffffff,#f1b000,#f1b000,#f1b000,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('mono1', 'scifidoor*1', '110#ffffff,#fa2d00,#fa2d00,#fa2d00', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono10', 'scifidoor*10', '110#FFFFFF,#B357FF,#B357FF,#B357FF', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono2', 'scifidoor*2', '110#ffffff,#3470ff,#3470ff,#3470ff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono3', 'scifidoor*3', '110#ffffff,#02bb70,#02bb70,#02bb70', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono4', 'scifidoor*4', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono5', 'scifidoor*5', '110#ffffff,#3e3d40,#3e3d40,#3e3d40', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono6', 'scifidoor*6', '110#ffffff,#589a03,#589a03,#589a03', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono7', 'scifidoor*7', '110#ffffff,#ffbc00,#ffbc00,#ffbc00', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono8', 'scifidoor*8', '110#ffffff,#83aeff,#83aeff,#83aeff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('mono9', 'scifidoor*9', '110#ffffff,#ff5f01,#ff5f01,#ff5f01', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('moon', 'rare_moonrug', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('moonrug', 'rare_moonrug', '220,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('msbed', 'bed_polyfon_one', '130,0,0,#8FAEB0,#8FAEB0,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_beige', 'bed_polyfon_one*4', '130,0,0,#D0C6A5,#D0C6A5,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_black', 'bed_polyfon_one*2', '130,0,0,#686868,#686868,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_blue', 'bed_polyfon_one*6', '130,0,0,#519AD1,#519AD1,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_green', 'bed_polyfon_one*7', '130,0,0,#759C34,#759C34,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_red', 'bed_polyfon_one*9', '130,0,0,#FFC927,#FFC927,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_white', 'bed_polyfon_one*3', '130,0,0,#DFDFDF,#DFDFDF,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('msbed_yellow', 'bed_polyfon_one*3', '130,0,0,#DAB831,#DAB831,0', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('mschair', 'sofachair_polyfon', '110,0,#8FAEB0,#8FAEB0,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_beige', 'sofachair_polyfon*4', '110,0,#D0C6A5,#D0C6A5,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_black', 'sofachair_polyfon*2', '110,0,#686868,#686868,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_blue', 'sofachair_polyfon*6', '110,0,#519AD1,#519AD1,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_green', 'sofachair_polyfon*7', '110,0,#759C34,#759C34,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_red', 'sofachair_polyfon*9', '110,0,#FFC927,#FFC927,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_white', 'sofachair_polyfon*3', '110,0,#DFDFDF,#DFDFDF,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('mschair_yellow', 'sofachair_polyfon*3', '110,0,#DAB831,#DAB831,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa', 'sofa_polyfon', '210,0,0,0,#8FAEB0,#8FAEB0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_beige', 'sofa_polyfon', '210,0,0,0,#D0C6A5,#D0C6A5', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_black', 'sofa_polyfon*2', '210,0,0,0,#686868,#686868', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_blue', 'sofa_polyfon*6', '210,0,0,0,#519AD1,#519AD1', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_green', 'sofa_polyfon*7', '210,0,0,0,#759C34,#759C34', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_red', 'sofa_polyfon*9', '210,0,0,0,#FFC927,#FFC927', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_white', 'sofa_polyfon*3', '210,0,0,0,#DFDFDF,#DFDFDF', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('msofa_yellow', 'sofa_polyfon*3', '210,0,0,0,#DAB831,#DAB831', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('MUR', 'carpet_polar', '23#ffffff,#ffffff,#ffffff', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('MURLOVE', 'carpet_polar*1', '23#ffbbcf,#ffbbcf,#ffddef', 'rug', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('navy_marquee', 'marquee*8', '11#ffffff,#ffffff,#ffffff,#004AA0', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('navy_pillow', 'pillow*8', '11#214E68,#214E68,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('navypod', 'chair_plasty*4', '11#ffffff,#0033CC,#ffffff,#0033CC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('newa8p', 'table_plasto_4leg*10', '22#ffffff,#ccddff', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newpl4lg2', 'table_plasto_4leg*15', '22#ffffff,#FF97BA', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplbsq1', 'table_plasto_bigsquare*14', '22#ffffff,#CC3399', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplbsq2', 'table_plasto_bigsquare*15', '22#ffffff,#FF97BA', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplch16', 'chair_plasto*16', '11#ffffff,#CC3399,#ffffff,#CC3399', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplch2', 'chair_plasto*16', '11#ffffff,#FF97BA,#ffffff,#FF97BA', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplrnd1', 'table_plasto_round*14', '22#ffffff,#CC3399', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplrnd2', 'table_plasto_round*15', '22#ffffff,#FF97BA', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplsq1', 'table_plasto_square*14', '11#ffffff,#CC3399', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplsq2', 'table_plasto_square*14', '11#ffffff,#FF97BA,#ffffff,#FF97BA', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newpltb4lg16', 'table_plasto_4leg*16', '22#ffffff,#CC3399', 'solid', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('newplty1', 'chair_plasty*7', '11#ffffff,#99DCCc,#ffffff,#99DCCc', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('newplty2', 'chair_plasty*8', '11#ffffff,#c38d1a,#ffffff,#c38d1a', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('newplty3', 'chair_plasty*9', '11#ffffff,#533e10,#ffffff,#533e10', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('newplty4', 'chair_plasty*10', '11#ffffff,#CC3399,#ffffff,#CC3399', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('newplty5', 'chair_plasty*11', '11#ffffff,#FF97BA,#ffffff,#FF97BA', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('nissanr34', 'nissanr34', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('nissanz33', 'nissanz33', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('NOPPA', 'edice', '110,0,0', 'solid', 'H0', '0');
INSERT INTO `furniture_template` VALUES ('nordiv', 'divider_nor2', '21#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_aqua', 'divider_nor2*9', '210,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_black', 'divider_nor2*9', '210,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_blue', 'divider_nor2*9', '210,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_green', 'divider_nor2*9', '210,0,#73A531,#73A531,#73A531,#73A531', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_pink', 'divider_nor2', '210,0,#DE7599,#DE7599,#DE7599,#DE7599', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_red', 'divider_nor2*9', '210,0,#D23D16,#D23D16,#D23D16,#D23D16', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv_yellow', 'divider_nor2*9', '210,0,#EFC933,#EFC933,#EFC933,#EFC933', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('nordiv4', 'divider_nor4', '21#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('nordiv5', 'divider_nor5', '11#ffffff,#F7EBBC,#F7EBBC', 'solid', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norkp', 'divider_nor1', '11#ffffff,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_aqua', 'divider_nor1*9', '110,#9ABFBD,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_black', 'divider_nor1*9', '110,#4C4C4C,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_blue', 'divider_nor1*9', '110,#9FC2C4,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_green', 'divider_nor1*9', '110,#73A531,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_pink', 'divider_nor1', '110,#DE7599,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_red', 'divider_nor1*9', '110,#D23D16,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norkp_yellow', 'divider_nor1*9', '110,#EFC933,0,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('norovi', 'divider_nor3', '11#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_aqua', 'divider_nor3*9', '110,0,#9ABFBD,#9ABFBD', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_black', 'divider_nor3*9', '110,0,#4C4C4C,#4C4C4C', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_blue', 'divider_nor3*9', '110,0,#9FC2C4,#9FC2C4', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_green', 'divider_nor3*9', '110,0,#73A531,#73A531', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_pink', 'divider_nor3', '110,0,#DE7599,#DE7599', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_red', 'divider_nor3*9', '110,0,#D23D16,#D23D16', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('norovi_yellow', 'divider_nor3*9', '110,0,#EFC933,#EFC933', 'door', 'HO', '0');
INSERT INTO `furniture_template` VALUES ('obi2', 'door', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ochre_fan', 'rare_fan*6', '11#FF8000,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('ochre_ice', 'rare_icecream*6', '11#FFFFFF,#FF8000,0,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('old_tree1', 'tree1', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('olive_pillar', 'pillar*8', '11#ffffff,#9A924B,#9A924B', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('one_way_door_aqua', 'one_way_door*1', '11#ABD0D2,#ffffff,#ABD0D2', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_beige', 'one_way_door*5', '11#F7EBBC,#ffffff,#F7EBBC', 'solid', 'T0\r\n', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_black', 'one_way_door*3', '11#525252,#ffffff,#525252', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_blue', 'one_way_door*6', '11#5EAAF8,#ffffff,#5EAAF8', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_green', 'one_way_door*7', '11#92D13D,#ffffff,#92D13D', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_pink', 'one_way_door*2', '11#FF99BC,#ffffff,#FF99BC', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_red', 'one_way_door*9', '11#E14218,#ffffff,#E14218', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_white', 'one_way_door*4', '11#ffffff,#ffffff,#ffffff', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('one_way_door_yellow', 'one_way_door*8', '11#FFD837,#ffffff,#FFD837', 'solid', 'T0', '0');
INSERT INTO `furniture_template` VALUES ('opara', 'rare_parasol*2', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('orange_para', 'rare_parasol*2', '11#ffffff,#ffffff,#ffffff,#ff8f61', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('orocket', 'scifirocket*5', '11#ffffff,#ffffff,#FF9900', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('OSB', 'doormat_love', '110,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ovi', 'door', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ovi2', 'doorB', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ovi3', 'doorC', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ovi4', 'doorD', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PEA', 'bench_armas', '210,0,0', 'sit', 'H', '1.3');
INSERT INTO `furniture_template` VALUES ('PEN', 'couch_norja', '21#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC,#F7EBBC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_aqua', 'couch_norja*9', '210,0,0,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_black', 'couch_norja*9', '210,0,0,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_blue', 'couch_norja*9', '210,0,0,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_green', 'couch_norja*9', '210,0,0,#73A531,#73A531,#73A531,#73A531,#73A531', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_pink', 'couch_norja', '210,0,0,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_red', 'couch_norja*9', '210,0,0,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PEN_yellow', 'couch_norja*9', '210,0,0,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pet0', 'nest', '110,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pet1', 'nest', '110,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pet2', 'nest', '110,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petal', 'rare_daffodil_rug', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('petalpatch', 'rare_daffodil_rug', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('petdog1', 'pet_race_0_008', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('petfood1', 'petfood1', '110,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petfood2', 'petfood2', '110', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petfood3', 'petfood3', '110,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petfood4', 'petfood4', '110,0,0', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petgoodie1a', 'goodie1', '11#ff4cbf,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petgoodie1b', 'goodie1*1', '11#3fffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petgoodie1c', 'goodie1*2', '11#ffbf00,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('petgoodie2', 'goodie2', '110', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pettoy1', 'toy1', '11#ff0000,#ffff00,#ffffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pettoy2', 'toy1*1', '11#ff7f00,#007f00,#ffffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pettoy3', 'toy1*2', '11#003f7f,#ff00bf,#ffffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pettoy4', 'toy1*3', '11#bf1900,#00bfbf,#ffffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pettoy5', 'toy1*4', '11#000000,#ffffff,#ffffff,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('PIA', 'table_armas', '220,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('piano1', 'grand_piano*2', '22#ffffff,#1C1C1C,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('piano2', 'grand_piano*3', '22#ffffff,#333333,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pianochair', 'romantique_pianochair*1', '11#ffffff,#ff3366,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pianochair2', 'romantique_pianochair*5', '11#ffffff,#1C1C1C,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pianochair3', 'romantique_pianochair*4', '11#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pianochairw', 'romantique_pianochair*1', '11#ffffff,#1C1C1C,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PIKKUKAKTUS', 'plant_small_cactus', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('pillar0', 'pillar*0', '11#ffffff,#ffffff,#ffffff', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar1', 'pillar*1', '11#ffffff,#663300,#663300', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar2', 'pillar*2', '11#ffffff,#e78b8b,#e78b8b', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar3', 'pillar*3', '11#ffffff,#0000FF,#0000FF', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar4', 'pillar*4', '11#ffffff,#000000,#000000', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar5', 'pillar*5', '11#ffffff,#009900,#009900', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar6', 'pillar*6', '11#ffffff,#972e2a,#972e2a', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar7', 'pillar*7', '11#ffffff,#e3ca0e,#e3ca0e', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar8', 'pillar*8', '11#ffffff,#CCCCCC,#CCCCCC', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillar9', 'pillar*9', '11#ffffff,#999999,#999999', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pillow1', 'pillow*0', '11#fa2d00,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow10', 'pillow*9', '11#B357FF,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow2', 'pillow*1', '11#3470ff,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow3', 'pillow*2', '11#02bb70,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow4', 'pillow*3', '110#ffffff,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow5', 'pillow*4', '11#3e3d40,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow6', 'pillow*5', '11#589a03,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow7', 'pillow*6', '11#ffbc00,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow8', 'pillow*7', '11#83aeff,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pillow9', 'pillow*8', '11#ff5f01,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('Pink_elephant', 'rare_elephant_statue*4', '11#ffffff,#FF0099', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('pink_ice', 'rare_icecream*4', '11#FFFFFF,#e78b8b', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('pink_laser', 'scifiport*4', '11#ffffff,#e78b8b,#ffffff,#ffffff,#ffffff,#e78b8b', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pink_marquee', 'marquee*1', '11#ffffff,#ffffff,#ffffff,#FF798F', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pink_pillar', 'pillar*1', '11#ffffff,#FFD0D2,#FFD0D2', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('pink_pillow', 'pillow*1', '11#FF8888,#FF8888,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pink_rocket', 'scifirocket*4', '11#ffffff,#ffffff,#ff5577,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pink_screen', 'wooden_screen*1', '12#ffffff,#ffffff,#FFA795,#FFA795,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pinkhynacith', 'hyacinth1', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('pinklaser', 'scifiport*4', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('PIZ', 'pizza', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PL1', 'chair_plasty', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PL2', 'chair_plasty*1', '11#ffffff,#8EB5D1,#ffffff,#8EB5D1', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PL3', 'chair_plasty*2', '11#ffffff,#ff9900,#ffffff,#ff9900', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PL4', 'chair_plasty*3', '11#ffffff,#ff2200,#ffffff,#ff2200', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PL5', 'chair_plasty*4', '11#ffffff,#00cc00,#ffffff,#00cc00', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('plant_bulrush', 'plant_bulrush', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('plant_cruddy', 'plant_cruddy', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('plant_maze', 'plant_maze', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('plant_mazegate', 'plant_mazegate', '210,0,0', 'door', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('plants', 'plant_mazegate', '210,0,0', 'door', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('plasmascreen', 'plasmascreen\r\n', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PMP', 'table_polyfon_med', '220,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('poinsetta', 'joulutahti', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('polyovi', 'divider_poly3', '11#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2\r', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('polyovi_c', 'divider_poly3', '11#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('poster', 'poster', '11#ffffff,#ffffff,#ffffff,#EE7EA4,#EE7EA4', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('poster_1336', 'poster_1336', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('poster_livenudes', 'poster_livenudeles', '110,0,0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PPA', 'small_table_armas', '110,0,0', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('PPP', 'table_polyfon_small', '220,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS', 'table_silo_small', '11#ffffff,#ABD0D2', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_beige', 'table_silo_small', '110,#D0C6A5,0,#D0C6A5', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_black', 'table_silo_small', '110,#4C4C4C,0,#4C4C4C', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_blue', 'table_silo_small', '110,#9FC2C4,0,#9FC2C4', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_green', 'table_silo_small', '110,#73A531,0,#73A531', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_pink', 'table_silo_small', '110,#DE7599,0,#DE7599', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_red', 'table_silo_small', '110,#D23D16,0,#D23D16', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('PPS_yellow', 'table_silo_small', '110,#EFC933,0,#EFC933', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('present', 'present_gen6', '110,0,0', 'solid', 'H!hure', '0');
INSERT INTO `furniture_template` VALUES ('prize1', 'prize1', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('prize2', 'prize2', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('prize3', 'prize3', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('prupledrag', 'dragonlamp*9', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('ps3', 'ps3', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PSN', 'soft_sofa_norja', '21#ffffff,#F7EBBC,#ffffff,#F7EBBC,#F7EBBC,#F7EBBC', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_aqua', 'soft_sofa_norja*9', '21#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD,#9ABFBD', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_black', 'soft_sofa_norja*9', '21#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C,#4C4C4C', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_blue', 'soft_sofa_norja*9', '21#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4,#9FC2C4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_green', 'soft_sofa_norja*9', '21#73A531,#73A531,#73A531,#73A531,#73A531,#73A531', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_pink', 'soft_sofa_norja', '21#DE7599,#DE7599,#DE7599,#DE7599,#DE7599,#DE7599', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_red', 'soft_sofa_norja*9', '21#D23D16,#D23D16,#D23D16,#D23D16,#D23D16,#D23D16', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PSN_yellow', 'soft_sofa_norja*9', '21#EFC933,#EFC933,#EFC933,#EFC933,#EFC933,#EFC933', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('pudding', 'pudding', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('PUL', 'bottle', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('pumpkin', 'pumpkin', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('pura_chair_aqua', 'chair_basic*1', '11#FFFFFF,#ABD0D2,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_beige', 'chair_basic*5', '11#FFFFFF,#F7EBBC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_black', 'chair_basic*3', '11#FFFFFF,#525252,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_blue', 'chair_basic*6', '11#FFFFFF,#5EAAF8,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_green', 'chair_basic*7', '11#FFFFFF,#92D13D,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_pink', 'chair_basic*2', '11#FFFFFF,#FF99BC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_red', 'chair_basic*9', '11#FFFFFF,#E14218,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_white', 'chair_basic*4', '11#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_chair_yellow', 'chair_basic*8', '11#FFFFFF,#FFD837,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl11', 'pura_mdl1*1', '11#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl12', 'pura_mdl1*2', '11#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl13', 'pura_mdl1*3', '11#FFFFFF,#525252,#525252,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl14', 'pura_mdl1*4', '11#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl15', 'pura_mdl1*5', '11#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl16', 'pura_mdl1*6', '11#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl17', 'pura_mdl1*7', '11#FFFFFF,#92D13D,#92D13D,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl18', 'pura_mdl1*8', '11#FFFFFF,#FFD837,#FFD837,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl19', 'pura_mdl1*9', '11#FFFFFF,#E14218,#E14218,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl21', 'pura_mdl2*1', '11#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl22', 'pura_mdl2*2', '11#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl23', 'pura_mdl2*3', '11#FFFFFF,#525252,#525252,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl24', 'pura_mdl2*4', '11#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl25', 'pura_mdl2*5', '11#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl26', 'pura_mdl2*6', '11#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl27', 'pura_mdl2*7', '11#FFFFFF,#92D13D,#92D13D,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl28', 'pura_mdl2*8', '11#FFFFFF,#FFD837,#FFD837,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl29', 'pura_mdl2*9', '11#FFFFFF,#E14218,#E14218,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl31', 'pura_mdl3*1', '11#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl32', 'pura_mdl3*2', '11#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl33', 'pura_mdl3*3', '11#FFFFFF,#525252,#525252,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl34', 'pura_mdl3*4', '11#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl35', 'pura_mdl3*5', '11#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl36', 'pura_mdl3*6', '11#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl37', 'pura_mdl3*7', '11#FFFFFF,#92D13D,#92D13D,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl38', 'pura_mdl3*8', '11#FFFFFF,#FFD837,#FFD837,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl39', 'pura_mdl3*9', '11#FFFFFF,#E14218,#E14218,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl41', 'pura_mdl4*1', '11#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl42', 'pura_mdl4*2', '11#FFFFFF,#FF99BC,#FF99BC,#FF99BC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl43', 'pura_mdl4*3', '11#FFFFFF,#525252,#525252,#525252', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl44', 'pura_mdl4*4', '11#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl45', 'pura_mdl4*5', '11#FFFFFF,#F7EBBC,#F7EBBC,#F7EBBC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl46', 'pura_mdl4*6', '11#FFFFFF,#5EAAF8,#5EAAF8,#5EAAF8', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl47', 'pura_mdl4*7', '11#FFFFFF,#92D13D,#92D13D,#92D13D', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl48', 'pura_mdl4*8', '11#FFFFFF,#FFD837,#FFD837,#FFD837', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl49', 'pura_mdl4*9', '11#FFFFFF,#E14218,#E14218,#E14218', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl51', 'pura_mdl5*1', '11#FFFFFF,#ABD0D2,#ABD0D2,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl52', 'pura_mdl5*2', '11#FFFFFF,#FF99BC,#FF99BC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl53', 'pura_mdl5*3', '11#FFFFFF,#525252,#525252,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl54', 'pura_mdl5*4', '11#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl55', 'pura_mdl5*5', '11#FFFFFF,#F7EBBC,#F7EBBC,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl56', 'pura_mdl5*6', '11#FFFFFF,#5EAAF8,#5EAAF8,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl57', 'pura_mdl5*7', '11#FFFFFF,#92D13D,#92D13D,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl58', 'pura_mdl5*8', '11#FFFFFF,#FFD837,#FFD837,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('pura_mdl59', 'pura_mdl5*9', '11#FFFFFF,#E14218,#E14218,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('purabedtwo', 'bed_budget', '230,0,0', 'bed', 'H', '1');
INSERT INTO `furniture_template` VALUES ('puralamp', 'lamp_basic', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('purple_fan', 'rare_fan*3', '11#BC9BFF,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purple_ice', 'rare_icecream*3', '11#FFFFFF,#B357FF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('purple_laser', 'scifiport*8', '11#ffffff,#B357FF,#ffffff,#ffffff,#ffffff,#B357FF', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purple_marquee', 'marquee*7', '11#ffffff,#ffffff,#ffffff,#D600E2', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purple_rocket', 'scifirocket*8', '11#ffffff,#ffffff,#bb55cc,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purple_screen', 'wooden_screen*7', '12#ffffff,#ffffff,#DA2591,#DA2591,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purplelaser', 'scifiport*8', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('purpletraffic', 'traffic_light*3', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('PUU', 'plant_fruittree', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('PYN', 'table_norja_med', '22#ffffff,#F7EBBC', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('PYN_aqua', 'table_norja_med*9', '220,#9ABFBD', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_black', 'table_norja_med*9', '220,#4C4C4C', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_blue', 'table_norja_med*9', '220,#9FC2C4', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_green', 'table_norja_med*9', '220,#73A531', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_pink', 'table_norja_med', '220,#DE7599', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_red', 'table_norja_med*9', '220,#D23D16', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYN_yellow', 'table_norja_med*9', '220,#EFC933', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYS', 'table_silo_med', '22#ffffff,#ABD0D2', 'solid', 'H', '0.6');
INSERT INTO `furniture_template` VALUES ('PYTTYKELT', 'toilet_yell', '110,0,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PYTTYPUN', 'toilet_red', '110,0,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('PYTTYSIN', 'toilet', '110,0,0', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('pyukka', 'plant_yukka', '110,0,0', 'solid', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('queue_aqua', 'queue_tile1*3', '11#ffffff,#67c39c,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_black', 'queue_tile1*5', '11#ffffff,#555A37,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_blue', 'queue_tile1*6', '11#ffffff,#A2E8FA,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_gold', 'queue_tile1*4', '11#ffffff,#f1b000,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_green', 'queue_tile1*9', '11#ffffff,#9AFF60,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_navy', 'queue_tile1*8', '11#ffffff,#1E8AA5,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_pink', 'queue_tile1*1', '11#ffffff,#FF7C98,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_purple', 'queue_tile1*7', '11#ffffff,#FC5AFF,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_red', 'queue_tile1*2', '11#ffffff,#FF3333,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('queue_white', 'queue_tile1*0', '11#ffffff,#ffffff,#ffffff,#ffffff', 'roller', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('R2P', 'smooth_table_polyfon', '220,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rare_dragon2', 'rare_dragon2', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rare_globe', 'rare_globe', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rare_hammock', 'rare_hammock', '130,0,0', 'bed', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('rare_icecream_campaign', 'rare_icecream_campaign', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rare_mnstr', 'rare_mnstr', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('rare_xmas_screen', 'rare_xmas_screen', '210,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('rares', 'Rares', '210,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('rcandle', 'rcandle', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('rcandles', 'rcandleset', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rclr_chair', 'rclr_chair', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rclr_garden', 'rclr_garden', '130,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rclr_sofa', 'rclr_sofa', '210,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rdrag', 'dragonlamp*8', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('red_amber', 'rare_beehive_bulb*1', '11#ffffff,#ffffff,#ffffff,#ffffff,#de5555,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('red_bath', 'rare_fountain', '11#ffffff,#ffffff,#ef5a5a', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('red_ice', 'rare_icecream*0', '11#FFFFFF,#d02a1f', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('red_laser', 'scifiport*0', '11#ffffff,#d02a1f,#ffffff,#ffffff,#ffffff,#d02a1f', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('red_marquee', 'marquee*2', '11#ffffff,#ffffff,#ffffff,#C60000', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('red_pillow', 'pillow*2', '11#ef0000,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('red_rocket', 'scifirocket*0', '11#ffffff,#ffffff,#dd2d22,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('red_rose', 'plant_valentinerose*1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('redarea', 'plant_valentinerose*1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('rediced', 'plant_valentinerose*1', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('redtraffic', 'traffic_light*6', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('RMA', 'carpet_armas', '240,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rock_pillar', 'pillar*9', '11#ffffff,#B2A69D,#B2A69D', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('rom_lamp', 'rom_lamp', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('romantique_chair', 'romantique_chair*1', '11#ffffff,#ff3366,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_chair5', 'romantique_chair*5', '110,#339999,0', 'sit', 'HO', '1');
INSERT INTO `furniture_template` VALUES ('romantique_clock', 'romantique_clock', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('romantique_divan', 'romantique_divan*1', '21#ffffff,#ffffff,#ffffff,#ff3366', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_divan3', 'romantique_divan*3', '210,0,0,#339999', 'sit', 'HO', '1');
INSERT INTO `furniture_template` VALUES ('romantique_divider', 'romantique_divider*1', '21#ff3366,#ff3366,#ffffff,#ffffff', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_divider1', 'romantique_divider*1', '21#339999,#339999', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('romantique_mirrortabl', 'romantique_mirrortabl', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_pianochair1', 'romantique_pianochair*1', '110,#339999,0', 'sit', 'HO', '1');
INSERT INTO `furniture_template` VALUES ('romantique_smalltabl_1', 'romantique_smalltabl*1', '11#ffffff,#ff3366,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_smalltabl5', 'romantique_smalltabl*5', '110,#339999', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('romantique_tray1', 'romantique_tray1', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('romantique_tray2', 'romantique_tray2', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rope_divider', 'rope_divider', '210,0,0', 'door', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rose_pink', 'plant_valentinerose*4', '11#FFFFFF,#FF1493,#99CCFF', 'solid', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('rose_red', 'plant_valentinerose*1', '11#FFFFFF,#FF0000,#99CCFF', 'solid', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('rose_violet', 'plant_valentinerose*5', '11#FFFFFF,#FF00FF,#99CCFF', 'solid', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('rose_white', 'plant_valentinerose*2', '11#FFFFFF,#FFFFFF,#99CCFF', 'solid', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('rose_yellow', 'plant_valentinerose*3', '11#FFFFFF,#FFD700,#99CCFF', 'solid', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('rosewood_screen', 'wooden_screen*2', '12#ffffff,#ffffff,#bb0000,#bb0000,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('rrocket', 'scifirocket*1', '11#ffffff,#ffffff,#DD0000', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('RTV', 'red_tv', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('rubber_chair', 'rubberchair*7', '11#CFCFCF,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_black', 'rubberchair*8', '11#333333,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_blue', 'rubberchair*1', '11#0080FF,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_lime', 'rubberchair*5', '11#89ca35,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_ocean', 'rubberchair*4', '11#00E5E2,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_orange', 'rubberchair*3', '11#FF6600,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_pink', 'rubberchair*2', '11#ff5577,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubber_chair_purp', 'rubberchair*6', '11#7733ff,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubberchair', 'rubberchair', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('rubberchair_1', 'rubberchair*1', '11#4193D6,#FFFFFF,#FFFFFF', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('ruusu', 'plant_rose', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('S1A', 'bed_armas_one', '130,0,0', 'bed', 'H', '1.9');
INSERT INTO `furniture_template` VALUES ('S1B', 'bed_budget_one', '13#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('S1BVALKO', 'bed_budgetb_one', '13#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('S1P', 'bed_polyfon_one', '13#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('S1S', 'bed_silo_one', '130,0,0', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('S2A', 'bed_armas_two', '230,0,0', 'bed', 'H', '1.9');
INSERT INTO `furniture_template` VALUES ('S2B', 'bed_budget', '23#FFFFFF,#FFFFFF,#FFFFFF,#ABD0D2,#ABD0D2,#ABD0D2', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('S2BVALKO', 'bed_budgetb', '23#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF,#FFFFFF', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('S2P', 'bed_polyfon', '23#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'bed', 'H', '1.6');
INSERT INTO `furniture_template` VALUES ('S2S', 'bed_silo_two', '230,0,0', 'bed', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('safe', 'safe_silo', '110,0,0', 'solid', 'H', '1.8');
INSERT INTO `furniture_template` VALUES ('safe_silo', 'safe_silo', '11#ffffff,#ABD0D2,#ABD0D2,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('safe_silo_beige', 'safe_silo', '110,#D0C6A5,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_black', 'safe_silo', '110,#4C4C4C,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_blue', 'safe_silo', '110,#9FC2C4,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_green', 'safe_silo', '110,#73A531,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_pink', 'safe_silo', '110,#DE7599,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_red', 'safe_silo', '110,#D23D16,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('safe_silo_yellow', 'safe_silo', '110,#EFC933,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('samovar', 'samovar', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('sand', 'sandrug', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('scoreboard', 'hockey_score', '110,0,0', 'solid', 'Hx', '0.7');
INSERT INTO `furniture_template` VALUES ('screen1', 'wooden_screen*0', '120#fa2d00,#ffffff#,#fa2d00,#fa2d00,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen10', 'wooden_screen*9', '120#B357FF,#ffffff#,#B357FF,#B357FF,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen2', 'wooden_screen*1', '120#3470ff,#ffffff#,#3470ff,#3470ff,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen3', 'wooden_screen*2', '120#02bb70,#ffffff#,#02bb70,#02bb70,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen4', 'wooden_screen*3', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen5', 'wooden_screen*4', '120#3e3d40,#ffffff#,#3e3d40,#3e3d40,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen6', 'wooden_screen*5', '120#589a03,#ffffff#,#589a03,#589a03,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen7', 'wooden_screen*6', '120#ffbc00,#ffffff#,#ffbc00,#ffbc00,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen8', 'wooden_screen*7', '120#83aeff,#ffffff#,#83aeff,#83aeff,#ffffff#,#ffffff\r\n', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('screen9', 'wooden_screen*8', '120#ff5f01,#ffffff#,#ff5f01,#ff5f01,#ffffff#,#ffffff', 'solid', 'HON', '0.7');
INSERT INTO `furniture_template` VALUES ('servercu', 'servercu\r\n', '110,0,01', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('SHP', 'sofa_polyfon', '21#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('SHS', 'sofa_silo', '21#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2,#ABD0D2,#ABD0D2,#ABD0D2\r', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('SHS_beige', 'sofa_silo', '210,0,#D0C6A5,#D0C6A5,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_black', 'sofa_silo', '210,0,#4C4C4C,#4C4C4C,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_blue', 'sofa_silo', '210,0,#9FC2C4,#9FC2C4,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_green', 'sofa_silo', '210,0,#73A531,#73A531,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_pink', 'sofa_silo', '210,0,#DE7599,#DE7599,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_red', 'sofa_silo', '210,0,#D23D16,#D23D16,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('SHS_yellow', 'sofa_silo', '210,0,#EFC933,#EFC933,0', 'sit', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('sidrag', 'dragonlamp*3', '110,0,0', 'solid', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('sildiv', 'divider_silo2', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp', 'divider_silo1', '11#ffffff,#ABD0D2', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_beige', 'divider_silo1', '110,#D0C6A5,0,#D0C6A5', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_black', 'divider_silo1', '110,#4C4C4C,0,#4C4C4C', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_blue', 'divider_silo1', '110,#9FC2C4,0,#9FC2C4', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_green', 'divider_silo1', '110,#73A531,0,#73A531', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_pink', 'divider_silo1', '110,#DE7599,0,#DE7599', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_red', 'divider_silo1', '110,#D23D16,0,#D23D16', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silkp_yellow', 'divider_silo1', '110,#EFC933,0,#EFC933', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silo_studydesk', 'silo_studydesk', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('silostudydesk', 'silo_studydesk', '21#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silovi', 'divider_silo3', '11#ffffff,#ffffff,#ffffff,#ABD0D2', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_beige', 'divider_silo3', '110,0,0,#D0C6A5,#D0C6A5', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_black', 'divider_silo3', '110,0,0,#4C4C4C,#4C4C4C', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_blue', 'divider_silo3', '110,0,0,#9FC2C4,#9FC2C4', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_green', 'divider_silo3', '110,0,0,#73A531,#73A531', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_pink', 'divider_silo3', '110,0,0,#DE7599,#DE7599', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_red', 'divider_silo3', '110,0,0,#D23D16,#D23D16', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silovi_yellow', 'divider_silo3', '110,0,0,#EFC933,#EFC933', 'door', 'HC', '0');
INSERT INTO `furniture_template` VALUES ('silver_elephant', 'rare_elephant_statue*1', '11#ffffff,#bfbfbf', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('silver_mono', 'scifidoor*5', '11#ffffff,#eaeaea,#eaeaea,#eaeaea,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('skull', 'skullcandle', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('skullcandle', 'skullcandle', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('skydrag', 'dragonlamp*7', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('sleepingbag', 'sleepingbag*1', '13#BB5F54,0,#BB5F54,0,#BB5F54', 'bed', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke1', 'scifiport*0', '110#ffffff,#fa2d00,#fa2d00', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke10', 'scifirocket*9', '110#FFFFFF,#B357FF,#B357FF', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke2', 'scifirocket*1', '110#ffffff,#3470ff,#3470ff', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke3', 'scifirocket*2', '110#ffffff,#02bb70,#02bb70', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke4', 'scifirocket*3', '110#ffffff,#ffffff,#ffffff', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke5', 'scifirocket*4', '110#ffffff,#3e3d40,#3e3d40', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke6', 'scifirocket*5', '110#ffffff,#589a03,#589a03', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke7', 'scifirocket*6', '110#ffffff,#ffbc00,#ffbc00', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke8', 'scifirocket*7', '110#ffffff,#83aeff,#83aeff', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smoke9', 'scifirocket*8', '110#ffffff,#ff5f01,#ff5f01', 'solid', 'HON', '0.8');
INSERT INTO `furniture_template` VALUES ('smokeviolet', 'scifirocket*9', '112,0,0', 'solid', 'H', '0.8');
INSERT INTO `furniture_template` VALUES ('snow', 'rare_snowrug', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('snowmachine', 'snowmachine', '110,0,0', 'solid', 'H1', '1.1');
INSERT INTO `furniture_template` VALUES ('snowrug', 'rare_snowrug', '220,0,0', 'rug', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('soccer_ball', 'footylamp', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('solarium', 'solarium_norja*6', '11#ffffff,#5EAAF8,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('solarium_norja', 'solarium_norja', '110,#E2DAAC', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('song_disk', 'song_disk', '310,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_machine', 'sound_machine*1', '11#ffffff,#ffffff,#cccccc,#ffff11', 'door', 'H', '2.0');
INSERT INTO `furniture_template` VALUES ('sound_machine1', 'sound_machine*1', '11#ffffff,#ffffff,#cccccc,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine2', 'sound_machine*2', '11#ffffff,#ffffff,#73a8ca,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine3', 'sound_machine*3', '11#ffffff,#ffffff,#238E68,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine4', 'sound_machine*4', '11#ffffff,#FFFFFF,#1a426c,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine5', 'sound_machine*5', '11#ffffff,#ffffff,#5C3317,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine6', 'sound_machine*6', '11#ffffff,#ffffff,#871F78,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_machine7', 'sound_machine*7', '11#ffffff,#FFFFFF,#8a2929,#ffff11', 'solid', 'H2', '0.9');
INSERT INTO `furniture_template` VALUES ('sound_set1', 'sound_set_1', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set10', 'sound_set_10', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set11', 'sound_set_11', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set12', 'sound_set_12', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set13', 'sound_set_13', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set14', 'sound_set_14', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set15', 'sound_set_15', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set16', 'sound_set_16', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set17', 'sound_set_17', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set18', 'sound_set_18', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set19', 'sound_set_19', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set2', 'sound_set_2', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set20', 'sound_set_20', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set21', 'sound_set_21', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set22', 'sound_set_22', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set23', 'sound_set_23', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set24', 'sound_set_24', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set25', 'sound_set_25', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set26', 'sound_set_26', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set27', 'sound_set_27', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set28', 'sound_set_28', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set29', 'sound_set_29', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set3', 'sound_set_3', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set30', 'sound_set_30', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set31', 'sound_set_31', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set32', 'sound_set_32', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set33', 'sound_set_33', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set34', 'sound_set_34', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set35', 'sound_set_35', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set36', 'sound_set_36', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set37', 'sound_set_37', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set38', 'sound_set_38', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set39', 'sound_set_39', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set4', 'sound_set_4', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set40', 'sound_set_40', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set41', 'sound_set_41', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set42', 'sound_set_42', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set43', 'sound_set_43', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set44', 'sound_set_44', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set45', 'sound_set_45', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set46', 'sound_set_46', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set47', 'sound_set_47', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set48', 'sound_set_48', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set49', 'sound_set_49', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set5', 'sound_set_5', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set50', 'sound_set_50', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set51', 'sound_set_51', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set52', 'sound_set_52', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set6', 'sound_set_6', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set7', 'sound_set_7', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set8', 'sound_set_8', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('sound_set9', 'sound_set_9', '110,0,0', 'solid', 'H', '0.1');
INSERT INTO `furniture_template` VALUES ('soundmachine', 'sound_machine*1', '11#ffffff,#ffffff,#828282,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('speaker', 'rare_stand', '110,0,0', 'sit', 'H', '1.9');
INSERT INTO `furniture_template` VALUES ('Speakers_b', 'Speakers_b', '11#ffffff,#ffffff', 'solid', 'H', '2.3');
INSERT INTO `furniture_template` VALUES ('splant', 'plant_cruddy', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('sportcorner_asphalt', 'sporttrack2*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sportcorner_grass', 'sporttrack2*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sportcorner_tartan', 'sporttrack2*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sportgoal_asphalt', 'sporttrack3*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sportgoal_grass', 'sporttrack3*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sportgoal_tartan', 'sporttrack3*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sporttrackstraight', 'sporttrack1*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sporttrackstraight_asp', 'sporttrack1*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('sporttrackstraight_gra', 'sporttrack1*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('spotlamp', 'spotlight', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('spotlight', 'spotlight', '110,0,0', 'solid', 'H1', '0.7');
INSERT INTO `furniture_template` VALUES ('stack.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '2.5');
INSERT INTO `furniture_template` VALUES ('stack0.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('stack05', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('stack1.0', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '1.0');
INSERT INTO `furniture_template` VALUES ('stack1.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('stack10', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '1.0');
INSERT INTO `furniture_template` VALUES ('stack15', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '1.5');
INSERT INTO `furniture_template` VALUES ('stack2.0', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '2.0');
INSERT INTO `furniture_template` VALUES ('stack2.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '2.5');
INSERT INTO `furniture_template` VALUES ('stack20', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '2.0');
INSERT INTO `furniture_template` VALUES ('stack3.0', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '3.0');
INSERT INTO `furniture_template` VALUES ('stack3.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('stack30', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '3.0');
INSERT INTO `furniture_template` VALUES ('stack35', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('stack4.0', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '4.0');
INSERT INTO `furniture_template` VALUES ('stack4.5', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '4.5');
INSERT INTO `furniture_template` VALUES ('stack40', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '4.0');
INSERT INTO `furniture_template` VALUES ('stack45', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '4.5');
INSERT INTO `furniture_template` VALUES ('stack5.0', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '5.0');
INSERT INTO `furniture_template` VALUES ('stack50', 'bardeskcorner_polyfon', '110,#8FAEB0,0', 'solid', 'H', '5.0');
INSERT INTO `furniture_template` VALUES ('statue', 'statue', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('stn', 'soft_sofachair_norja', '11#ffffff,#F7EBBC,#F7EBBC', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_aqua', 'soft_sofachair_norja*9', '110,#9ABFBD,#9ABFBD', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_black', 'soft_sofachair_norja*9', '110,#4C4C4C,#4C4C4C', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_blue', 'soft_sofachair_norja*9', '110,#9FC2C4,#9FC2C4', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_green', 'soft_sofachair_norja*9', '110,#73A531,#73A531', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_pink', 'soft_sofachair_norja', '110,#DE7599,#DE7599', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_red', 'soft_sofachair_norja*9', '110,#D23D16,#D23D16', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stn_yellow', 'soft_sofachair_norja*9', '110,#EFC933,#EFC933', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('stone_bar', 'stone_bar', '210,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('stone_block', 'stone_block', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('STP', 'sofachair_polyfon', '11#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'sit', 'H', '1.2');
INSERT INTO `furniture_template` VALUES ('STS', 'sofachair_silo', '11#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('STS_beige', 'sofachair_silo', '210,0,#D0C6A5,#D0C6A5,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_black', 'sofachair_silo', '210,0,#4C4C4C,#4C4C4C,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_blue', 'sofachair_silo', '210,0,#9FC2C4,#9FC2C4,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_green', 'sofachair_silo', '210,0,#73A531,#73A531,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_pink', 'sofachair_silo', '210,0,#DE7599,#DE7599,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_red', 'sofachair_silo', '210,0,#D23D16,#D23D16,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('STS_yellow', 'sofachair_silo', '210,0,#EFC933,#EFC933,0', 'sit', 'H', '0.5');
INSERT INTO `furniture_template` VALUES ('summer_chair', 'summer_chair*5', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('summer_chair_aqua', 'summer_chair*1', '11#ffffff,#ffffff,#ffffff,#ffffff,#ABD0D2', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_beige', 'summer_chair*5', '11#ffffff,#ffffff,#ffffff,#ffffff,#F7EBBC', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_black', 'summer_chair*3', '11#ffffff,#ffffff,#ffffff,#ffffff,#525252', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_blue', 'summer_chair*6', '11#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_green', 'summer_chair*7', '11#ffffff,#ffffff,#ffffff,#ffffff,#92D13D', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_pink', 'summer_chair*2', '11#ffffff,#ffffff,#ffffff,#ffffff,#FF99BC', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_red', 'summer_chair*9', '11#ffffff,#ffffff,#ffffff,#ffffff,#E14218', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_white', 'summer_chair*4', '11#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_chair_yellow', 'summer_chair*8', '11#ffffff,#ffffff,#ffffff,#ffffff,#FFD837', 'sit', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_grill', 'summer_grill*1', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('summer_grill_blue', 'summer_grill', '21#ffffff,#5EAAF8,#ffffff,#ffffff,#5EAAF8,#5EAAF8,#5EAAF8', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_grill_green', 'summer_grill', '21#ffffff,#92D13D,#ffffff,#ffffff,#92D13D,#92D13D,#92D13D', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_grill_red', 'summer_grill', '21#ffffff,#E14218,#ffffff,#ffffff,#E14218,#E14218,#E14218', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_grill_yellow', 'summer_grill', '21#ffffff,#FFD837,#ffffff,#ffffff,#FFD837,#FFD837,#FFD837', 'solid', 'H', '0.9');
INSERT INTO `furniture_template` VALUES ('summer_pool', 'summer_pool', '220,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('summer_pool_blue', 'summer_pool*1', '22#5EAAF8,#5EAAF8,#5EAAF8,#5EAAF8,#ffffff,#ffffff,#ffffff,#ffffff,#5EAAF8', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('summer_pool_green', 'summer_pool*3', '22#92D13D,#92D13D,#92D13D,#92D13D,#ffffff,#ffffff,#ffffff,#ffffff,#92D13D', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('summer_pool_red', 'summer_pool*2', '22#E14218,#E14218,#E14218,#E14218,#ffffff,#ffffff,#ffffff,#ffffff,#E14218', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('summer_pool_yellow', 'summer_pool*4', '22#FFD837,#FFD837,#FFD837,#FFD837,#ffffff,#ffffff,#ffffff,#ffffff,#FFD837', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('sushi_pos', 'sushi_pos', '22#FFD837,#FFD837,#FFD837,#FFD837,#ffffff,#ffffff,#ffffff,#ffffff,#FFD837', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('sushi1', 'sushi1', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi2', 'sushi2', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi3', 'sushi3', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi4', 'sushi4', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi5', 'sushi5', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi6', 'sushi6', '110,0,0', 'solid', 'H', '0.3');
INSERT INTO `furniture_template` VALUES ('sushi7', 'sushi7', '110,0,0', 'solid', 'H', '0.4');
INSERT INTO `furniture_template` VALUES ('sushitana', 'sushitana', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('t', 'wallpaper', 'null', 'null', 'null', '0');
INSERT INTO `furniture_template` VALUES ('TAA', 'fireplace_armas', '210,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('TAP', 'fireplace_polyfon', '210,0,0', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('teal_screen', 'wooden_screen*8', '12#ffffff,#ffffff,#004B5E,#004B5E,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('teambench', 'bench_lego', '410,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('terra_pillar', 'pillar*6', '11#ffffff,#972e2a,#972e2a', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('theatre_seat', 'theatre_seat', '110,0,0', 'sit', 'H1', '1');
INSERT INTO `furniture_template` VALUES ('throne', 'throne', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tile_brown', 'tile_brown', '110,0,0', 'rug', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('tile_marble', 'tile_marble', '110,0,0', 'rug', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('tile_stella', 'tile_stella', '110,0,0', 'rug', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('tlp', 'post.it', '20', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('tlp2', 'post.it.vd', '20', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('torch', 'torch', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('toyotaae86', 'toyotaae86', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('toyotaae86_f', 'toyotaae86_f', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('toyotasupura', 'toyotasupura', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track11', 'sporttrack1*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track12', 'sporttrack1*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track13', 'sporttrack1*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track21', 'sporttrack2*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track22', 'sporttrack2*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track23', 'sporttrack2*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track31', 'sporttrack3*1', '22#ffffff,#e4592d,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track32', 'sporttrack3*2', '22#ffffff,#62818b,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('track33', 'sporttrack3*3', '22#ffffff,#5cb800,#ffffff', 'rug', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('traffic_light', 'traffic_light', '110,#D91E26,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('transparent_fan', 'rare_fan*8', '11#FFFFFF,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('traxmachine', 'traxmachine', '110,0,0', 'solid', 'H2', '0');
INSERT INTO `furniture_template` VALUES ('tree1', 'tree1', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tree3', 'tree3', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tree4', 'tree4', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tree5', 'tree5', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('triplecandle', 'triplecandle', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tropical', 'valentinescreen', '210,0,0', 'solid', 'HON', '1');
INSERT INTO `furniture_template` VALUES ('tsofa', 'hcsohva', '210,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN', 'chair_norja', '11#ffffff,#ffffff,#F7EBBC,#F7EBBC', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_aqua', 'chair_norja*9', '110,#9ABFBD,#9ABFBD,#9ABFBD', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_black', 'chair_norja*9', '110,#4C4C4C,#4C4C4C,#4C4C4C', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_blue', 'chair_norja*9', '110,#9FC2C4,#9FC2C4,#9FC2C4', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_green', 'chair_norja*9', '110,#73A531,#73A531,#73A531', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_pink', 'chair_norja', '110,#DE7599,#DE7599,#DE7599', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_red', 'chair_norja*9', '110,#D23D16,#D23D16,#D23D16', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUN_yellow', 'chair_norja*9', '110,#EFC933,#EFC933,#EFC933', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('tune_a', 'tune_a', '210,0,0', 'solid', 'H', '2.5');
INSERT INTO `furniture_template` VALUES ('tune_b', 'tune_b', '210,0,0', 'solid', 'H', '2.5');
INSERT INTO `furniture_template` VALUES ('TUP', 'chair_polyfon', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('turkey', 'turkey', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('turkeys', 'turkey', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('turquoise_fan', 'rare_fan*8', '11#00E5E2,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('turquoise_laser', 'scifiport*7', '11#ffffff,#00cccc,#ffffff,#ffffff,#ffffff,#00cccc', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('turquoise_pillow', 'pillow*3', '11#63C9A0,#63C9A0,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('turquoiselaser', 'scifiport*7', '110,0,0', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('TUS', 'chair_silo', '11#ffffff,#ffffff,#ABD0D2,#ABD0D2', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_beige', 'chair_silo', '110,0,#D0C6A5,#D0C6A5,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_black', 'chair_silo', '110,0,#4C4C4C,#4C4C4C,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_blue', 'chair_silo', '110,0,#9FC2C4,#9FC2C4,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_green', 'chair_silo', '110,0,#73A531,#73A531,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_pink', 'chair_silo', '110,0,#DE7599,#DE7599,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_red', 'chair_silo', '110,0,#D23D16,#D23D16,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('TUS_yellow', 'chair_silo', '110,0,#EFC933,#EFC933,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('typo', 'typingmachine', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('val_carpet', 'carpet_valentine', '270,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('val_cauldron', 'val_cauldron', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('val_heart', 'val_heart', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('val_rose', 'plant_valentinerose*1', '11#FFFFFF,#FF1E1E,#FFFFFF,#FFFFFF', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('val_rug', 'carpet_valentine', '270,0,0', 'rug', 'H', '0');
INSERT INTO `furniture_template` VALUES ('valeduck', 'valeduck', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('valentinescreen', 'valentinescreen', '210,0,0', 'sit', 'H', '1.1');
INSERT INTO `furniture_template` VALUES ('Vending_Machine', 'Vending_Machine', '110#ffffff,#ffbc00,#ffbc00', 'solid', 'HOFF', '0');
INSERT INTO `furniture_template` VALUES ('violet_laser', 'scifiport*9', '11#ffffff,#7733ff,#ffffff,#ffffff,#ffffff,#7733ff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('violet_para', 'rare_parasol*3', '11#ffffff,#ffffff,#ffffff,#d47fff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('violet_rocket', 'scifirocket*9', '11#ffffff,#ffffff,#7733ff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('violetlaser', 'scifiport*9', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('vrocket', 'scifirocket*4', '11#ffffff,#ffffff,#800080', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('wall_china', 'wall_china', '110,0,0', 'solid', 'H', '1');
INSERT INTO `furniture_template` VALUES ('wallmirror', 'wallmirror', '0', 'poster', 'H', '0');
INSERT INTO `furniture_template` VALUES ('wallpaper', 'wallpaper', '301', 'null', 'null', '0');
INSERT INTO `furniture_template` VALUES ('waterbowlblue', 'waterbowl*4', '11#0099ff,#ffffff,#ffffff', 'rug', 'QA', '0.7');
INSERT INTO `furniture_template` VALUES ('waterbowlbrown', 'waterbowl*5', '11#bf7f00,#ffffff,#ffffff', 'rug', 'QA', '0.7');
INSERT INTO `furniture_template` VALUES ('waterbowlgreen', 'waterbowl*2', '11#3fff3f,#ffffff,#ffffff', 'rug', 'QA', '0.7');
INSERT INTO `furniture_template` VALUES ('waterbowlred', 'waterbowl*1', '11#ff3f3f,#ffffff,#ffffff', 'rug', 'QA', '0.7');
INSERT INTO `furniture_template` VALUES ('waterbowlyellow', 'waterbowl*3', '11#ffff00,#ffffff,#ffffff', 'rug', 'QA', '0.7');
INSERT INTO `furniture_template` VALUES ('wcandle', 'wcandle', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('wcandles', 'wcandleset', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('white_laser', 'scifiport*6', '11#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('white_marquee', 'marquee*a', '11#ffffff,#ffffff,#ffffff,#ffffff', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('white_pillow', 'pillow*0', '11#ffffff,#ffffff,#ffffff', 'sit', 'H', '1');
INSERT INTO `furniture_template` VALUES ('white_rocket', 'scifirocket*6', '11#ffffff,#ffffff,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('white_rose', 'plant_valentinerose*2', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('white_screen', 'wooden_screen*0', '12#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('whitearea', 'wooden_screen*0', '12#ffffff,#ffffff,#ffffff,#ffffff,#ffffff,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('whitelaser', 'scifiport*6', '110,0,0', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('whitetraffic', 'traffic_light*5', '110,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('wood_pillar', 'pillar*2', '11#ffffff,#7B5922,#7B5922', 'solid', 'H', '3.5');
INSERT INTO `furniture_template` VALUES ('wpillow', 'pillow*0', '11#ffffff,#ffffff,#ffffff', 'sit', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('WTV', 'wood_tv', '120,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmas_cake', 'pudding', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmas_turkey', 'turkey', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmas1', 'tree3', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmas2', 'tree4', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmas3', 'tree5', '110,0,0', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('xmasduck', 'xmasduck', '110,0,0', 'solid', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('yellotraffic', 'traffic_light*4', '110,0,0', 'sit', 'H', '0');
INSERT INTO `furniture_template` VALUES ('yellow_amber', 'rare_beehive_bulb*2', '11#ffffff,#ffffff,#ffffff,#ffffff,#ffcc00,#ffffff', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('yellow_bear', 'carpet_polar*3', '23#ffee99,#ffee99,#ffffff', 'rug', 'HON', '0');
INSERT INTO `furniture_template` VALUES ('yellow_fan', 'rare_fan*5', '11#ffcc00,0,0,0', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('yellow_laser', 'scifiport*1', '11#ffffff,#f1b000,#ffffff,#ffffff,#ffffff,#f1b000', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('yellow_marquee', 'marquee*4', '11#ffffff,#ffffff,#ffffff,#efbf00', 'door', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('yellow_para', 'rare_parasol*1', '11#ffffff,#ffffff,#ffffff,#ffff11', 'solid', 'H', '0');
INSERT INTO `furniture_template` VALUES ('yellow_rocket', 'scifirocket*1', '11#ffffff,#ffffff,#ffbc00,#ffffff', 'solid', 'H', '0.7');
INSERT INTO `furniture_template` VALUES ('buy_furni', '', '', '', '', '0');
INSERT INTO `furniture_template` VALUES ('local', '', '', '', '', '0');
INSERT INTO `guestroom_modeldata` VALUES ('a', '3,5,0.0', 'xxxxxxxxxxxxxxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxx00000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('b', '0,5,0.0', 'xxxxxxxxxxxxxxxxx0000000xxxxx0000000xxxxx0000000xxxxx0000000x00000000000x00000000000x00000000000x00000000000x00000000000x00000000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('c', '4,7,0.0', 'xxxxxxxxxxxxxxxxx0000000xxxxx0000000xxxxx0000000xxxxx0000000x00000000000x00000000000x00000000000x00000000000x00000000000x00000000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rxxxxx0000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rx00000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('d', '4,7,0.0', 'xxxxxxxxxxxxxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxx000000xxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxx000000x\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('e', '1,5,0.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000000xx0000000000xx0000000000xx0000000000xx0000000000xx0000000000xx0000000000xx0000000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxx0000000000\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('f', '2,5,0.0', 'xxxxxxxxxxxxxxxxxxx0000xxxxxxxx0000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xx0000000000xx0000000000xx0000000000xx0000000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxxxx0000x\rxxxxxxx0000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rx0000000000x\rx0000000000x\rx0000000000x\rx0000000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('g', '1,7,1.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00000xxxxxxxx00000xxxxxxxx00000xxx1111000000xxx1111000000xxx1111000000xxx1111000000xxx1111000000xxxxxxxx00000xxxxxxxx00000xxxxxxxx00000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxx1111000000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxx00000x\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx\rxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('h', '4,4,1.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx111111xxxxxx111111xxxxxx111111xxxxxx111111xxxxxx111111xxxxxx000000xxxxxx000000xxxx00000000xxxx00000000xxxx00000000xxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx111111x\rxxxxx000000x\rxxxxx000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxx00000000x\rxxxxxxxxxxxx\rxxxxxxxxxxxx\rxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('i', '0,10,0.0', 'xxxxxxxxxxxxxxxxxx0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000x0000000000000000xxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxx\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rx0000000000000000\rxxxxxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('j', '0,10,0.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxx0000000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rxxxxxxxxxxx0000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rx0000000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('k', '0,13,0.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxx00000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000x000000000000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxxxxxxxxxx00000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rx000000000000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx\r\r');
INSERT INTO `guestroom_modeldata` VALUES ('l', '0,16,0.0', 'xxxxxxxxxxxxxxxxxxxxxx00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000x00000000xxxx00000000xxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rx00000000xxxx00000000\rxxxxxxxxxxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('m', '0,15,1.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxx0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000x0000000000000000000000000000xxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rx0000000000000000000000000000\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxx00000000xxxxxxxxxx\rxxxxxxxxxxxxxxxxxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('n', '0,16,0.0', 'xxxxxxxxxxxxxxxxxxxxxx00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x000000xxxxxxxx000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000x000000xxxxxxxx000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000x00000000000000000000xxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxx\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx000000xxxxxxxx000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000x000000x000000\rx000000xxxxxxxx000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rx00000000000000000000\rxxxxxxxxxxxxxxxxxxxxx\r');
INSERT INTO `guestroom_modeldata` VALUES ('o', '0,18,1.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx11111111xxxxxxxxxxxxxxxxx00000000xxxxxxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000x111111100000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxx0000000000000000xxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx11111111xxxx\rxxxxxxxxxxxxx00000000xxxx\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rx111111100000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxx0000000000000000\rxxxxxxxxxxxxxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('p', '0,23,2.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxx222222222222xxxxxxx222222222222xxxxxxx222222222222xxxxxxx222222222222xxxxxxx222222222222xxxxxxx222222222222xxxxxxx22222222xxxxxxxxxxx11111111xxxxx222221111111111111x222221111111111111x222221111111111111x222221111111111111x222221111111111111x222221111111111111x222221111111111111x222221111111111111x2222xx11111111xxxxx2222xx00000000xxxxx2222xx000000000000x2222xx000000000000x2222xx000000000000x2222xx000000000000x2222xx000000000000x2222xx000000000000xxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxx\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx222222222222\rxxxxxxx22222222xxxx\rxxxxxxx11111111xxxx\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx222221111111111111\rx2222xx11111111xxxx\rx2222xx00000000xxxx\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rx2222xx000000000000\rxxxxxxxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('q', '10,4,2.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxx22222222xxxxxxxxxxx22222222xxxxxxxxxxx22222222xxxxxxxxxxx22222222xxxxxxxxxxx22222222xxxxxxxxxxx22222222x222222222222222222x222222222222222222x222222222222222222x222222222222222222x222222222222222222x222222222222222222x2222xxxxxxxxxxxxxxx2222xxxxxxxxxxxxxxx2222211111xx000000x222221111110000000x222221111110000000x2222211111xx000000xx22xxx1111xxxxxxxxxx11xxx1111xxxxxxxxx1111xx1111xx000000x1111xx111110000000x1111xx111110000000x1111xx1111xx000000xxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rxxxxxxxxxxx22222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx222222222222222222\rx2222xxxxxxxxxxxxxx\rx2222xxxxxxxxxxxxxx\rx2222211111xx000000\rx222221111110000000\rx222221111110000000\rx2222211111xx000000\rxx22xxx1111xxxxxxxx\rxx11xxx1111xxxxxxxx\rx1111xx1111xx000000\rx1111xx111110000000\rx1111xx111110000000\rx1111xx1111xx000000\rxxxxxxxxxxxxxxxxxxx');
INSERT INTO `guestroom_modeldata` VALUES ('r', '10,4,3.0', 'xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx33333333333333xxxxxxxxxxx33333333333333xxxxxxxxxxx33333333333333xxxxxxxxxxx33333333333333xxxxxxxxxxx33333333333333xxxxxxxxxxx33333333333333xxxxxxx333333333333333333xxxxxxx333333333333333333xxxxxxx333333333333333333xxxxxxx333333333333333333xxxxxxx333333333333333333xxxxxxx333333333333333333x4444433333xxxxxxxxxxxxxxx4444433333xxxxxxxxxxxxxxx44444333333222xx000000xxx44444333333222xx000000xxxxx44xxxxxxxx22xx000000xxxxx33xxxxxxxx11xx000000xxxxx33322222211110000000xxxxx33322222211110000000xxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxxxxxxxxx000000xxxxxxxxxxxxxxxxxxxxxxxxxxx', 'xxxxxxxxxxxxxxxxxxxxxxxxx\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxxxxxx33333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rxxxxxxx333333333333333333\rx4444433333xxxxxxxxxxxxxx\rx4444433333xxxxxxxxxxxxxx\rx44444333333222xx000000xx\rx44444333333222xx000000xx\rxxx44xxxxxxxx22xx000000xx\rxxx33xxxxxxxx11xx000000xx\rxxx33322222211110000000xx\rxxx33322222211110000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxx000000xx\rxxxxxxxxxxxxxxxxxxxxxxxxx');
INSERT INTO `messenger` VALUES ('nillus', null, null, '0', null);
INSERT INTO `ranks` VALUES ('1', 'fuse_room_queue_defaultfuse_tradefuse_buy_creditsfuse_logindefaultdefault', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `ranks` VALUES ('2', 'fuse_room_queue_defaultfuse_tradefuse_buy_creditsfuse_loginfuse_receive_calls_for_helpfuse_moderator_accessfuse_room_alertfuse_any_room_controllerfuse_ignore_room_ownerfuse_pick_up_any_furnifuse_alertfuse_receive_calls_for_helpfuse_room_kickfuse_administrator_accessfuse_remove_stickiesfuse_enter_locked_roomsfuse_superbanfuse_kickfuse_habbo_chooserfuse_furni_chooserfuse_enter_full_roomsfuse_room_mutefuse_modfuse_banfuse_mutefuse_see_flat_idsdefaultpockethabbo_content_download_allowedfuse_logindefaultpockethabbo_messenger_allowedfuse_use_special_room_layoutsfuse_room_queue_defaultfuse_buy_creditsfuse_extended_buddylistfuse_priority_accessfuse_trade', '0', '0', '0', '0', '0', '0', '0');
INSERT INTO `ranks` VALUES ('3', 'pockethabbo_content_download_allowedfuse_logindefaultpockethabbo_messenger_allowedfuse_room_queue_defaultfuse_buy_creditsfuse_extended_buddylistfuse_priority_accessfuse_trade', '0', '0', '1', '0', '0', '0', '0');
INSERT INTO `ranks` VALUES ('4', 'fuse_room_queue_defaultfuse_tradefuse_buy_creditsfuse_loginfuse_ignore_room_ownerfuse_enter_locked_roomsfuse_habbo_chooserfuse_furni_chooserfuse_enter_full_roomsfuse_kickdefaultfuse_moderator_access', '0', '1', '1', '1', '0', '0', '0');
INSERT INTO `ranks` VALUES ('5', 'fuse_room_queue_defaultfuse_tradefuse_buy_creditsfuse_loginfuse_receive_calls_for_helpfuse_moderator_accessfuse_room_alertfuse_any_room_controllerfuse_ignore_room_ownerfuse_pick_up_any_furnifuse_alertfuse_receive_calls_for_helpfuse_room_kickfuse_administrator_accessfuse_remove_stickiesfuse_enter_locked_roomsfuse_superbanfuse_kickfuse_habbo_chooserfuse_furni_chooserfuse_enter_full_roomsfuse_room_mutefuse_modfuse_banfuse_mutefuse_see_flat_idsdefault', '1', '1', '1', '1', '1', '1', '1');
INSERT INTO `ranks` VALUES ('6', 'fuse_room_queue_defaultfuse_tradefuse_buy_creditsfuse_loginfuse_receive_calls_for_helpfuse_moderator_accessfuse_room_alertfuse_any_room_controllerfuse_ignore_room_ownerfuse_pick_up_any_furnifuse_alertfuse_receive_calls_for_helpfuse_room_kickfuse_administrator_accessfuse_remove_stickiesfuse_enter_locked_roomsfuse_superbanfuse_kickfuse_habbo_chooserfuse_furni_chooserfuse_enter_full_roomsfuse_room_mutefuse_modfuse_banfuse_mutefuse_see_flat_idsdefaultpockethabbo_content_download_allowedfuse_logindefaultpockethabbo_messenger_allowedfuse_use_special_room_layoutsfuse_room_queue_defaultfuse_buy_creditsfuse_extended_buddylistfuse_priority_accessfuse_trade', '1', '1', '1', '1', '1', '1', '1');
INSERT INTO `system` VALUES ('1', '0', '0', '0', 'fuck,bastard,cunt,dick,pussy,buttsecks,aaron,sapphire,otaku,otaku lite,otaku-studios', 'bobba', 'admin,adm,staff,owner,mod-,m0d-', 'DgX~Cshelves_norj\r\naX~Dshelves_polyf\r\nonYmAshelves_silo\r\nXQHtable_polyfon_s\r\nmallYmAchair_polyf\r\nonZbBtable_norja_\r\nmedY_Itable_silo_m\r\nedX~Dtable_plasto\r\n_4legY_Itable_plast\r\no_roundY_Itable_pl\r\nasto_bigsquareY_Is\r\ntand_polyfon_zZbB\r\nchair_siloX~Dsofa_\r\nsiloX~Dcouch_norj\r\naX~Dchair_norjaX\r\n~Dtable_polyfon_me\r\ndYmAdoormat_love\r\nZbBdoormat_plainY\r\nmAsofachair_polyfon\r\nX~Dsofa_polyfonX\r\n~Dsofachair_siloX~\r\nDchair_plastyX~Dc\r\nhair_plastoYmAtabl\r\ne_plasto_squareY_I\r\nbed_polyfonX~Dbe\r\nd_polyfon_oneX~D\r\nbed_trad_oneYmAb\r\ned_tradYmAbed_sil\r\no_oneYmAbed_silo\r\n_twoYmAtable_silo_\r\nsmallX~Dbed_arma\r\ns_twoYmAbed_bud\r\nget_oneXQHbed_b\r\nudgetXQHshelves_\r\narmasYmAbench_ar\r\nmasYmAtable_arma\r\nsYmAsmall_table_ar\r\nmasZbBsmall_chair\r\n_armasYmAfireplac\r\ne_armasYmAlamp_\r\narmasYmAbed_arm\r\nas_oneYmAcarpet_\r\nstandardY_Icarpet_\r\narmasYmAcarpet_p\r\nolarY_Ifireplace_pol\r\nyfonY_Itable_plasto\r\n_4leg*1Y_Itable_pla\r\nsto_bigsquare*1Y_It\r\nable_plasto_round*1\r\nY_Itable_plasto_sq\r\nuare*1Y_Ichair_plas\r\nto*1YmAcarpet_sta\r\nndard*1Y_Idoormat\r\n_plain*1YmAtable_p\r\nlasto_4leg*2Y_Itabl\r\ne_plasto_bigsquare*\r\n2Y\r\n_Itable_plasto_roun\r\nd*2Y_Itable_plasto_\r\nsquare*2Y_Ichair_pl\r\nasto*2YmAdoormat\r\n_plain*2YmAcarpet\r\n_standard*2Y_Itabl\r\ne_plasto_4leg*3Y_It\r\nable_plasto_bigsqua\r\nre*3Y_Itable_plasto\r\n_round*3Y_Itable_p\r\nlasto_square*3Y_Ic\r\nhair_plasto*3YmAca\r\nrpet_standard*3Y_I\r\ndoormat_plain*3Ym\r\nAtable_plasto_4leg*\r\n4Y_Itable_plasto_bi\r\ngsquare*4Y_Itable_\r\nplasto_round*4Y_It\r\nable_plasto_square*\r\n4Y_Ichair_plasto*4\r\nYmAcarpet_standar\r\nd*4Y_Idoormat_plai\r\nn*4YmAdoormat_pl\r\nain*6YmAdoormat_\r\nplain*5YmAcarpet_s\r\ntandard*5Y_Itable_\r\nplasto_4leg*5Y_Itab\r\nle_plasto_bigsquare*\r\n5Y_Itable_plasto_ro\r\nund*5Y_Itable_plast\r\no_square*5Y_Ichair\r\n_plasto*5YmAtable_\r\nplasto_4leg*6Y_Itab\r\nle_plasto_bigsquare*\r\n6Y_Itable_plasto_ro\r\nund*6Y_Itable_plast\r\no_square*6Y_Ichair\r\n_plasto*6YmAtable_\r\nplasto_4leg*7Y_Itab\r\nle_plasto_bigsquare*\r\n7Y_Itable_plasto_ro\r\nund*7Y_Itable_plast\r\no_square*7Y_Ichair\r\n_plasto*7YmAtable_\r\nplasto_4leg*8Y_Itab\r\nle_plasto_bigsquare*\r\n8Y_Itable_plasto_ro\r\nund*8Y_Itable_plast\r\no_square*8Y_Ichair\r\n_plasto*8YmAtable_\r\nplasto_4leg*9Y_Itab\r\nle_plasto_bigsquare*\r\n9Y_Itable_plasto_ro\r\nun\r\nd*9Y_Itable_plasto_\r\nsquare*9Y_Ichair_pl\r\nasto*9YmAcarpet_s\r\ntandard*6Y_Ichair_\r\nplasty*1X~DpizzaY\r\nmAdrinksYmAchair_\r\nplasty*2X~Dchair_p\r\nlasty*3X~Dchair_pl\r\nasty*4X~Dbar_polyf\r\nonY_Iplant_cruddy\r\nYmAbottleYmAbard\r\nesk_polyfonX~Dbar\r\ndeskcorner_polyfon\r\nX~DfloortileHbar_ar\r\nmasY_Ibartable_ar\r\nmasYmAbar_chair_\r\narmasYmAcarpet_s\r\noftY_Icarpet_soft*1\r\nY_Icarpet_soft*2Y_I\r\ncarpet_soft*3Y_Icar\r\npet_soft*4Y_Icarpet\r\n_soft*5Y_Icarpet_s\r\noft*6Y_Ired_tvY_Iw\r\nood_tvYmAcarpet_\r\npolar*1Y_Ichair_pla\r\nsty*5X~Dcarpet_pol\r\nar*2Y_Icarpet_polar\r\n*3Y_Icarpet_polar*4\r\nY_Ichair_plasty*6X\r\n~Dtable_polyfonYm\r\nAsmooth_table_polyf\r\nonYmAsofachair_po\r\nlyfon_girlX~Dbed_p\r\nolyfon_girl_oneX~D\r\nbed_polyfon_girlX~\r\nDsofa_polyfon_girlX\r\n~Dbed_budgetb_on\r\neXQHbed_budgetb\r\nXQHplant_pineapple\r\nYmAplant_fruittree\r\nY_Iplant_small_cact\r\nusY_Iplant_bonsai\r\nY_Iplant_big_cactus\r\nY_Iplant_yukkaY_I\r\ncarpet_standard*7Y\r\n_Icarpet_standard*8\r\nY_Icarpet_standard\r\n*9Y_Icarpet_standa\r\nrd*aY_Icarpet_stan\r\ndard*bY_Iplant_sun\r\nflowerY_Iplant_rose\r\nY_Itv_luxusY_Ibath\r\nZBsinkY_ItoiletY\r\nmAduckYmAtileYm\r\nAt\r\noilet_redYmAtoilet_y\r\nellYmAtile_redYmAt\r\nile_yellYmAprize1Y\r\nmAprize2YmAprese\r\nnt_genZvCpresent_\r\ngen1ZvCpresent_g\r\nen2ZvCpresent_ge\r\nn3ZvCpresent_gen\r\n4ZvCpresent_gen5\r\nZvCpresent_gen6Z\r\nvCbar_basicY_Ishel\r\nves_basicXQHsoft_\r\nsofachair_norjaX~D\r\nsoft_sofa_norjaX~D\r\nlamp_basicXQHlam\r\np2_armasYmAfridge\r\nY_IdoorHdoorBHd\r\noorCHpumpkinYmA\r\nskullcandleYmAdea\r\ndduckYmAdeadduc\r\nk2YmAdeadduck3\r\nYmAmenorahYmAp\r\nuddingYmAhamYm\r\nAturkeyYmAxmasdu\r\nckY_IhouseYmAtri\r\nplecandleYmAtree3\r\nYmAtree4YmAtree5\r\nX~Dham2YmAwca\r\nndlesetYmArcandle\r\nsetYmAstatueYmA\r\nheartY_IvaleduckY\r\nmAheartsofaX~Dthr\r\noneYmAsamovarY\r\n_IgiftflowersY_Ihab\r\nbocakeYmAhologra\r\nmYmAeasterduckY\r\n_IbunnyYmAbasket\r\nY_IbirdieYmAedice\r\nX~Dprize3YmAdivid\r\ner_poly3X~Ddivider\r\n_arm1YmAdivider_a\r\nrm2YmAdivider_arm\r\n3YmAdivider_nor1\r\nX~Ddivider_silo1X~\r\nDdivider_nor2X~Dd\r\nivider_silo2YmAdivi\r\nder_nor3X~Ddivider\r\n_silo3X~Dtypingma\r\nchineYmAspyroYm\r\nAredhologramYmAc\r\nameraHjoulutahtiY\r\nmAhyacinth1YmAhy\r\nacinth2YmAclub_so\r\nfaX~Dchair_plasto*\r\n10YmAchair_plasto*\r\n11YmAbardeskcorn\r\ner_polyfon*12X~Db\r\nardes\r\nkcorner_polyfon*13\r\nX~Dchair_plasto*12\r\nYmAchair_plasto*13\r\nYmAchair_plasto*14\r\nYmAtable_plasto_4l\r\neg*14Y_Imoccham\r\nasterY_Icarpet_lego\r\ncourtYmAbench_le\r\ngoYmAlegotrophyY\r\nmAvalentinescreen\r\nYmAedicehcYmArar\r\ne_daffodil_rugYmAr\r\nare_beehive_bulbY\r\n_IhcsohvaYmAhca\r\nmmeYmArare_paras\r\nolY_Irare_elephant_\r\nstatueYmArare_fou\r\nntainY_Irare_stand\r\nYmArare_globeYmA\r\nrare_hammockYmAr\r\nare_elephant_statue\r\n*1YmArare_elephan\r\nt_statue*2YmArare_\r\nfountain*1Y_Irare_f\r\nountain*2Y_Irare_fo\r\nuntain*3Y_Irare_be\r\nehive_bulb*1Y_Irar\r\ne_beehive_bulb*2Y\r\n_Irare_xmas_screen\r\nY_Irare_parasol*1Y\r\n_Irare_parasol*2Y_I\r\nrare_parasol*3Y_Iso\r\nft_jaggara_norjaYm\r\nAhouse2YmAdjesko\r\n_turntableYmAHmd\r\n_sofaYmAmd_limuk\r\naappiY_Itable_plast\r\no_4leg*10Y_Itable_\r\nplasto_4leg*15Y_Ita\r\nble_plasto_bigsquar\r\ne*14Y_Itable_plasto\r\n_bigsquare*15Y_Ita\r\nble_plasto_round*14\r\nY_Itable_plasto_rou\r\nnd*15Y_Itable_plast\r\no_square*14Y_Itabl\r\ne_plasto_square*15\r\nY_Ichair_plasto*15\r\nYmAchair_plasty*7X\r\n~Dchair_plasty*8X~\r\nDchair_plasty*9X~\r\nDchair_plasty*10X~\r\nDchair_plasty*11X~\r\nDchair_plasto*16Y\r\nmAtable_plasto_4\r\nleg*16Y_Ihockey_s\r\ncoreY_Ihockey_ligh\r\ntYmAdoorDHprizetr\r\nophy2*3Y_Iprizetrop\r\nhy3*3Y_Iprizetrophy\r\n4*3Y_Iprizetrophy5*\r\n3Y_Iprizetrophy6*3\r\nY_Iprizetrophy7*3Y\r\n_Iprizetrophy*1Y_Ipr\r\nizetrophy2*1Y_Ipriz\r\netrophy3*1Y_Iprizetr\r\nophy4*1Y_Iprizetrop\r\nhy5*1Y_Iprizetrophy\r\n6*1Y_Iprizetrophy7*\r\n1Y_Iprizetrophy*2Y\r\n_Iprizetrophy2*2Y_I\r\nprizetrophy3*2Y_Ipri\r\nzetrophy4*2Y_Iprize\r\ntrophy5*2Y_Iprizetro\r\nphy6*2Y_Iprizetroph\r\ny7*2Y_Iprizetrophy*\r\n3Y_Ihc_chrYmAhc\r\n_tblYmAhc_lmp[fBh\r\nc_dskXQHnestHpe\r\ntfood1ZvCpetfood2\r\nZvCpetfood3ZvCw\r\naterbowl*4XICwater\r\nbowl*5XICwaterbow\r\nl*2XICwaterbowl*1\r\nXICwaterbowl*3XICt\r\noy1XICtoy1*1XICto\r\ny1*2XICtoy1*3XICt\r\noy1*4XICgoodie1Z\r\nvCgoodie1*1ZvCgo\r\nodie1*2ZvCgoodie2\r\nX~Dscifiport*0Y_Is\r\ncifiport*9Y_Iscifiport\r\n*8Y_Iscifiport*7Y_I\r\nscifiport*6Y_Iscifipor\r\nt*5Y_Iscifiport*4Y_I\r\nscifiport*3Y_Iscifipor\r\nt*2Y_Iscifiport*1Y_I\r\nscifirocket*9Y_Iscifir\r\nocket*8Y_Iscifirock\r\net*7Y_Iscifirocket*6\r\nY_Iscifirocket*5Y_I\r\nscifirocket*4Y_Iscifir\r\nocket*3Y_Iscifirock\r\net*2Y_Iscifirocket*1\r\nY_Iscifirocket*0Y_I\r\nscifidoor*10Y_Iscifid\r\noor*9\r\nY_Iscifidoor*8Y_Isc\r\nifidoor*7Y_Iscifidoor\r\n*6Y_Iscifidoor*5Y_I\r\nscifidoor*4Y_Iscifido\r\nor*3Y_Iscifidoor*2Y\r\n_Iscifidoor*1Y_Ipillo\r\nw*5YmApillow*8Ym\r\nApillow*0YmApillow*\r\n1YmApillow*2YmAp\r\nillow*7YmApillow*9\r\nYmApillow*4YmApill\r\now*6YmApillow*3Y\r\nmAmarquee*1Y_Im\r\narquee*2Y_Imarque\r\ne*7Y_Imarquee*aY\r\n_Imarquee*8Y_Imar\r\nquee*9Y_Imarquee*\r\n5Y_Imarquee*4Y_I\r\nmarquee*6Y_Imarq\r\nuee*3Y_Iwooden_s\r\ncreen*1Y_Iwooden\r\n_screen*2Y_Iwood\r\nen_screen*7Y_Iwo\r\noden_screen*0Y_I\r\nwooden_screen*8Y\r\n_Iwooden_screen*5\r\nY_Iwooden_screen*\r\n9Y_Iwooden_scree\r\nn*4Y_Iwooden_scr\r\neen*6Y_Iwooden_s\r\ncreen*3Y_Ipillar*6Y\r\n_Ipillar*1Y_Ipillar*9\r\nY_Ipillar*0Y_Ipillar*8\r\nY_Ipillar*2Y_Ipillar*\r\n5Y_Ipillar*4Y_Ipillar\r\n*7Y_Ipillar*3Y_Irare\r\n_dragonlamp*4Y_Ir\r\nare_dragonlamp*0Y\r\n_Irare_dragonlamp*5\r\nY_Irare_dragonlamp\r\n*2Y_Irare_dragonla\r\nmp*8Y_Irare_drago\r\nnlamp*9Y_Irare_dra\r\ngonlamp*7Y_Irare_\r\ndragonlamp*6Y_Irar\r\ne_dragonlamp*1Y_I\r\nrare_dragonlamp*3\r\nY_Irare_icecream*1\r\nY_Irare_icecream*7\r\nY_Irare_icecream*8\r\nY_Irare_icecream*2\r\nY_Irare_icecream*6\r\nY_Irare_icecream*9\r\nY_Irare_icecream*3\r\nY_Irare_icecream*0\r\nY_Irare_icecream*4\r\nY_Irare_icecream*5\r\nY_Irare_fan*7YxBra\r\nre_fan*6YxBrare_fa\r\nn*9YxBrare_fan*3Y\r\nxBrare_fan*0YxBrar\r\ne_fan*4YxBrare_fan\r\n*5YxBrare_fan*1Yx\r\nBrare_fan*8YxBrare\r\n_fan*2YxBqueue_til\r\ne1*3X~Dqueue_tile\r\n1*6X~Dqueue_tile1\r\n*4X~Dqueue_tile1*\r\n9X~Dqueue_tile1*8\r\nX~Dqueue_tile1*5\r\nX~Dqueue_tile1*7X\r\n~Dqueue_tile1*2X~\r\nDqueue_tile1*1X~D\r\nqueue_tile1*0X~Dti\r\ncketHrare_snowrug\r\nX~Dcn_lampZrHcn\r\n_sofaYmAsporttrack\r\n1*1YmAsporttrack1*\r\n3YmAsporttrack1*2\r\nYmAsporttrack2*1Y\r\nmAsporttrack2*2Ym\r\nAsporttrack2*3YmA\r\nsporttrack3*1YmAs\r\nporttrack3*2YmAsp\r\norttrack3*3YmAfoot\r\nylampX~Dbarchair_\r\nsiloX~Ddivider_nor4\r\n*4X~Dtraffic_light*1\r\nY_Itraffic_light*2Y_\r\nItraffic_light*3Y_Itraf\r\nfic_light*4Y_Itraffic_\r\nlight*6Y_Irubberchai\r\nr*1X~Drubberchair*\r\n2X~Drubberchair*3\r\nX~Drubberchair*4X\r\n~Drubberchair*5X~\r\nDrubberchair*6X~D\r\nbarrier*1X~Dbarrier*\r\n2X~Dbarrier*3X~Dr\r\nubberchair*7X~Dru\r\nbberchair*8X~Dtabl\r\ne_norja_med*2Y_It\r\nable_norja_med*3Y\r\n_Itable_norja_med*4\r\nY_Itable_norja_med\r\n*5Y_Itable_norja_m\r\ned*6Y_Itable_norja\r\n_med*7Y_Itable_no\r\nrja\r\n_med*8Y_Itable_no\r\nrja_med*9Y_Icouch\r\n_norja*2X~Dcouch\r\n_norja*3X~Dcouch\r\n_norja*4X~Dcouch\r\n_norja*5X~Dcouch\r\n_norja*6X~Dcouch\r\n_norja*7X~Dcouch\r\n_norja*8X~Dcouch\r\n_norja*9X~Dshelve\r\ns_norja*2X~Dshelv\r\nes_norja*3X~Dshel\r\nves_norja*4X~Dshe\r\nlves_norja*5X~Dsh\r\nelves_norja*6X~Ds\r\nhelves_norja*7X~D\r\nshelves_norja*8X~\r\nDshelves_norja*9X\r\n~Dchair_norja*2X~\r\nDchair_norja*3X~D\r\nchair_norja*4X~Dc\r\nhair_norja*5X~Dch\r\nair_norja*6X~Dchair\r\n_norja*7X~Dchair_\r\nnorja*8X~Dchair_n\r\norja*9X~Ddivider_n\r\nor1*2X~Ddivider_n\r\nor1*3X~Ddivider_n\r\nor1*4X~Ddivider_n\r\nor1*5X~Ddivider_n\r\nor1*6X~Ddivider_n\r\nor1*7X~Ddivider_n\r\nor1*8X~Ddivider_n\r\nor1*9X~Dsoft_sofa\r\n_norja*2X~Dsoft_so\r\nfa_norja*3X~Dsoft_\r\nsofa_norja*4X~Dsof\r\nt_sofa_norja*5X~Ds\r\noft_sofa_norja*6X~\r\nDsoft_sofa_norja*7\r\nX~Dsoft_sofa_norja*\r\n8X~Dsoft_sofa_norj\r\na*9X~Dsoft_sofach\r\nair_norja*2X~Dsoft_\r\nsofachair_norja*3X\r\n~Dsoft_sofachair_n\r\norja*4X~Dsoft_sofa\r\nchair_norja*5X~Dso\r\nft_sofachair_norja*6\r\nX~Dsoft_sofachair_\r\nnorja*7X~Dsoft_sof\r\nachair_norja*8X~Ds\r\noft_sofachair_norja*\r\n9X~Dsofachair_silo\r\n*2X~Dsofachair_sil\r\no*3X~Dsofachair\r\n_silo*4X~Dsofachai\r\nr_silo*5X~Dsofacha\r\nir_silo*6X~Dsofach\r\nair_silo*7X~Dsofac\r\nhair_silo*8X~Dsofa\r\nchair_silo*9X~Dtabl\r\ne_silo_small*2X~Dt\r\nable_silo_small*3X~\r\nDtable_silo_small*4\r\nX~Dtable_silo_small\r\n*5X~Dtable_silo_sm\r\nall*6X~Dtable_silo_\r\nsmall*7X~Dtable_sil\r\no_small*8X~Dtable\r\n_silo_small*9X~Ddi\r\nvider_silo1*2X~Ddi\r\nvider_silo1*3X~Ddi\r\nvider_silo1*4X~Ddi\r\nvider_silo1*5X~Ddi\r\nvider_silo1*6X~Ddi\r\nvider_silo1*7X~Ddi\r\nvider_silo1*8X~Ddi\r\nvider_silo1*9X~Ddi\r\nvider_silo3*2X~Ddi\r\nvider_silo3*3X~Ddi\r\nvider_silo3*4X~Ddi\r\nvider_silo3*5X~Ddi\r\nvider_silo3*6X~Ddi\r\nvider_silo3*7X~Ddi\r\nvider_silo3*8X~Ddi\r\nvider_silo3*9X~Dta\r\nble_silo_med*2X~D\r\ntable_silo_med*3X~\r\nDtable_silo_med*4X\r\n~Dtable_silo_med*5\r\nX~Dtable_silo_med*\r\n6X~Dtable_silo_me\r\nd*7X~Dtable_silo_\r\nmed*8X~Dtable_sil\r\no_med*9X~Dsofa_s\r\nilo*2X~Dsofa_silo*3\r\nX~Dsofa_silo*4X~\r\nDsofa_silo*5X~Dsof\r\na_silo*6X~Dsofa_sil\r\no*7X~Dsofa_silo*8\r\nX~Dsofa_silo*9X~D\r\nsofachair_polyfon*2\r\nX~Dsofachair_polyf\r\non*3X~Dsofachair_\r\npolyfon*4X~Dsofac\r\nhair_polyfon*6X~Ds\r\nofachair_polyfon*7X\r\n~Dsofachair_polyfon\r\n*8X~Dsofachair_pol\r\nyf\r\non*9X~Dsofa_polyf\r\non*2X~Dsofa_polyf\r\non*3X~Dsofa_polyf\r\non*4X~Dsofa_polyf\r\non*6X~Dsofa_polyf\r\non*7X~Dsofa_polyf\r\non*8X~Dsofa_polyf\r\non*9X~Dbed_polyf\r\non*2X~Dbed_polyf\r\non*3X~Dbed_polyf\r\non*4X~Dbed_polyf\r\non*6X~Dbed_polyf\r\non*7X~Dbed_polyf\r\non*8X~Dbed_polyf\r\non*9X~Dbed_polyf\r\non_one*2X~Dbed_\r\npolyfon_one*3X~D\r\nbed_polyfon_one*4\r\nX~Dbed_polyfon_on\r\ne*6X~Dbed_polyfo\r\nn_one*7X~Dbed_p\r\nolyfon_one*8X~Db\r\ned_polyfon_one*9X\r\n~Dbardesk_polyfon*\r\n2X~Dbardesk_polyf\r\non*3X~Dbardesk_p\r\nolyfon*4X~Dbardes\r\nk_polyfon*5X~Dbar\r\ndesk_polyfon*6X~D\r\nbardesk_polyfon*7X\r\n~Dbardesk_polyfon*\r\n8X~Dbardesk_polyf\r\non*9X~Dbardeskco\r\nrner_polyfon*2X~D\r\nbardeskcorner_polyf\r\non*3X~Dbardeskco\r\nrner_polyfon*4X~D\r\nbardeskcorner_polyf\r\non*5X~Dbardeskco\r\nrner_polyfon*6X~D\r\nbardeskcorner_polyf\r\non*7X~Dbardeskco\r\nrner_polyfon*8X~D\r\nbardeskcorner_polyf\r\non*9X~Ddivider_pol\r\ny3*2X~Ddivider_pol\r\ny3*3X~Ddivider_pol\r\ny3*4X~Ddivider_pol\r\ny3*5X~Ddivider_pol\r\ny3*6X~Ddivider_pol\r\ny3*7X~Ddivider_pol\r\ny3*8X~Ddivider_pol\r\ny3*9X~Dchair_silo*\r\n2X~Dchair_silo*3X\r\n~Dchair_silo*4X~D\r\nchair_silo*5X~Dcha\r\nir_silo*6X~Dchair_si\r\nlo*7X~Dchair_silo*8\r\nX~Dchair_silo*9X~\r\nDdivider_nor3*2X~\r\nDdivider_nor3*3X~\r\nDdivider_nor3*4X~\r\nDdivider_nor3*5X~\r\nDdivider_nor3*6X~\r\nDdivider_nor3*7X~\r\nDdivider_nor3*8X~\r\nDdivider_nor3*9X~\r\nDdivider_nor2*2X~\r\nDdivider_nor2*3X~\r\nDdivider_nor2*4X~\r\nDdivider_nor2*5X~\r\nDdivider_nor2*6X~\r\nDdivider_nor2*7X~\r\nDdivider_nor2*8X~\r\nDdivider_nor2*9X~\r\nDsilo_studydeskX~\r\nDsolarium_norjaY_I\r\nsolarium_norja*1Y_I\r\nsolarium_norja*2Y_I\r\nsolarium_norja*3Y_I\r\nsolarium_norja*5Y_I\r\nsolarium_norja*6Y_I\r\nsolarium_norja*7Y_I\r\nsolarium_norja*8Y_I\r\nsolarium_norja*9Y_I\r\nsandrugX~Drare_m\r\noonrugYmAchair_c\r\nhinaYmAchina_tabl\r\neYmAsleepingbag*1\r\nYmAsleepingbag*2\r\nYmAsleepingbag*3\r\nYmAsleepingbag*4\r\nYmAsafe_siloY_Isle\r\nepingbag*7YmAslee\r\npingbag*9YmAsleep\r\ningbag*5YmAsleepi\r\nngbag*10YmAsleepi\r\nngbag*6YmAsleepin\r\ngbag*8YmAchina_s\r\nhelveX~Dtraffic_lig\r\nht*5Y_Idivider_nor4\r\n*2X~Ddivider_nor4*\r\n3X~Ddivider_nor4*\r\n5X~Ddivider_nor4*\r\n6X~Ddivider_nor4*\r\n7X~Ddivider_nor4*\r\n8X~Ddivider_nor4*\r\n9X~Ddivider_nor5*\r\n2X~Ddivider_nor5*\r\n3X~Ddivider_nor5*\r\n4X~Ddivider_nor5*\r\n5X~Ddivider_nor5*\r\n6X~Ddivider_\r\nnor5*7X~Ddivider_\r\nnor5*8X~Ddivider_\r\nnor5*9X~Ddivider_\r\nnor5X~Ddivider_nor\r\n4X~Dwall_chinaY\r\nmAcorner_chinaYm\r\nAbarchair_silo*2X~\r\nDbarchair_silo*3X~\r\nDbarchair_silo*4X~\r\nDbarchair_silo*5X~\r\nDbarchair_silo*6X~\r\nDbarchair_silo*7X~\r\nDbarchair_silo*8X~\r\nDbarchair_silo*9X~\r\nDsafe_silo*2Y_Isafe\r\n_silo*3Y_Isafe_silo*\r\n4Y_Isafe_silo*5Y_I\r\nsafe_silo*6Y_Isafe_\r\nsilo*7Y_Isafe_silo*8\r\nY_Isafe_silo*9Y_Igl\r\nass_shelfY_Iglass_\r\nchairY_Iglass_stool\r\nY_Iglass_sofaY_Igl\r\nass_tableY_Iglass_t\r\nable*2Y_Iglass_tabl\r\ne*3Y_Iglass_table*4\r\nY_Iglass_table*5Y_\r\nIglass_table*6Y_Igl\r\nass_table*7Y_Iglass\r\n_table*8Y_Iglass_ta\r\nble*9Y_Iglass_chair\r\n*2Y_Iglass_chair*3\r\nY_Iglass_chair*4Y_I\r\nglass_chair*5Y_Igla\r\nss_chair*6Y_Iglass_\r\nchair*7Y_Iglass_ch\r\nair*8Y_Iglass_chair*\r\n9Y_Iglass_sofa*2Y\r\n_Iglass_sofa*3Y_Igl\r\nass_sofa*4Y_Iglass\r\n_sofa*5Y_Iglass_so\r\nfa*6Y_Iglass_sofa*7\r\nY_Iglass_sofa*8Y_I\r\nglass_sofa*9Y_Iglas\r\ns_stool*2Y_Iglass_s\r\ntool*4Y_Iglass_stool\r\n*5Y_Iglass_stool*6\r\nY_Iglass_stool*7Y_I\r\nglass_stool*8Y_Itre\r\ne1X~DwcandleYx\r\nBglass_stool*3Y_Igl\r\nass_stool*9Y_ICFC\r\n_100_coin_g\r\noldZvCCFC_10_coi\r\nn_bronzeZvCCFC_\r\n200_moneybagZvC\r\nCFC_500_goldbarZ\r\nvCCFC_50_coin_silv\r\nerZvCCF_10_coin_\r\ngoldZvCCF_1_coin\r\n_bronzeZvCCF_20_\r\nmoneybagZvCCF_5\r\n0_goldbarZvCCF_5\r\n_coin_silverZvChc_\r\ncrptYmAhc_tvZBg\r\nothgateX~Dgothicc\r\nandelabraYxBgothr\r\nailingX~Dgoth_tabl\r\neYmAhc_bkshlfYm\r\nAhc_btlrY_Ihc_crtn\r\nYmAhc_djsetYmAh\r\nc_frplcZbBhc_lmpst\r\nYmAhc_machineY\r\nmAhc_rllrXQHhc_rn\r\ntgnX~Dhc_trllYmA\r\ngothic_chair*1X~D\r\ngothic_sofa*1X~Dg\r\nothic_stool*1X~Dgo\r\nthic_chair*2X~Dgot\r\nhic_sofa*2X~Dgothi\r\nc_stool*2X~Dgothic\r\n_chair*3X~Dgothic\r\n_sofa*3X~Dgothic_\r\nstool*3X~Dgothic_c\r\nhair*4X~Dgothic_so\r\nfa*4X~Dgothic_sto\r\nol*4X~Dgothic_chai\r\nr*5X~Dgothic_sofa*\r\n5X~Dgothic_stool*5\r\nX~Dgothic_chair*6\r\nX~Dgothic_sofa*6X\r\n~Dgothic_stool*6X\r\n~Dtree2ZmBsound\r\n_machineYVDroma\r\nntique_pianochair*3\r\nY_Iromantique_pian\r\nochair*5Y_Iromantiq\r\nue_pianochair*2Y_I\r\nromantique_pianoch\r\nair*4Y_Iromantique_\r\npianochair*1Y_Irom\r\nantique_divan*3Y_I\r\nromantique_divan*5\r\nY_Iromantique_diva\r\nn*2Y_Iromantique_\r\ndivan*4Y_Iromantiq\r\nue_divan*1Y_Iroma\r\nntique_chair*3Y_Iro\r\nmantique_chair*5Y_\r\nIromanti\r\nque_chair*2Y_Irom\r\nantique_chair*4Y_Ir\r\nomantique_chair*1Y\r\n_IrcandleYxBplant_\r\nvalentinerose*3XIC\r\nplant_valentinerose*\r\n5XICplant_valentine\r\nrose*2XICplant_val\r\nentinerose*4XICpla\r\nnt_valentinerose*1X\r\nICplant_mazegateY\r\neCplant_mazeZcCpl\r\nant_bulrushXICpetf\r\nood4Y_Icarpet_val\r\nentineZ|Egothic_car\r\npetXICgothic_carpe\r\nt2Z|Egothic_chairX\r\n~Dgothic_sofaX~D\r\ngothic_stoolX~Dgra\r\nnd_piano*3Z|Egran\r\nd_piano*5Z|Egrand\r\n_piano*2Z|Egrand_\r\npiano*4Z|Egrand_pi\r\nano*1Z|Esound_set\r\n_1Y_Isound_set_2\r\nY_Isound_set_3Y_I\r\nsound_set_4Y_Isou\r\nnd_set_5Y_Isound_\r\nset_6Y_Isound_set\r\n_7Y_Isound_set_8\r\nY_Isound_set_9Y_I\r\nsound_machine*1Y\r\nGGval_cauldronX~\r\nDsound_machine*2\r\nYGGsound_machine\r\n*3YGGsound_mach\r\nine*4YGGsound_m\r\nachine*5YGGsound\r\n_machine*6YGGso\r\nund_machine*7YG\r\nGromantique_tray2\r\nY_Iromantique_tray1\r\nY_Iromantique_smal\r\nltabl*1Y_Iromantiqu\r\ne_smalltabl*2Y_Irom\r\nantique_smalltabl*3\r\nY_Iromantique_small\r\ntabl*4Y_Iromantique\r\n_smalltabl*5Y_Iroma\r\nntique_mirrortablY_I\r\nromantique_divider*\r\n1Y_Iromantique_div\r\nider*2Y_Iromantique\r\n_divider*3Y_Iromant\r\nique_divider*4Y_Iro\r\nm_la\r\nmpZ|Erclr_sofaXQ\r\nHrclr_gardenXQHrcl\r\nr_chairZ|Ehabbowo\r\nod_chairYGGtheatr\r\ne_seatYGGspotlight\r\nY_Ijp_tatami2YGGj\r\np_tatamiYGGjp_ba\r\nmbooYGGjp_iroriX\r\nQHjp_pillowYGGso\r\nund_set_28Y_Isoun\r\nd_set_27Y_Isound_\r\nset_26Y_Isound_se\r\nt_25Y_Isound_set_\r\n24Y_Isound_set_23\r\nY_Isound_set_22Y\r\n_Isound_set_21Y_I\r\nsound_set_20Y_Iso\r\nund_set_19Y_Isoun\r\nd_set_18Y_Isound_\r\nset_17Y_Isound_se\r\nt_16Y_Isound_set_\r\n15Y_Isound_set_14\r\nY_Isound_set_13Y\r\n_Isound_set_12Y_I\r\nsound_set_11Y_Iso\r\nund_set_10Y_Irope\r\n_dividerXQHromanti\r\nque_clockY_Irare_i\r\ncecream_campaign\r\nY_Ipura_mdl5*1XQ\r\nHpura_mdl5*2XQH\r\npura_mdl5*3XQHpu\r\nra_mdl5*4XQHpura\r\n_mdl5*5XQHpura_\r\nmdl5*6XQHpura_m\r\ndl5*7XQHpura_mdl\r\n5*8XQHpura_mdl5*\r\n9XQHpura_mdl4*1\r\nXQHpura_mdl4*2X\r\nQHpura_mdl4*3XQ\r\nHpura_mdl4*4XQH\r\npura_mdl4*5XQHpu\r\nra_mdl4*6XQHpura\r\n_mdl4*7XQHpura_\r\nmdl4*8XQHpura_m\r\ndl4*9XQHpura_mdl\r\n3*1XQHpura_mdl3*\r\n2XQHpura_mdl3*3\r\nXQHpura_mdl3*4X\r\nQHpura_mdl3*5XQ\r\nHpura_mdl3*6XQH\r\npura_mdl3*7XQHpu\r\nra_mdl3*8XQHpura\r\n_mdl3*9XQHpura_\r\nmdl2*1XQHpura_m\r\ndl2*2XQHpura_mdl\r\n2*3XQHpura_mdl2*\r\n4XQHpura_mdl2*5\r\nXQHpura_mdl2*6X\r\nQHpu\r\nra_mdl2*7XQHpura\r\n_mdl2*8XQHpura_\r\nmdl2*9XQHpura_m\r\ndl1*1XQHpura_mdl\r\n1*2XQHpura_mdl1*\r\n3XQHpura_mdl1*4\r\nXQHpura_mdl1*5X\r\nQHpura_mdl1*6XQ\r\nHpura_mdl1*7XQH\r\npura_mdl1*8XQHpu\r\nra_mdl1*9XQHjp_la\r\nnternXQHchair_basi\r\nc*1XQHchair_basic\r\n*2XQHchair_basic*\r\n3XQHchair_basic*4\r\nXQHchair_basic*5\r\nXQHchair_basic*6X\r\nQHchair_basic*7XQ\r\nHchair_basic*8XQH\r\nchair_basic*9XQHb\r\ned_budget*1XQHb\r\ned_budget*2XQHb\r\ned_budget*3XQHb\r\ned_budget*4XQHb\r\ned_budget*5XQHb\r\ned_budget*6XQHb\r\ned_budget*7XQHb\r\ned_budget*8XQHb\r\ned_budget*9XQHb\r\ned_budget_one*1X\r\nQHbed_budget_one\r\n*2XQHbed_budget\r\n_one*3XQHbed_bu\r\ndget_one*4XQHbe\r\nd_budget_one*5XQ\r\nHbed_budget_one*\r\n6XQHbed_budget_\r\none*7XQHbed_bud\r\nget_one*8XQHbed\r\n_budget_one*9XQ\r\nHjp_drawerXQHsou\r\nnd_machine_proYG\r\nGone_way_door*1X\r\nQHone_way_door*2\r\nXQHone_way_door\r\n*3XQHone_way_do\r\nor*4XQHone_way_\r\ndoor*5XQHone_wa\r\ny_door*6XQHone_\r\nway_door*7XQHon\r\ne_way_door*8XQH\r\none_way_door*9XQ\r\nHtile_stellaY_Itile_m\r\narbleY_Itile_brown\r\nY_Isummer_grill*1Y\r\n_Isummer_grill*2Y_I\r\nsummer_grill*3Y_Isu\r\nmmer_grill*4Y_Isum\r\nmer_chair*1Y_Isum\r\nmer_chair*2Y_Isum\r\nmer_\r\nchair*3Y_Isummer_\r\nchair*4Y_Isummer_\r\nchair*5Y_Isummer_\r\nchair*6Y_Isummer_\r\nchair*7Y_Isummer_\r\nchair*8Y_Isummer_\r\nchair*9Y_Isound_se\r\nt_36Y_Isound_set_\r\n35Y_Isound_set_34\r\nY_Isound_set_33Y\r\n_Isound_set_32Y_I\r\nsound_set_31Y_Iso\r\nund_set_30Y_Isoun\r\nd_set_29Y_Irare_m\r\nnstrY_Iexe_rugY_I\r\nexe_s_tableY_IRDp\r\nost.itHpost.it.vdHp\r\nhotoHChessHTicT\r\nacToeHBattleShip\r\nHPokerHwallpaper\r\nHfloorHposterYxBg\r\nothicfountainYxBhc\r\n_wall_lampZbBindu\r\nstrialfanZ`BtorchZ\r\nBval_heartXBCwall\r\nmirrorZ|Ejp_ninjastar\r\nsXQHhabw_mirrorX\r\nQH\r\n', ';Frontpage;Rollers;Rare;Spaces;Habbo Exchange;Club Furni;Club Furni 2;Teleporters;Pets;Pet Accessories;Area;Gothic;Grunge;Trax;Candy;Romantique;Recycler;Asian;Japanese;Habbowood;Iced;Lodge;Plastic;Pura;Mode;Accessories;Bathroom;Plants;Sports;Rugs;Gallery;Flags;Trophies;Trax;Offers;One Way Doors;', ';Rare Trophies;Japanese;Habbowood;Green Iced;Green Mode;Green Area;Blue Iced;Blue Mode;Blue Area;Red Iced;Red Mode;Red Area;Pink Iced;Pink Mode;Pink Area;Beige Mode;Beigh Iced;Beigh Area;White Mode;White Iced;White Area;Black Mode;Black Iced;Black Area;Limited Edition;Love;Easter;Halloween;Christmas;Club Furni;Club Shop;Ice Cream Machines;Summer Pools;Pillows;Oriental Screens;Pillars;Laser Gates;Guitars;Monoliths;Smoke Machines;Fans;Marquee;Rare Recolours;Rares;', 'Hey there %name%!<br>Welcome on board of this beta build of Holograph Emulator for Habbo Hotel!<br>Current build: %release%<br><br>Holograph Team');
INSERT INTO `users` VALUES ('1', 'Nillus', 'holotest', '6', 'nottelllingyou@hotmail.com', '26-03-1992', '12-01-2008', 'hd-180-1.ch-878-62.lg-270-64.sh-290-62.ea-1404-62', 'M', 'Holograph Emulator', 'Consolemission', '1000', '2', '/', '0,ADM', null, null, null);
